C     Last change:  VP    7 Jan 98    9:42 am
      subroutine dist
      include 'params.cmn'
      include 'basic.cmn'
      include 'atoms.cmn'
      include 'dist.cmn'
      include 'fepc.cmn'
      character*132 ven,venp,venpp
      character*80 radka,t80,attor(4),atplane(mxa)
      character*8 text(2),nazev
      dimension w(3),wg(3),dtw(3),daw(3),dbu(3),dbv(3),dcv(3),dcw(3),
     1          fm(3,20),sfm(3,20),isww(4),wt(mxa),idx(mxa),xtor(3,4),
     2          xplane(3,mxa),sxplane(3,mxa)
      logical iesd,ExistFile,opened
      equivalence (atplane,attor),(xplane,xtor)
      data text/'torsion','plane'/
      uloha='Calculating of distances, angles, torsion angles and '//
     1      'best planes'
      call DefaultDist
      if(ExistFile('dist.tmp')) call DeleteFile('dist.tmp')
      open(m40,file=fln(1:ifln)//'.m40')
      open(m50,file=fln(1:ifln)//'.m50')
      open(88,file=fln(1:ifln)//'.scr',form='unformatted')
      open(89,file='dist.tmp')
      write(89,'(''dist'')')
      open(lst,file=fln(1:ifln)//'.dis')
      call iom50(0,0)
      if(ErrJana.ne.0) return
      call NactiDist
      call iom50(0,1)
      call FeFillRectangle(XMinUnit+2.,XMaxUnit-40.,YMaxBottom,
     1                     YMaxUnit-14.,4,0,0,Black)
      call FeMoveMouseTo((XMinUnit+XMaxUnit)*.5,(YMinUnit+YMaxUnit)*.5)
      if(ndim.le.3) ittab=0
      if(nt(1).ne.0) then
        if(ncommen.le.0) then
          nt(1)=nt(1)+1
          do 1000i=1,ncomp
            if(i.ne.1) then
              nt(i)=nt(1)
              tzero(i)=tzero(1)
            endif
            dt(i)=1./float(nt(i)-1)
1000      continue
        else
          do 1010i=1,ncomp
            tzero(i)=trez(1,i)
            nt(i)=nsuper(1,i)*nsuper(2,i)*nsuper(3,i)
            dt(i)=1./float(nt(i))
1010      continue
          ieach=1
        endif
      endif
      pom=0.
      call inm40(iesd)
      if(ErrJana.ne.0) return
      call deleq
      call inclat
      call addspec
      if(iesd) then
        call newln(2)
        write(lst,'(/''Input e.s.d of fraction coordinates of atoms '',
     1               ''included'')')
      else
        irnd=0
      endif
      call pisat
      call distat
      if(ErrJana.ne.0) return
      do 2000i=1,nacalc
        do 1900j=1,3
          x(j,i)=xdst(j,i)
1900    continue
2000  continue
4000  nr=0
      inquire(55,opened=opened)
      if(.not.opened) go to 9999
      line=(line-1)/4+4
      call NewPg(0)
      rewind 55
4100  read(55,FormA80,err=7000) radka
      if(radka(1:1).eq.'*') go to 4100
      kk=0
      call mala(radka)
      call kus(radka,kk,nazev)
      if(nazev.eq.'end') go to 7000
      i=islovo(nazev,text,2)
      if(i.le.0) go to 4100
      go to (5000,6000),i
5000  k2=0
      do 5010i=1,4
        k1=k2+1
        k2=k2+3
        call kus(radka,kk,attor(i))
        call uprat(attor(i))
        call atsym(attor(i),n,xtor(1,i),wt,wt(4),jsym,ich)
        if(n.le.0) then
          t80='atom '//attor(i)(i:idel(attor(i)))//' isn''t of the file'
     1        //' M40'
          call FeChybne(-1.,-1.,radka,t80,1,0)
          go to 4100
        else
          if(i.eq.1) then
            isw=iswa(n)
          else
            if(isw.ne.iswa(n)) then
              t80='atoms belong to different composite parts'
              call FeChybne(-1.,-1.,radka,t80,1,0)
              go to 4100
            endif
          endif
        endif
        if(ich.eq.1) then
          t80='string contains non-numerical character'
          call FeChybne(-1.,-1.,radka,t80,1,0)
          go to 4100
        else if(ich.eq.3) then
          t80='atom '//attor(i)(1:idel(attor(i)))//' has incorrect '//
     1        'symmetry part'
          call FeChybne(-1.,-1.,radka,t80,1,0)
          go to 4100
        endif
        call multmq(rm(1,iabs(jsym),isw),sx(1,n),sgx(k1),3,3,1)
5010  continue
      do 5100i=1,3
        u(i)=xtor(i,2)-xtor(i,1)
        v(i)=xtor(i,3)-xtor(i,2)
        w(i)=xtor(i,4)-xtor(i,3)
5100  continue
      call multm(g(1,isw),u,ug,3,3,1)
      call multm(g(1,isw),v,vg,3,3,1)
      call multm(g(1,isw),w,wg,3,3,1)
      uu=scalmul(u,ug)
      uv=scalmul(u,vg)
      uw=scalmul(u,wg)
      vv=scalmul(v,vg)
      vw=scalmul(v,wg)
      ww=scalmul(w,wg)
      pa=uv*vw-uw*vv
      pb=uu*vv-uv**2
      pc=vv*ww-vw**2
      do 5200i=1,3
        dau(i)=vg(i)*vw-wg(i)*vv
        dav(i)=ug(i)*vw+wg(i)*uv-2.*vg(i)*uw
        daw(i)=vg(i)*uv-ug(i)*vv
        dbu(i)=2.*(ug(i)*vv-vg(i)*uv)
        dbv(i)=2.*(vg(i)*uu-ug(i)*uv)
        dcv(i)=2.*(vg(i)*ww-wg(i)*vw)
        dcw(i)=2.*(wg(i)*vv-vg(i)*vw)
5200  continue
      pom1=1./(pb*pc)
      pom2=-1./sqrt(1.-pa**2*pom1)
      pom1=sqrt(pom1)
      alfa=acos(pa*pom1)/torad
      pom2=pom2*pom1
      pom3=pa*.5/pb
      pom4=pa*.5/pc
      do 5300i=1,3
        dtu(i)=pom2*(dau(i)-pom3*dbu(i))
        dtv(i)=pom2*(dav(i)-pom3*dbv(i)-pom4*dcv(i))
        dtw(i)=pom2*(daw(i)-pom4*dcw(i))
5300  continue
      do 5400i=1,3
        ddx(i)=-dtu(i)
        ddx(i+3)=dtu(i)-dtv(i)
        ddx(i+6)=dtv(i)-dtw(i)
        ddx(i+9)=dtw(i)
5400  continue
      isb=100.*sigma(sgx,ddx,12)/torad+.5
      if(u(1)*v(2)*w(3)+u(3)*v(1)*w(2)+u(2)*v(3)*w(1)-
     1   u(3)*v(2)*w(1)-u(1)*v(3)*w(2)-u(2)*v(1)*w(3).lt.0.) alfa=-alfa
      ven='Torsion angle of atoms : '
      j=idel(ven)+2
      do 5410i=1,4
        write(ven(j:132),FormA1)(attor(i)(k:k),k=1,idel(attor(i)))
        j=idel(ven)+1
        if(i.ne.4) then
          write(ven(j:j+1),'(''-'')')
          j=j+1
        endif
5410  continue
      write(ven(j:132),'('' is'',f8.2,''('',i4,'')'')') alfa,isb
      call newln(1)
      write(lst,102) ven
      go to 4100
6000  call kus(radka,kk,cislo)
      call posun(cislo,0)
      read(cislo,101) n1
      call kus(radka,kk,cislo)
      call posun(cislo,0)
      read(cislo,101) n2
      if(n1.lt.3) then
        call FeChybne(-1.,-1.,radka,'number of atoms defining plane '//
     1                'than 3',1,0)
        go to 4100
      endif
      do 6001i=1,n2
        if(kk.eq.80) then
          read(55,FormA80) radka
          call mala(radka)
          kk=0
        endif
        call kus(radka,kk,atplane(i))
        call uprat(atplane(i))
        call atsym(atplane(i),n,xplane(1,i),wt,wt(4),jsym,ich)
        if(n.le.0) then
          t80='atom '//atplane(i)(1:idel(atplane(i)))//' isn''t of '//
     1        'the file M40'
          call FeChybne(-1.,-1.,radka,t80,1,0)
          go to 4100
        else
          if(i.eq.1) then
            isw=iswa(n)
          else
            if(isw.ne.iswa(n)) then
              t80='atoms belong to different composite parts'
              call FeChybne(-1.,-1.,radka,t80,1,0)
              go to 4100
            endif
          endif
        endif
        if(ich.eq.1) then
          t80='string contains non-numerical character'
          call FeChybne(-1.,-1.,radka,t80,1,0)
          go to 4100
        else if(ich.eq.3) then
          t80='atom '//atplane(i)(1:idel(atplane(i)))//' has incorrect '
     1        //'symmetry part'
          call FeChybne(-1.,-1.,radka,t80,1,0)
          go to 4100
        endif
        call multmq(rm(1,iabs(jsym),isw),sx(1,n),sxplane(1,i),3,3,1)
6001  continue
      nr=nr+1
      ven='Equation of best plane through atoms :'
      l=40
      i=idel(atplane(1))
      k=1
      outs(1)='Equation of best plane through atoms :'
      do 6005j=1,n1
        outs(k)=outs(k)(1:l)//atplane(j)(1:i)
        l=l+i
        if(j.eq.n1) go to 6005
        if(l.lt.127) then
          outs(k)=outs(k)(1:l)//' '
          l=l+1
        endif
        i=idel(atplane(j+1))
        if(l.gt.127-i) then
          k=k+1
          l=40
          outs(k)=' '
        endif
 6005 continue
      call newln(k+3+((n2-1)/7+1)*2)
      write(lst,102)
      do 6010i=1,k
        write(lst,102) outs(i)
6010  continue
      do 6100i=1,3
        u(i)=xplane(i,1)-xplane(i,2)
        v(i)=xplane(i,3)-xplane(i,2)
6100  continue
      wg(1)=u(2)*v(3)-u(3)*v(2)
      wg(2)=u(3)*v(1)-u(1)*v(3)
      wg(3)=u(1)*v(2)-u(2)*v(1)
      call multm(gi,wg,w,3,3,1)
      call vecnor(w,wg)
      do 6500i=1,10
        i3=1
        if(abs(w(2)).gt.abs(w(1))) i3=2
        if(abs(w(3)).gt.abs(w(2)).and.abs(w(3)).gt.abs(w(1))) i3=3
        i1=mod(i3,3)+1
        i2=6-i1-i3
        avx=0.
        avy=0.
        avz=0.
        pom=0.
        do 6200j=1,n1
          if(iesd) then
            pom1=0.
            do 6150k=1,3
              pom1=pom1+(wg(k)*sxplane(k,j))**2
6150        continue
            pom1=1./pom1
          else
            pom1=1.
          endif
          avx=avx+xplane(i1,j)*pom1
          avy=avy+xplane(i2,j)*pom1
          avz=avz+xplane(i3,j)*pom1
          pom=pom+pom1
          wt(j)=pom1
6200    continue
        avx=avx/pom
        avy=avy/pom
        avz=avz/pom
        pom3=w(i1)/w(i3)
        pom4=w(i2)/w(i3)
        cx=0.
        cy=0.
        cz=0.
        p1=0.
        p2=0.
        do 6300j=1,n1
          xxx=xplane(i1,j)-avx
          yyy=xplane(i2,j)-avy
          zzz=xplane(i3,j)-avz
          uu=xxx*wg(i1)+yyy*wg(i2)+zzz*wg(i3)
          pom=wt(j)
          pom1=xxx-pom3*zzz
          pom2=yyy-pom4*zzz
          cx=cx+pom1**2  *pom
          cy=cy+pom1*pom2*pom
          cz=cz+pom2**2  *pom
          p1=p1+pom1*uu  *pom
          p2=p2+pom2*uu  *pom
6300    continue
        pom=1./(cx*cz-cy**2)
        cz= cz*pom
        cy=-cy*pom
        cx= cx*pom
        w(i1)=cz*p1+cy*p2
        w(i2)=cy*p1+cx*p2
        w(i3)=-pom3*w(i1)-pom4*w(i2)
        pom1=0.
        pom2=0.
        do 6400j=1,3
          wg(j)=wg(j)-w(j)
          pom1=pom1+abs(w(j))
          pom2=pom2+abs(wg(j))
6400    continue
        call multm(gi(1,isw),wg,w,3,3,1)
        call vecnor(w,wg)
        if(pom1/pom2.le..00001) go to 6600
6500  continue
6600  if(wg(1).lt.0.) then
        do 6650i=1,3
          wg(i)=-wg(i)
6650    continue
      endif
      do 6710i=1,3
        fm(i,nr)=wg(i)
        isww(i)=0
        sfm(i,nr)=0.
6710  continue
      isww(4)=0
      if(iesd) then
        isww(i1)=nint(sqrt(cz)*10000.)
        isww(i2)=nint(sqrt(cx)*10000.)
        pom3=w(i1)/w(i3)
        pom4=w(i2)/w(i3)
        pom=pom3**2*cz+pom4**2*cx+2.*pom3*pom4*cy
        isww(i3)=nint(sqrt(pom)*10000.)
        if(i1.eq.1) then
          sfm(1,nr)=cz
          sfm(2,nr)=cx
          sfm(3,nr)=cy*2.
        else if(i.eq.1) then
          sfm(1,nr)=pom
          sfm(2,nr)=cz
          sfm(3,nr)=-2.*(pom3*cz+pom4*cy)
        else if(i.eq.2) then
          sfm(1,nr)=cx
          sfm(2,nr)=pom
          sfm(3,nr)=-2.*(pom3*cy+pom4*cx)
        endif
      endif
      uu=-wg(i1)*avx-wg(i2)*avy-wg(i3)*avz
      chiq=0.
      do 6770i=1,n2
        xxx=xplane(i1,i)-avx
        yyy=xplane(i2,i)-avy
        zzz=xplane(i3,i)-avz
        vv=wg(i1)*xxx+wg(i2)*yyy+wg(i3)*zzz
        dx(i)=vv
        idx(i)=0
        if(iesd) then
          pom1=xxx-pom3*zzz
          pom2=yyy-pom4*zzz
          pom=pom1**2*cz+pom2**2*cx+2.*pom1*pom2*cy
          do 6760j=1,3
            pom=pom+(wg(j)*sxplane(j,i))**2
6760      continue
          idx(i)=nint(1000.*sqrt(pom))
          if(i.le.n1) chiq=chiq+vv**2*wt(i)
        endif
6770  continue
      if(iesd) then
        pom1=avx-pom3*avz
        pom2=avy-pom4*avz
        isww(4)=nint(sqrt(pom1**2*cz+pom2**2*cx+2.*pom1*pom2*cy)*10000.)
      endif
      write(lst,'(f8.4,''*x+('',f8.4,'')*y+('',f8.4,'')*z+('',f8.4,
     1            '') = 0.0   chiq ='',f8.2/3x,''('',i5,'')'',5x,
     2            2(''('',i5,'')'',6x),''('',i5,'')'')')
     3      wg,uu,chiq,isww
      ven='Atom name :'
      venp='Distance from plane :'
      venpp=' '
      l=22
      do 6900i=1,n2
        ven=ven(1:l+4)//(atplane(i)(1:8))
        if(idel(atplane(i)).gt.8) venpp=venpp(1:l+4)//(atplane(i)(9:16))
        write(venp(l+1:132),'(f7.3,''('',i3,'')'')') dx(i),idx(i)
        l=l+12
        if(l.gt.117) then
          write(lst,102) ven
          if(idel(venpp).gt.0) write(lst,102) venpp
          write(lst,102) venp
          ven=' '
          venp=' '
          l=22
        endif
6900  continue
      if(l.gt.22) then
        write(lst,102) ven
        if(idel(venpp).gt.0) write(lst,102) venpp
        write(lst,102) venp
      endif
      go to 4100
7000  close(55,status='delete')
      if(nr.lt.2) go to 9999
      call NewPg(0)
      call newln(5)
      write(lst,'(/''Table of dihedral angles :''///)')
      do 8300i=1,nr
        call multm(gi(1,isw),fm(1,i),u,3,3,1)
        do 8200j=1,nr
          if(i.eq.j) then
            dx(j)=0.
            idx(j)=0
          else
            call multm(gi(1,isw),fm(1,j),v,3,3,1)
            pom=scalmul(fm(1,j),u)
            dx(j)=acos(pom)/torad
            pom1=v(1)-u(1)/u(3)*v(3)
            pom2=v(2)-u(2)/u(3)*v(3)
            pom3=u(1)-v(1)/v(3)*u(3)
            pom4=u(2)-v(2)/v(3)*u(3)
            idx(j)=nint(100.*sqrt((sfm(1,i)*pom1**2+sfm(2,i)*pom2**2+
     1                             sfm(3,i)*pom1*pom2+sfm(1,j)*pom3**2+
     2                             sfm(2,j)*pom4**2+sfm(3,j)*pom3*pom4)/
     3                             (1.-pom**2))/torad)
          endif
8200    continue
        write(lst,'(i5,8(f8.2,''('',i5,'')'')/6x,8(f8.2,''('',i5,
     1              '')'')/6x,4(f8.2,''('',i5,'')''))') i,
     2              (dx(j),idx(j),j=1,nr)
8300  continue
9999  close(m50)
      close(lst)
      close(61)
      write(89,'(''end'')')
      close(89)
      return
101   format(i15)
102   format(a132)
      end
      subroutine round(x,sx,n)
      if(sx.eq.0.) go to 9999
      if(n) 1000,9999,1000
 1000 f=1.
 1500 isx=sx*f+.05
      if(isx) 9999,1800,3000
 1800 f=f*10.
      go to 1500
 3000 sx=anint(sx*f)/f
      x=anint(x*f)/f
 9999 return
      end
      function sigma(sx,dx,n)
      dimension sx(n),dx(n)
      s=0.
      do 1000i=1,n
        s=s+(sx(i)*dx(i))**2
1000  continue
      sigma=sqrt(s)
      return
      end
      subroutine NactiDist
      include 'params.cmn'
      include 'basic.cmn'
      include 'dist.cmn'
      call Najdi('dist',i)
      if(i.ne.1) go to 9999
      do 1000i=1,NactiKeys
        if(i.le.22) then
          NactiRepeat(i)= 0
        else
          NactiRepeat(i)=-1
        endif
1000  continue
1100  call NactiCommon(izpet)
1110  if(izpet.eq.0) then
        do 2000i=1,NactiInt+NactiReal
          if(NactiRepeat(i).le.0) go to 2000
          if(i.le.NactiInt) then
            j=NacetlInt(i)
          else
            p=NacetlReal(i)
          endif
          if(i.eq.1) then
            irnd=j
          else if(i.eq.2) then
            iuhl=j
          else if(i.eq.3) then
            fullcoo=j
          else if(i.eq.4) then
            ieach=j
          else if(i.eq.5) then
            incl=j
          else if(i.eq.6) then
            ittab=j
          else if(i.eq.11) then
            dmdk=p
          else if(i.eq.12) then
            dmhk=p
          else if(i.eq.13) then
            oind=p
          else if(i.eq.14) then
            oind=p
          endif
2000    continue
        go to 9999
      else if(izpet.eq.1) then
        do 2010i=1,ndimi
          call kus(NactiVeta,PosledniPozice,Cislo)
          call posun(Cislo,0)
          read(Cislo,'(i15)') nt(i)
2010    continue
      else if(izpet.eq.2) then
        do 2020i=1,ndimi
          call kus(NactiVeta,PosledniPozice,Cislo)
          call posun(Cislo,1)
          read(Cislo,'(f15.0)') tzero(i)
2020    continue
      else if(izpet.eq.3) then
2100    isel=isel+1
        call kus(NactiVeta,PosledniPozice,asel(isel))
        call uprat(asel(isel))
        if(PosledniPozice.ne.80) go to 2100
      else if(izpet.ge.4) then
        backspace m50
        open(55,file='torpl.tmp')
3000    read(m50,FormA80,end=3100) NactiVeta
        write(55,FormA80) NactiVeta
        go to 3000
3100    izpet=0
        go to 1110
      endif
      if(izpet.ne.0) go to 1100
9000  call ChybaNacteni(izpet+NactiReal+NactiInt)
      go to 1100
9999  return
102   format(f15.5)
      end
      subroutine inm40(iesd)
      include 'params.cmn'
      include 'basic.cmn'
      include 'atoms.cmn'
      include 'dist.cmn'
      dimension xp(6),xpp(6),sngc(mxw,24,mxa),csgc(mxw,24,mxa)
      logical iesd
      call iom40(0,0)
      if(ErrJana.ne.0) return
      do 1200i=1,nacalc
        do 1000j=1,3
          xdst(j,i)=x(j,i)
1000    continue
        do 1100j=1,6
          betadst(j,i)=beta(j,i)
1100    continue
1200  continue
      if(ndim.gt.3) then
        call trortho(0)
        if(ncommen.gt.0) then
          nacalcp=nacalc
          call comsym(1)
          call comexp(sngc,csgc)
          call specat
          n=nacalcp
          do 5000j=1,ngc
            do 4000i=1,nacalcp
              isw=iswa(i)
              n=n+1
              call qbyx(x(1,n),qcnt(1,n),isw)
              do 2000k=1,3
                xp(k)=xdst(k,i)
2000          continue
              do 2100k=4,ndim
                xp(k)=0.
2100          continue
              call multm(rm6gc(1,j,isw),xp,xpp,ndim,ndim,1)
              call multmq(rm6gc(1,j,isw),sx(1,i),sx(1,n),3,3,1)
              do 2200k=1,3
                xdst(k,n)=xpp(k)+sgc(k,j,isw)
2200          continue
4000        continue
5000      continue
        endif
      endif
      close(m40)
      iesd=.true.
      s=0.
      do 6000i=1,nacalc
        dx(i)=0.
        if(ndim.gt.3) then
          x40=qcnt(1,i)
          isw=iswa(i)
          eps0=tzero(isw)
          epsd=dt(isw)
          call indocc(oi,x40,eps0,nt(isw),epsd,a0(i),ax(1,i),ay(1,i),
     1                kmods(i),kfs(i),1)
          if(kfx(i).gt.0) call indoccx(oi,x40,eps0,nt(isw),epsd,
     1                           uy(1,kmodx(i),i),uy(2,kmodx(i),i))
          call indpos(xdi,x40,eps0,nt(isw),epsd,ux(1,1,i),uy(1,1,i),
     1                kmodx(i),kfx(i),1)
          do 5200j=1,nt(isw)
            do 5100k=1,3
              xdi(k,j)=xdi(k,j)+x(k,i)-xdst(k,i)
5100        continue
            if(oi(j).le.ocut) go to 5200
            call multm(g(1,isw),xdi(1,j),xp,3,3,1)
            dx(i)=max(dx(i),sqrt(scalmul(xdi(1,j),xp)))
5200      continue
        endif
        s=s+sx(1,i)+sx(2,i)+sx(3,i)
6000  continue
      iesd=s.gt.0.
      return
      end
      subroutine angulus(angle,isu)
      include 'params.cmn'
      include 'basic.cmn'
      include 'dist.cmn'
      angle=0.
      isu=0
      uv=scalmul(u,vg)
      pom=sqrt(uu*vv)
      if(abs(pom).lt..0001) go to 9999
      angle=uv/pom
      if(abs(angle).gt..999999) then
        angle=90.-sign(90.,angle)
        go to 9999
      endif
      if(abs(angle).lt..0001) then
        angle=90.
        go to 9999
      endif
      pom=1./(pom*(sqrt(1.-angle**2)*torad))
      angle=acos(angle)/torad
      if(iswi.ne.iswk) return
      do 1000l=1,3
        dtu(l)=pom*(vg(l)-ug(l)*uv/uu)
        dtv(l)=pom*(ug(l)-vg(l)*uv/vv)
        ddx(l)=-dtu(l)-dtv(l)
        ddx(l+3)=dtu(l)
        ddx(l+6)=dtv(l)
1000  continue
      isu=sigma(sgx,ddx,9)*100.+.5
9999  return
      end
      subroutine outst(iven)
      include 'params.cmn'
      include 'basic.cmn'
      character*32 iven(*)
      n=(line-1)/4+1
      do 1000i=1,n
       write(lst,'(4a32)')(iven(i+(j-1)*n),j=1,4)
1000  continue
      do 2000i=1,line
        iven(i)=' '
2000  continue
      return
      end
      subroutine inclat
      include 'params.cmn'
      include 'basic.cmn'
      include 'atoms.cmn'
      include 'dist.cmn'
      character*80 t80
      logical Exist
      if(incl.ne.2) then
        inquire(file=fln(1:ifln)//'.m48',exist=exist)
        if(.not.exist) then
          incl=incl-1
          if(incl.ne.0) incl=2
        endif
      endif
      if(incl.ge.2) then
        inquire(file=fln(1:ifln)//'.m47',exist=exist)
        if(.not.exist) then
          incl=incl-2
          if(incl.ne.0) incl=1
        endif
      endif
      if(incl.gt.0) then
        call newln(1)
        if(incl.eq.1) then
          write(lst,'(''Positive peaks from the previous Fourier '',
     1                ''calculation will be included'')')
        else if(incl.eq.2) then
          write(lst,'(''Negative peaks from the previous Fourier '',
     1                ''calculation will be included'')')
        else
          write(lst,'(''Both positive and negative peaks from the '',
     1                ''previous Fourier calculation will be included'')
     2                 ')
        endif
      else
        return
      endif
      l1=1
      l2=1
      if(incl.ge.2) then
        l2=2
        if(incl.eq.2) l1=2
      endif
      do 1500l=l1,l2
        m4=49-l
        t80=fln(1:ifln)//'.m'
        i=idel(t80)+1
        write(t80(i:i+1),'(i2)') m4
        open(m4,file=t80(1:i+1))
        read(m4,'(i5,15x,i5)') n,isw
        read(m4,'(f9.6)') to,to,to,to
        do 1400i=nacalc+1,nacalc+n
          read(m4,'(a8,2i3,13x,3f9.6,6x,3i1,3i3/f9.6)') atom(i),isf(i),
     1                    itf(i),(xdst(k,i),k=1,3),j,j,j,j,kmodx(i),j,
     2                    to
          iswa(i)=isw
          do 1000k=1,3
            x(k,i)=xdst(k,i)
            sx(k,i)=0.
1000      continue
          call qbyx(x(1,i),qcnt(1,i),isw)
          do 1100k=1,6
            beta(k,i)=0.
            sbeta(k,i)=0.
1100      continue
          do 1300j=1,kmodx(i)
            read(m4,101)(ux(k,j,i),k=1,3),(uy(k,j,i),k=1,3)
1300      continue
          if(kmodx(i).ne.0) read(m4,101) to
1400    continue
        close(m4)
        nacalc=nacalc+n
1500  continue
      call specat
      return
101   format(6f9.6)
      end
      subroutine deleq
      include 'params.cmn'
      include 'basic.cmn'
      include 'atoms.cmn'
      include 'dist.cmn'
      logical pis,eqrv
      pis=.true.
      do 1160i=1,nacalc
        if(isf(i).eq.0) go to 1160
        if(ai(i).eq.0.) then
          isf(i)=0
          go to 1160
        endif
        j=i
1130    j=j+1
        j=koinc(xdst(1,i),xdst,j,nacalc,.01,pom,iswa(i))
        if(j.gt.0) then
          if(kfs(i).eq.kfs(j).and.kmods(i).eq.kmods(j)) then
            if(.not.eqrv(ax(1,i),ax(1,j),kmods(i),.00001).or.
     1         .not.eqrv(ay(1,i),ay(1,j),kmods(i),.00001)) go to 1130
          else
            go to 1130
          endif
          if(kfx(i).eq.kfx(j).and.kmodx(i).eq.kmodx(j)) then
            if(.not.eqrv(ux(1,1,i),ux(1,1,j),3*kmodx(i),.00001).or.
     1         .not.eqrv(uy(1,1,i),uy(1,1,j),3*kmodx(i),.00001))
     2        go to 1130
          else
            go to 1130
          endif
          if(pis) then
            call newln(1)
            write(lst,FormA80)
            pis=.false.
          endif
          call newln(1)
          write(lst,'(''The atom '',a8,'' deleted from the distance '',
     1                '' calculation as coincides from with : '',a8)')
     2                atom(j),atom(i)
          isf(j)=0
          go to 1130
        else
          go to 1160
        endif
1160  continue
      end
      subroutine pisat
      include 'params.cmn'
      include 'basic.cmn'
      include 'atoms.cmn'
      include 'dist.cmn'
      logical eqwild
      character*1 znak
      if(isel.gt.0) then
        fullcoo=1
        do 1000j=1,nacalc
          brat(j)=.false.
1000    continue
        do 1020i=1,isel
          if(index(asel(i),'*').ne.0) then
            do 1010j=1,nacalc
              brat(j)=brat(j).or.eqwild(atom(j),asel(i))
1010        continue
          else
            j=ktat(atom,nacalc,asel(i))
            if(j.gt.0) brat(j)=.true.
          endif
1020    continue
      else
        do 1050j=1,nacalc
          brat(j)=.true.
1050    continue
      endif
1100  continue
      call newln(3)
      write(lst,'(/38x,''fractional'',36x,''cartesian'')')
      if(lite.eq.1) then
        write(lst,'('' no'',2x,''atom'',10x,''xf'',8x,''yf'',8x,''zf'',
     1              5x,''sigxf'',5x,''sigyf'',5x,''sigzf'',8x,''x'',8x,
     2              ''y'',8x,''z'',6x,''Biso'')')
      else
        write(lst,'('' no'',2x,''atom'',10x,''xf'',8x,''yf'',8x,''zf'',
     1              5x,''sigxf'',5x,''sigyf'',5x,''sigzf'',8x,''x'',8x,
     2              ''y'',8x,''z'',6x,''Uiso'')')
      endif
      do 1500i=1,nacalc
        m=isf(i)
        if(m.eq.0) go to 1500
        do 1110j=1,3
          sxp(j,i)=sx(j,i)
1110    continue
        do 1111j=1,3
          call round(xdst(j,i),sx(j,i),irnd)
1111    continue
        if(itf(i).eq.1) then
          if(lite.eq.0) then
            bizo=beta(1,i)/episq
            pom=sbeta(1,i)/episq
          else
            bizo=beta(1,i)
            pom=sbeta(1,i)
          endif
        else
          call boueq(betadst(1,i),sbeta(1,i),lite,bizo,pom,1)
        endif
        xk=xdst(1,i)*tr(1,1)+xdst(2,i)*tr(4,1)+xdst(3,i)*tr(7,1)
        yk=                  xdst(2,i)*tr(5,1)+xdst(3,i)*tr(8,1)
        zk=                                    xdst(3,i)*tr(9,1)
        if(brat(i)) then
          znak='+'
        else
          znak='-'
        endif
        call newln(1)
        if(lite.eq.1) then
          write(lst,'(i3,2x,a8,a1,6f10.6,3f9.4,f6.2,''('',i3,'')'')')
     1                i,atom(i),znak,(xdst(j,i),j=1,3),(sx(j,i),j=1,3),
     2                xk,yk,zk,bizo,nint(pom*100.)
        else
          write(lst,'(i3,2x,a8,a1,6f10.6,3f9.4,f9.4,''('',i3,'')'')')
     1                i,atom(i),znak,(xdst(j,i),j=1,3),(sx(j,i),j=1,3),
     2                xk,yk,zk,bizo,nint(pom*10000.)
        endif
1500  continue
      return
      end
      subroutine distat
      include 'params.cmn'
      include 'basic.cmn'
      include 'atoms.cmn'
      include 'dist.cmn'
      include 'fepc.cmn'
      dimension y0(3),y1(3),y2(3),uz(3),shj(3),shjc(3),umg(3),sx0(6),
     1          xdj(3,mxt),uxj(3,mxw),uyj(3,mxw),y0p(6),y1p(3),y2p(3),
     2          uzp(3),up(3),jsh(3),wprij(36),gw4(3),wpriji(36),nvx(3),
     3          nvy(3),nvz(3),y3(6),y3p(6),yp(6),ypp(6),idtab(30),
     4          iptab(30),nutab(30),utab(30,30)
      character*132 ltab(500)
      character*80 t80
      character*40 t40
      character*8 at1,at2,attab(30),atutab(30,30),konec
      character*7 t7
      character*2 nty
      logical iuhl0
      data konec/'[konec]'/
      iswji=0
      iswki=0
      if(dmhk.ge.0.) then
        do 1000i=1,nf
          dmd(i)=dmdk
          dmh(i)=dmhk
1000    continue
      endif
      pom=0.
      do 1100i=1,nf
        if(dmh(i).lt.dmd(i)) dmh(i)=0.
        pom=pom+dmh(i)
1100  continue
      if(pom.le.0.) then
        call newln(2)
        write(lst,'(/''Distances and angles will not be calculated'')')
        return
      endif
      do 1110i=1,mxl4
       iven(i)=' '
1110  continue
      iuhl0=iuhl.eq.0
      call newln(3)
      if(fullcoo.eq.1) then
        write(lst,'(/''Full coordination of atoms will be printed'')')
      else
        write(lst,'(/''Reduced coordination of atoms will be printed'')'
     1              )
      endif
      if(iuhl0) then
        write(lst,'(''Distances will be calculated'')')
      else
        write(lst,'(''Distances and angles will be calculated'')')
      endif
      if(ndim.eq.4.and.nt(1).gt.0.and.ieach.ne.0) then
        call newln(1)
        if(ieach.eq.1) then
          write(lst,'('' at '',i3,'' equidistant values of t from the ''
     1               ,''interval <0,1>'')') nt(1)
        else
          write(lst,'('' at '',i3,'' equidistant values of t from the ''
     1               ,''interval <0,1> but only each '',i2,a2,
     2                '' value will be printed'')') nt(1),ieach,
     3                                              nty(ieach)
        endif
      endif
      call newln(nf)
      write(lst,'('' for atom : '',a2,'' from '',f6.3,'' to '',f6.3)')
     1           (nat(l),dmd(l),dmh(l),l=1,nf)
      call newln(1)
      write(lst,FormA80)
      if(line.gt.40) then
        call newpg(0)
        mxl=mxl4
      else
        mxl=mxl4-(line-3)*4
      endif
      line=0
      open(61,file=fln(1:ifln)//'.m61')
      do 8100i=1,nacalc
        if(.not.brat(i)) go to 8100
        l=isf(i)
        if(l.eq.0) go to 8100
        dmdi=dmd(l)
        dmhi=dmh(l)
        iswi=iswa(i)
        ah=rcp(1,iswi)
        bh=rcp(2,iswi)
        ch=rcp(3,iswi)
        tzeroi=tzero(iswi)
        dti=dt(iswi)
        nti=nt(iswi)
        xdmn=tzeroi
        xdmx=tzeroi+dti*float(nti)
        call bunka(xdst(1,i),x1,0)
        do 1200l=1,3
          x1p(l)=x(l,i)
1200    continue
        call qbyx(x1,x1(4),iswi)
        if(iuhl0) then
          write(61,'(''Distances concerning atom '',a8/34(''=''))')
     1          atom(i)
        else
          write(61,'(''Distances and angles concerning atom '',a8/
     1               45(''=''))') atom(i)
        endif
        if(ittab.le.1) then
          call fflush
          line=line+1
          write(iven(line),102)
          call fflush
          line=line+1
          write(iven(line),103) atom(i)
          call fflush
          line=line+1
          write(iven(line),102)
          call fflush
        endif
        do 2000l=1,3
          sgx(l)=sx(l,i)
2000    continue
        if(nti.gt.0.and.ndim.eq.4) then
          x40=qcnt(1,i)
          eps0=tzeroi
          epsd=dti
          call indocc(oi,x40,eps0,nti,epsd,a0(i),ax(1,i),ay(1,i),
     1                kmods(i),kfs(i),1)
          if(kfx(i).gt.0) call indoccx(oi,x40,eps0,nti,epsd,
     1                           uy(1,kmodx(i),i),uy(2,kmodx(i),i))
          call indpos(xdi,x40,eps0,nti,epsd,ux(1,1,i),uy(1,1,i),
     1                kmodx(i),kfx(i),1)
        endif
        if(fullcoo.eq.1) then
          jp=1
        else
          jp=i
        endif
        do 8000j=jp,nacalc
          l=isf(j)
          if(l.eq.0) go to 8000
          iswj=iswa(j)
          mxcellx=dmhi*rcp(1,iswj)+1
          mxcelly=dmhi*rcp(2,iswj)+1
          mxcellz=dmhi*rcp(3,iswj)+1
          if(iswj.ne.iswi) then
            l=iswi*10+iswj
            if(l.ne.iswji) then
              call multm(zv(1,iswi),zvi(1,iswj),wprij,4,4,4)
              call matinv(wprij,wpriji,det,4)
              do 2040l=1,3
                nvz(l)=nint(wpriji(l+12))
2040          continue
              kolik=0
              do 2042l=1,3
                nvx(l)=0
                nvy(l)=0
                if(nvz(l).ne.0) then
                  kolik=kolik+1
                  kdeneni=l
                else
                  kdeje=l
                endif
2042          continue
              if(kolik.eq.3) then
                nvx(1)=1
                nvy(2)=1
              else if(kolik.eq.2) then
                nvx(mod(kdeje-1,3)+1)=1
                nvy(mod(kdeje,3)+1)=1
              else
                nvx(mod(kdeneni,3)+1)=1
                nvy(mod(kdeneni+1,3)+1)=1
              endif
              call multm(g(1,iswi),wprij(13),gw4,3,3,1)
              gww=scalmul(gw4,wprij(13))
              tnat=wprij(ndimq)-scalmul(qu(1,1,iswi),wprij(13))
            endif
          else
            tnat=1.
          endif
          iswji=l
          tztnat=tzeroi/tnat
          dttnat=dti/tnat
          dmhij=dmhi+dx(i)+dx(j)
          dmdijq=dmdi**2
          dmhija=dmhij*ah
          dmhijb=dmhij*bh
          dmhijc=dmhij*ch
          dmhijq=dmhij**2
          do 2050l=1,3
            y0(l)=xdst(l,j)
            y0p(l)=x(l,j)
            sx0(l)=sx(l,j)
2050      continue
          js=0
          jst=0
          do 7900jsym=1,ns
            call multm(rm(1,jsym,iswj),y0,y1,3,3,1)
            call multm(rm(1,jsym,iswj),y0p,y1p,3,3,1)
            call multmq(rm(1,jsym,iswj),sx0,sgx(4),3,3,1)
            eps=rm6(16,jsym,iswj)
            do 2100l=1,3
              y1(l)=y1(l)+s6(l,jsym,iswj)
              y1p(l)=y1p(l)+s6(l,jsym,iswj)
2100        continue
            do 7800jcntrsm=1,3-ncs
              js=js+1
              if(isa(js,j).le.0) go to 7800
              if(jcntrsm.ne.1) then
                eps=-eps
                do 2200l=1,3
                  y1(l)=-y1(l)+s6(l,jsym,iswj)*2.
                  y1p(l)=-y1p(l)+s6(l,jsym,iswj)*2.
2200            continue
              endif
              do 7700jcenter=1,nvt
                do 2300l=1,3
                  y2(l)=y1(l)+vt6(l,jcenter,iswj)
                  y2p(l)=y1p(l)+vt6(l,jcenter,iswj)
2300            continue
                ts4=s6(4,jsym,iswj)+vt6(4,jcenter,iswj)
                if(iswj.eq.iswi) then
                  call bunka(y2,shj,1)
                  do 2310l=1,3
                    uzp(l)=y2p(l)-x1p(l)+shj(l)
                    uz(l)=y2(l)-x1(l)
2310              continue
                else
                  call multm(wpriji,x1,yp,ndim,ndim,1)
                  do 2320l=1,3
                    shj(l)=yp(l)-y2(l)
2320              continue
                  do 2330l=1,3
                    shj(l)=ifix(shj(l))
                    y2(l)=y2(l)+shj(l)
                    y2p(l)=y2p(l)+shj(l)
2330              continue
                endif
                do 7600jcellx=-mxcellx,mxcellx
                  cellxj=jcellx
                  if(iswj.eq.iswi) then
                    pom=uz(1)+cellxj
                    if(abs(pom).gt.dmhija) go to 7600
                    u(1)=pom
                    up(1)=uzp(1)+cellxj
                    y2(1)=y2(1)+cellxj
                    y2p(1)=y2p(1)+cellxj
                    jsh(1)=nint(shj(1))+jcellx
                    shjc(1)=shj(1)+cellxj+s6(1,jsym,iswj)+
     1                      vt6(1,jcenter,iswj)
                  endif
                  do 7500jcelly=-mxcelly,mxcelly
                    cellyj=jcelly
                    if(iswj.eq.iswi) then
                      pom=uz(2)+cellyj
                      if(abs(pom).gt.dmhijb) go to 7500
                      u(2)=pom
                      up(2)=uzp(2)+cellyj
                      y2(2)=y2(2)+cellyj
                      y2p(2)=y2p(2)+cellyj
                      jcellzp=-mxcellz
                      jcellzk= mxcellz
                      jsh(2)=nint(shj(2))+jcelly
                      shjc(2)=shj(2)+cellyj+s6(2,jsym,iswj)+
     1                        vt6(2,jcenter,iswj)
                    else
                      do 2420l=1,3
                        pom=cellxj*float(nvx(l))+cellyj*float(nvy(l))
                        y3(l)=y2(l)+pom
                        y3p(l)=y2p(l)+pom
                        shjc(l)=shj(l)+pom+s6(l,jsym,iswj)+
     1                          vt6(l,jcenter,iswj)
                        jsh(l)=nint(shj(l)+pom)
2420                  continue
                      call qbyx(y3,y3(4),iswj)
                      call multm(wprij,y3,yp,ndim,ndim,1)
                      do 2425l=1,3
                        u(l)=yp(l)-x1(l)
2425                  continue
                      v1=scalmul(gw4,u)
                      call multm(g(1,iswi),u,ug,3,3,1)
                      du=scalmul(u,ug)-v1**2/gww
                      if(du.gt.dmhijq) go to 7500
                      du=sqrt(du)
                      tmin=-v1/gww*tnat
                      it=tmin
                      if(tmin.lt.0.) it=it-1
                      do 2430l=1,3
                        pom=-it*nvz(l)
                        y3(l)=y3(l)+pom
                        y3p(l)=y3p(l)+pom
                        shjc(l)=shjc(l)+pom
                        jsh(l)=jsh(l)+nint(pom)
2430                  continue
                      tmin=tmin-float(it)
                      jcellzk=0
2442                  do 2443l=1,3
                        yp(l)=y3(l)+float(nvz(l)*(jcellzk+1))
2443                  continue
                      call qbyx(yp,yp(4),iswj)
                      yp(4)=yp(4)+xdmx/tnat
                      call multm(wprij,yp,ypp,4,4,1)
                      do 2444l=1,3
                        u(l)=ypp(l)-x1(l)
2444                  continue
                      call multm(g(1,iswi),u,ug,3,3,1)
                      pom=scalmul(u,ug)
                      tminp=tmin+float(jcellzk+1)
                      if(pom.lt.dmhijq.or.
     1                   (tminp.ge.xdmn.and.tminp.le.xdmx)) then
                        jcellzk=jcellzk+1
                        go to 2442
                      endif
                      jcellzp=0
2452                  do 2453l=1,3
                        yp(l)=y3(l)+float(nvz(l)*(jcellzp-1))
2453                  continue
                      call qbyx(yp,yp(4),iswj)
                      yp(4)=yp(4)+xdmn/tnat
                      call multm(wprij,yp,ypp,4,4,1)
                      do 2454l=1,3
                        u(l)=ypp(l)-x1(l)
2454                  continue
                      call multm(g(1,iswi),u,ug,3,3,1)
                      pom=scalmul(u,ug)
                      tminp=tmin+float(jcellzp-1)
                      if(pom.lt.dmhijq.or.
     1                   (tminp.ge.xdmn.and.tminp.le.xdmx)) then
                        jcellzp=jcellzp-1
                        go to 2452
                      endif
                      do 2455l=1,3
                        pom=float(nvz(l)*(jcellzp-1))
                        y3p(l)=y3p(l)+pom
                        y3 (l)=y3 (l)+pom
                        shjc(l)=shjc(l)+pom
                        jsh(l)=jsh(l)+nint(pom)
2455                  continue
                    endif
                    do 7400jcellz=jcellzp,jcellzk
                      jst=jst+1
                      cellzj=jcellz
                      if(iswj.eq.iswi) then
                        pom=uz(3)+cellzj
                        if(abs(pom).gt.dmhijc) go to 7400
                        u(3)=pom
                        up(3)=uzp(3)+cellzj
                        y2(3)=y2(3)+cellzj
                        y2p(3)=y2p(3)+cellzj
                        shjc(3)=shj(3)+cellzj+s6(3,jsym,iswj)+
     1                          vt6(3,jcenter,iswj)
                        jsh(3)=nint(shj(3))+jcellz
                        call multm(g(1,iswi),u,ug,3,3,1)
                        uu=scalmul(u,ug)
                        if(uu.gt.dmhijq.or.uu.lt.dmdijq) go to 7400
                        if(uu.eq.0..and.i.eq.j) go to 7400
                        du=sqrt(uu)
                        do 2500l=1,3
                          if(du.ne.0.) then
                            ddx(l+3)=ug(l)/du
                          else
                            ddx(l+3)=0.
                          endif
                          ddx(l)=-ddx(l+3)
                          y3 (l)=y2 (l)
                          y3p(l)=y2p(l)
2500                    continue
                      else
                        do 2510l=1,3
                          pom=nvz(l)
                          y3 (l)=y3 (l)+pom
                          y3p(l)=y3p(l)+pom
                          shjc(l)=shjc(l)+pom
                          jsh(l)=jsh(l)+nint(pom)
2510                    continue
                      endif
                      call qbyx(y3,y3(4),iswj)
                      call qbyx(y3p,y3p(4),iswj)
                      call scode(jsym,jcntrsm,jcenter,shjc,jsh,iswj,t80,
     1                           t40)
                      call ScodeCIF(jsym,jcntrsm,jcenter,jsh,iswj,t7)
                      t80=t80(1:idel(t80))//'#'
                      l=idel(t40)
                      if(l.gt.0) t80=t80(1:idel(t80))//t40(1:l)
                      call zhusti(t80)
                      if(iswi.eq.iswj) then
                        sdu=sigma(sgx,ddx,6)
                        isdu=nint(sdu*10000.)
                      else
                        sdu=0.
                        isdu=0
                      endif
                      if(ndim.eq.3) then
                        write(61,117) atom(i),atom(j),du,isdu,t80
                        write(89,116) atom(i),atom(j),du,sdu,t7
                      endif
                      if(ittab.le.1) then
                        call fflush
                        line=line+1
                        write(iven(line),104) atom(j),du,isdu
                        do 2530k=1,8
                          if(iven(line)(k:k).eq.' ') iven(line)(k:k)='.'
2530                    continue
                      endif
                      if(nti.le.0.or.ndim.ne.4) go to 3000
                      do 2600m=1,kmodx(j)
                        call multm(rm(1,jsym,iswj),ux(1,m,j),uxj(1,m),
     1                             3,3,1)
                        if(kfx(j).eq.0.or.m.ne.kmodx(j)) then
                          call multm(rm(1,jsym,iswj),uy(1,m,j),
     1                               uyj(1,m),3,3,1)
                        else
                          do 2540l=1,3
                            uyj(l,m)=uy(l,m,j)
2540                      continue
                        endif
                        if(jcntrsm.eq.2) then
                          do 2550l=1,3
                            uxj(l,m)=-uxj(l,m)
                            if(kfx(j).eq.0.or.m.ne.kmodx(j))
     1                                           uyj(l,m)=-uyj(l,m)
2550                      continue
                        endif
2600                  continue
                      call qbyx(shjc,qx,iswj)
                      x40=qcnt(1,j)+eps*(qx(1)-ts4)
                      eps0=eps*tztnat
                      epsd=eps*dttnat
                      call indocc(oj,x40,eps0,nti,epsd,a0(j),ax(1,j),
     1                            ay(1,j),kmods(j),kfs(j),1)
                      if(kfx(j).gt.0) call indoccx(oj,x40,eps0,nti,epsd,
     1                           uy(1,kmodx(j),j),uy(2,kmodx(j),j))
                      call indpos(xdj,x40,eps0,nti,epsd,uxj,uyj,kmodx(j)
     1                           ,kfx(j),1)
                      t=tzeroi-dti
                      dummx=-9999.
                      dummn= 9999.
                      dumav=0.
                      y340=y3p(4)
c    stale otazka jak je to molekularni
                      npom=0
                      do 2700kt=1,nti
                        t=t+dti
                        if(oi(kt).le.ocut.or.oj(kt).le.ocut) go to 2700
                        npom=npom+1
                        if(iswj.eq.iswi) then
                          do 2651l=1,3
                            um(l,kt)=up(l)+xdj(l,kt)-xdi(l,kt)
2651                      continue
                        else
                          y3p(4)=y340+t/tnat
                          call qbyx(xdj(1,kt),yp(4),iswj)
                          yp(4)=yp(4)+y3p(4)
                          do 2660l=1,3
                            yp(l)=y3p(l)+xdj(l,kt)
2660                      continue
                          call multm(wprij,yp,ypp,4,4,1)
                          do 2662l=1,3
                            um(l,kt)=ypp(l)-x1p(l)-xdi(l,kt)
2662                      continue
                        endif
                        call multm(g(1,iswi),um(1,kt),umg,3,3,1)
                        dum(kt)=sqrt(scalmul(um(1,kt),umg))
                        dummx=max(dum(kt),dummx)
                        if(dum(kt).lt.dummn) then
                          dummn=dum(kt)
                          ktmin=kt
                        endif
                        dumav=dumav+dum(kt)
2700                  continue
                      if(npom.gt.0.and.dummn.le.dmhi) then
                        write(61,117) atom(i),atom(j),du,isdu,t80
                        write(89,116) atom(i),atom(j),du,sdu,t7
                        if(ittab.le.1) then
                          call fflush
                          if(iswi.eq.iswj) then
                            dumav=dumav/float(npom)
                            call fflush
                            line=line+1
                            write(iven(line),'(1x,''ave'',9x,f7.4,12x)')
     1                            dumav
                            call fflush
                            line=line+1
                            write(iven(line),'(1x,''min'',9x,f7.4,12x)')
     1                            dummn
                            call fflush
                            line=line+1
                            write(iven(line),'(1x,''max'',9x,f7.4,12x)')
     1                              dummx
                            call fflush
                          else
                            call fflush
                            line=line+1
                            write(iven(line),'(1x,''min'',9x,f7.4,12x)')
     1                            dummn
                            if(ktmin.eq.1.or.ktmin.eq.nti)
     1                            iven(line)(9:9)='<'
                            call fflush
                          endif
                        endif
                      else
                        if(ittab.le.1) line=max(line-1,0)
                        go to 7400
                      endif
                      call fflush
                      if(ieach.ne.0) then
                        t=tzeroi
                        l=0
                        do 2800kt=1,nti,ieach
                          l=l+1
                          if(oi(kt).gt.ocut.and.oj(kt).gt.ocut) then
                            if(ittab.le.1) then
                              call fflush
                              line=line+1
                              write(iven(line),'(1x,f5.3,7x,f7.4,12x)')
     1                              t,dum(kt)
                              if(oi(kt).le.oind.or.oj(kt).le.oind)
     1                           iven(line)(1:1)='*'
                              call fflush
                            endif
                            write(88) atom(i),atom(j),l,dum(kt)
                          endif
                          t=t+dti*float(ieach)
2800                    continue
                      endif
                      if(ittab.le.1) then
                        call fflush
                        line=line+1
                        write(iven(line),'(26(''-''))')
                        call fflush
                      endif
3000                  if(.not.iuhl0) then
                        call uhelat(i,j,t7)
                        call fflush
                      endif
                      write(88) konec,atom(j),1,1.
7400                continue
7500              continue
7600            continue
7700          continue
7800        continue
7900      continue
8000    continue
        write(61,119)
        if(ittab.le.1) then
          call fflush
          line=line+1
          iven(line)='*'
          call fflush
        endif
8100  continue
      if(line.gt.0.and.ittab.le.1) call outst(iven)
      if(ndim.le.3.or.ittab.lt.1) then
        close(88,status='delete')
        return
      endif
      line=0
      do 9000i=1,nacalc
        if(isf(i).le.0.or..not.brat(i)) go to 9000
        iswi=iswa(i)
        call newln(3)
        write(lst,'(40x,38(''*''))')
        write(lst,'(40x,''** Coordination for atom : '',a8,'' **'')')
     1        atom(i)
        write(lst,'(40x,38(''*''))')
        rewind 88
        tzeroi=tzero(iswi)
        dti=dt(iswi)
        nti=nt(iswi)
        dmhij=dmhi
        t=tzeroi
        l=0
        ip=333
        do 8800kt=1,nti,ieach
          l=l+1
          ntb=0
          do 8150m=1,30
            nutab(m)=0
8150      continue
          rewind 88
8200      read(88,end=8320) at1,at2,ktp,pom
8300      if(at1.ne.atom(i).or.ktp.ne.l) go to 8200
          if(pom.le.dmhij) then
            if(ntb.lt.30) then
              ntb=ntb+1
              attab(ntb)=at2
              idtab(ntb)=nint(pom*10000.)
            else
              call FeChybne(-1.,-1.,'the maximum number of 30 '//
     1                      'neighbours exceeded',' ',1,1)
              ErrJana=1
              return
            endif
          else
8305        read(88,end=8320) at1,at2,ktp,pom
            if(at1.ne.'[konec]') go to 8305
            go to 8200
          endif
8310      read(88,end=8320) at1,at2,ktp,pom
          if(at1.eq.'[uhel]') then
            if(ktp.eq.l.and.ntb.ne.0.and.pom.gt.-1000.) then
              nutb=nutab(ntb)+1
              if(nutb.le.30) then
                nutab(ntb)=nutb
                atutab(nutb,ntb)=at2
                utab(nutb,ntb)=pom
              else
                call FeChybne(-1.,-1.,'the maximum number of 30 '//
     1                        'neighbours exceeded',' ',1,1)
                ErrJana=1
                return
              endif
            endif
            go to 8310
          endif
          if(at1.eq.'[konec]') then
            go to 8200
          else
            go to 8310
          endif
8320      if(ip.gt.111) then
            if(ip.ne.333) then
              do 8350n=1,lmax
                if(n.eq.1) then
                  call newln(3)
                  write(lst,120)
                  write(lst,'(1x,132a1)')(ltab(n)(k:k),k=1,
     1                                                   idel(ltab(n)))
                  write(lst,120)
                else
                  call newln(1)
                  write(lst,'(1x,132a1)')(ltab(n)(k:k),k=1,
     1                                                   idel(ltab(n)))
                endif
8350          continue
            endif
            lmax=0
            do 8360n=1,444
              ltab(n)=' '
              do 8355ip=1,132,26
                ltab(n)(ip:ip)='|'
8355          continue
8360        continue
            ip=3
          endif
          n=0
          n=n+1
          write(ltab(n)(ip:ip+23),'(6x,'' t='',f6.3)') t
          if(ntb.gt.0) then
            call indexx(ntb,idtab,iptab)
            do 8400j=1,ntb
              k=iptab(j)
              n=n+1
              write(ltab(n)(ip:ip+23),'(a8,7x,f8.4)') attab(k),
     1                                  float(idtab(k))*.0001
              do 8370m=0,14
                if(ltab(n)(ip+m:ip+m).eq.' ') ltab(n)(ip+m:ip+m)='.'
8370          continue
              do 8390m=j,nutab(k)
                jj=iptab(m+1)
                if(jj.ge.k) jj=jj-1
                n=n+1
                write(ltab(n)(ip:ip+23),'(3x,a8,4x,f8.2)') atutab(jj,k),
     1                                                       utab(jj,k)
                do 8380mm=3,14
                  if(ltab(n)(ip+mm:ip+mm).eq.' ')
     1                                    ltab(n)(ip+mm:ip+mm)='.'
8380            continue
8390          continue
8400        continue
          endif
          t=t+dti*float(ieach)
          lmax=max(n,lmax)
          ip=ip+26
8800    continue
        if(ip.gt.3) then
          do 8810l=1,lmax
            if(l.eq.1) then
              call newln(3)
              write(lst,120)
              write(lst,'(1x,132a1)')(ltab(l)(kt:kt),kt=1,idel(ltab(l)))
              write(lst,120)
            else
              call newln(1)
              write(lst,'(1x,132a1)')(ltab(l)(kt:kt),kt=1,idel(ltab(l)))
            endif
8810      continue
        endif
        call newln(1)
        write(lst,120)
9000  continue
      close(88,status='delete')
      return
102   format(26('*'),6x)
103   format('* atom ',a8,10x,'*',6x)
104   format(a8,5('.'),f7.4,'(',i4,')',6x)
105   format(2x,a8,'...',f7.2,'(',i4,')',6x)
116   format('distance: ',2a8,2f9.4,' .',7x,a7)
117   format(a8,' - ',a8,5x,f8.4,'(',i4,')  symmetry : ',a50)
118   format(a8,' - ',a8,' - ',a8,5x,f8.2,'(',i4,') symmetry : ',a50)
119   format(120('-'))
120   format(1x,131('-'))
      end
      subroutine uhelat(i,j,t7)
      include 'params.cmn'
      include 'basic.cmn'
      include 'atoms.cmn'
      include 'dist.cmn'
      include 'fepc.cmn'
      dimension z0(6),z1(6),z2(3),vz(3),shk(3),shkc(3),dam(mxt),vm(3),
     1          vmg(3),xdk(3,mxt),ok(mxt),uxk(3,mxw),uyk(3,mxw),zp(6),
     2          sx0(6),z0p(6),z1p(6),z2p(3),vzp(3),vp(3),wprik(36),
     3          gw4(3),wpriki(36),nvx(3),nvy(3),nvz(3),zpp(6),z3(6),
     4          z3p(6),ksh(3)
      character*80 t80
      character*40 t40
      character*8 label
      character*7 t7,t7p
      data label/'[uhel]'/
      if(ndim.eq.3) then
        kp=j
      else
        kp=1
      endif
      do 8000k=kp,nacalc
        l=isf(k)
        if(l.eq.0) go to 8000
        iswk=iswa(k)
        if(iswk.ne.iswi) then
          l=iswi*10+iswk
          if(l.ne.iswki) then
            call multm(zv(1,iswi),zvi(1,iswk),wprik,4,4,4)
            call matinv(wprik,wpriki,det,4)
            do 2040l=1,3
              nvz(l)=nint(wpriki(l+12))
2040        continue
            kolik=0
            do 2042l=1,3
              nvx(l)=0
              nvy(l)=0
              if(nvz(l).ne.0) then
                kolik=kolik+1
                kdeneni=l
              else
                kdeje=l
              endif
2042        continue
            if(kolik.eq.3) then
              nvx(1)=1
              nvy(2)=1
            else if(kolik.eq.2) then
              nvx(mod(kdeje-1,3)+1)=1
              nvy(mod(kdeje,3)+1)=1
            else
              nvx(mod(kdeneni,3)+1)=1
              nvy(mod(kdeneni+1,3)+1)=1
            endif
            call multm(g(1,iswi),wprik(13),gw4,3,3,1)
            gww=scalmul(gw4,wprik(13))
            tnat=wprik(ndimq)-scalmul(qu(1,1,iswi),wprik(13))
          endif
        else
          tnat=1.
        endif
        iswki=l
        tztnat=tzeroi/tnat
        dttnat=dti/tnat
        dmhik=dmhi+dx(i)+dx(k)
        mxcellx=dmhik*rcp(1,iswk)+1
        mxcelly=dmhik*rcp(2,iswk)+1
        mxcellz=dmhik*rcp(3,iswk)+1
        dmdikq=dmdi**2
        dmhika=dmhik*ah
        dmhikb=dmhik*bh
        dmhikc=dmhik*ch
        dmhikq=dmhik**2
        do 2050l=1,3
          z0(l)=xdst(l,k)
          z0p(l)=x(l,k)
          sx0(l)=sx(l,k)
2050    continue
        ks=0
        kst=0
        do 7900ksym=1,ns
          call multm(rm(1,ksym,iswk),z0,z1,3,3,1)
          call multm(rm(1,ksym,iswk),z0p,z1p,3,3,1)
          call multmq(rm(1,ksym,iswk),sx0,sgx(7),3,3,1)
          eps=rm6(16,ksym,iswk)
          do 2100l=1,3
            z1(l)=z1(l)+s6(l,ksym,iswk)
            z1p(l)=z1p(l)+s6(l,ksym,iswk)
2100      continue
          do 7800kcntrsm=1,3-ncs
            ks=ks+1
            if(isa(ks,k).le.0) go to 7800
            if(kcntrsm.ne.1) then
              eps=-eps
              do 2200l=1,3
                z1(l)=-z1(l)+s6(l,ksym,iswk)*2.
                z1p(l)=-z1p(l)+s6(l,ksym,iswk)*2.
2200          continue
            endif
            do 7700kcenter=1,nvt
              do 2300l=1,3
                z2(l)=z1(l)+vt6(l,kcenter,iswk)
                z2p(l)=z1p(l)+vt6(l,kcenter,iswk)
2300          continue
              ts4=s6(4,ksym,iswk)+vt6(4,kcenter,iswk)
              if(iswk.eq.iswi) then
                call bunka(z2,shk,1)
                do 2310l=1,3
                  vzp(l)=z2p(l)-x1p(l)+shk(l)
                  vz(l)=z2(l)-x1(l)
2310            continue
              else
                call multm(wpriki,x1,zp,ndim,ndim,1)
                do 2320l=1,3
                  shk(l)=zp(l)-z2(l)
2320            continue
                do 2330l=1,3
                  shk(l)=ifix(shk(l))
                  z2(l)=z2(l)+shk(l)
                  z2p(l)=z2p(l)+shk(l)
2330            continue
              endif
              do 7600kcellx=-mxcellx,mxcellx
                cellxk=kcellx
                if(iswk.eq.iswi) then
                  pom=vz(1)+cellxk
                  if(abs(pom).gt.dmhika) go to 7600
                  v(1)=pom
                  vp(1)=vzp(1)+cellxk
                  z2(1)=z2(1)+cellxk
                  z2p(1)=z2p(1)+cellxk
                  ksh(1)=nint(shk(1))+kcellx
                  shkc(1)=shk(1)+cellxk+s6(1,ksym,iswk)+
     1                    vt6(1,kcenter,iswk)
                endif
                do 7500kcelly=-mxcelly,mxcelly
                  cellyk=kcelly
                  if(iswk.eq.iswi) then
                    pom=vz(2)+cellyk
                    if(abs(pom).gt.dmhikb) go to 7500
                    v(2)=pom
                    vp(2)=vzp(2)+cellyk
                    z2(2)=z2(2)+cellyk
                    z2p(2)=z2p(2)+cellyk
                    kcellzp=-mxcellz
                    kcellzk= mxcellz
                    ksh(2)=nint(shk(2))+kcelly
                    shkc(2)=shk(2)+cellyk+s6(2,ksym,iswk)+
     1                      vt6(2,kcenter,iswk)
                  else
                    do 2420l=1,3
                      pom=cellxk*float(nvx(l))+cellyk*float(nvy(l))
                      z3(l)=z2(l)+pom
                      z3p(l)=z2p(l)+pom
                      shkc(l)=shk(l)+pom+s6(l,ksym,iswk)+
     1                        vt6(l,kcenter,iswk)
                      ksh(l)=nint(shk(l)+pom)
2420                continue
                    call qbyx(z3,z3(4),iswk)
                    call multm(wprik,z3,zp,ndim,ndim,1)
                    do 2425l=1,3
                      v(l)=zp(l)-x1(l)
2425                continue
                    v1=scalmul(gw4,v)
                    call multm(g(1,iswi),v,vg,3,3,1)
                    dv=scalmul(v,vg)-v1**2/gww
                    if(dv.gt.dmhikq) go to 7500
                    dv=sqrt(dv)
                    call angulus(angle,isu)
                    tmin=-v1/gww*tnat
                    it=tmin
                    if(tmin.lt.0.) it=it-1
                    do 2430l=1,3
                      pom=-it*nvz(l)
                      z3(l)=z3(l)+pom
                      z3p(l)=z3p(l)+pom
                      shkc(l)=shkc(l)+pom
                      ksh(l)=ksh(l)+nint(pom)
2430                continue
                    tmin=tmin-float(it)
                    kcellzk=0
2442                do 2443l=1,3
                      zp(l)=z3(l)+float(nvz(l)*(kcellzk+1))
2443                continue
                    call qbyx(zp,zp(4),iswk)
                    zp(4)=zp(4)+xdmx/tnat
                    call multm(wprik,zp,zpp,4,4,1)
                    do 2444l=1,3
                      v(l)=zpp(l)-x1(l)
2444                continue
                    call multm(g(1,iswi),v,vg,3,3,1)
                    pom=scalmul(v,vg)
                    tminp=tmin+float(kcellzk+1)
                    if(pom.lt.dmhikq.or.
     1                 (tminp.ge.xdmn.and.tminp.le.xdmx)) then
                      kcellzk=kcellzk+1
                      go to 2442
                    endif
                    kcellzp=0
2452                do 2453l=1,3
                      zp(l)=z3(l)+float(nvz(l)*(kcellzp-1))
2453                continue
                    call qbyx(zp,zp(4),iswk)
                    zp(4)=zp(4)+xdmn/tnat
                    call multm(wprik,zp,zpp,4,4,1)
                    do 2454l=1,3
                      v(l)=zpp(l)-x1(l)
2454                continue
                    call multm(g(1,iswi),v,vg,3,3,1)
                    pom=scalmul(v,vg)
                    tminp=tmin+float(kcellzp-1)
                    if(pom.lt.dmhikq.or.
     1                 (tminp.ge.xdmn.and.tminp.le.xdmx)) then
                      kcellzp=kcellzp-1
                      go to 2452
                    endif
                    do 2455l=1,3
                      pom=float(nvz(l)*(kcellzp-1))
                      z3p(l)=z3p(l)+pom
                      z3 (l)=z3 (l)+pom
                      shkc(l)=shkc(l)+pom
                      ksh(l)=ksh(l)+nint(pom)
2455                continue
                  endif
                  do 7400kcellz=kcellzp,kcellzk
                    kst=kst+1
                    cellzk=kcellz
                    if(k.eq.j.and.kst.eq.jst) go to 7400
                    if(iswk.eq.iswi) then
                      pom=vz(3)+cellzk
                      if(abs(pom).gt.dmhikc) go to 7400
                      v(3)=pom
                      vp(3)=vzp(3)+cellzk
                      z2(3)=z2(3)+cellzk
                      z2p(3)=z2p(3)+cellzk
                      shkc(3)=shk(3)+cellzk+s6(3,ksym,iswk)+
     1                        vt6(3,kcenter,iswk)
                      ksh(3)=nint(shk(3))+kcellz
                      call multm(g(1,iswi),v,vg,3,3,1)
                      vv=scalmul(v,vg)
                      if(vv.gt.dmhikq.or.vv.lt.dmdikq) go to 7400
                      if(vv.eq.0..and.i.eq.k) go to 7400
                      dv=sqrt(vv)
                      do 2500l=1,3
                        if(dv.ne.0.) then
                          ddx(l+3)=vg(l)/dv
                        else
                          ddx(l+3)=0.
                        endif
                        ddx(l)=-ddx(l+3)
2500                  continue
                      call angulus(angle,isu)
                    else
                      do 2510l=1,3
                        pom=nvz(l)
                        z3 (l)=z3 (l)+pom
                        z3p(l)=z3p(l)+pom
                        shkc(l)=shkc(l)+pom
                        ksh(l)=ksh(l)+nint(pom)
2510                  continue
                    endif
                    call qbyx(z3,z3(4),iswk)
                    call qbyx(z3p,z3p(4),iswk)
                    call scode(ksym,kcntrsm,kcenter,shkc,ksh,iswk,t80,
     1                         t40)
                    call ScodeCIF(ksym,kcntrsm,kcenter,ksh,iswk,t7p)
                    if(ndim.eq.3) then
                      write(61,118) atom(j),atom(i),atom(k),angle,isu,
     1                              t80
                      write(89,116) atom(j),atom(i),atom(k),angle,
     1                              float(isu)*.01,t7,t7p
                    endif
                    if(ittab.le.1) then
                      call fflush
                      line=line+1
                      write(iven(line),105) atom(k),angle,isu
                      do 2530l=3,10
                        if(iven(line)(l:l).eq.' ') iven(line)(l:l)='.'
2530                  continue
                      call fflush
                    endif
                    if(nti.le.0.or.ndim.ne.4) go to 7400
                    do 2600m=1,kmodx(k)
                      call multm(rm(1,ksym,iswk),ux(1,m,k),uxk(1,m),3,3,
     1                           1)
                      if(kfx(k).eq.0.or.m.ne.kmodx(k)) then
                        call multm(rm(1,ksym,iswk),uy(1,m,k),uyk(1,m),3,
     1                             3,1)
                      else
                        do 2540l=1,3
                          uyk(l,m)=uy(l,m,k)
2540                    continue
                      endif
                      if(kcntrsm.eq.2) then
                        do 2550l=1,3
                          uxk(l,m)=-uxk(l,m)
                          if(kfx(k).eq.0.or.m.ne.kmodx(k))
     1                       uyk(l,m)=-uyk(l,m)
2550                    continue
                      endif
2600                continue
                    call qbyx(shkc,qx,iswk)
                    x40=qcnt(1,k)+eps*(qx(1)-ts4)
                    eps0=eps*tztnat
                    epsd=eps*dttnat
                    call indocc(ok,x40,eps0,nti,epsd,a0(k),ax(1,k),
     1                          ay(1,k),kmods(k),kfs(k),1)
                    if(kfx(k).gt.0) call indoccx(ok,x40,eps0,nti,epsd,
     1                         uy(1,kmodx(k),k),uy(2,kmodx(k),k))
                    call indpos(xdk,x40,eps0,nti,epsd,uxk,uyk,kmodx(k),
     1                          kfx(k),1)
                    t=tzeroi-dti
                    dammx=-9999.
                    dammn= 9999.
                    damav=0.
                    npom=0
                    z340=z3p(4)
                    do 2700kt=1,nti
                      t=t+dti
                      if(oi(kt).le.ocut.or.oj(kt).le.ocut.
     1                                  or.ok(kt).le.ocut) go to 2700
                      npom=npom+1
                      if(iswk.eq.iswi) then
                        do 2651l=1,3
                          vm(l)=vp(l)+xdk(l,kt)-xdi(l,kt)
2651                    continue
                      else
                        z3p(4)=z340+t/tnat
                        call qbyx(xdk(1,kt),zp(4),iswk)
                        zp(4)=zp(4)+z3p(4)
                        do 2660l=1,3
                          zp(l)=z3p(l)+xdk(l,kt)
2660                    continue
                        call multm(wprik,zp,zpp,4,4,1)
                        do 2662l=1,3
                          vm(l)=zpp(l)-x1p(l)-xdi(l,kt)
2662                    continue
                      endif
                      call multm(g(1,iswi),vm,vmg,3,3,1)
                      dvp=sqrt(scalmul(vm,vmg))
                      if(dvp.le.dmhi) then
                        pom=scalmul(um(1,kt),vmg)/(dum(kt)*dvp)
                        if(abs(pom).ge.1.) then
                          pom=90.-sign(90.,pom)
                        else
                          pom=acos(pom)/torad
                        endif
                      else
                        npom=npom-1
                        dam(kt)=-1600.
                        go to 2700
                      endif
                      dam(kt)=pom
                      dammx=max(dam(kt),dammx)
                      dammn=min(dam(kt),dammn)
                      damav=damav+dam(kt)
2700                continue
                    if(npom.gt.0) then
                      write(89,116) atom(j),atom(i),atom(k),angle,
     1                              float(isu)*.01,t7,t7p
                      write(61,118) atom(j),atom(i),atom(k),angle,isu,
     1                              t80
                      if(ittab.le.1) then
                        if(iswi.eq.iswk) then
                          call fflush
                          damav=damav/float(npom)
                          line=line+1
                          write(iven(line),'(3x,''ave'',7x,f7.2,12x)')
     1                          damav
                          call fflush
                          line=line+1
                          write(iven(line),'(3x,''min'',7x,f7.2,12x)')
     1                          dammn
                          call fflush
                          line=line+1
                          write(iven(line),'(3x,''max'',7x,f7.2,12x)')
     1                          dammx
                          call fflush
                        endif
                        call fflush
                      endif
                    else
                      if(ittab.le.1) line=max(line-1,0)
                      go to 7400
                    endif
                    if(ieach.ne.0) then
                      t=tzeroi
                      l=0
                      do 2800kt=1,nti,ieach
                        l=l+1
                        if(oi(kt).gt.ocut.and.oj(kt).gt.ocut.and.
     1                     ok(kt).gt.ocut.and.dam(kt).gt.-1000.) then
                          pom=dam(kt)
                          if(ittab.le.1) then
                            call fflush
                            line=line+1
                            write(iven(line),'(3x,f5.3,5x,f7.2,12x)')
     1                            t,pom
                            if(oi(kt).le.oind.or.oj(kt).le.oind
     1                                       .or.ok(kt).le.oind)
     2                         iven(line)(2:2)='*'
                            call fflush
                          endif
                          write(88) label,atom(k),l,dam(kt)
                        endif
                        t=t+dti*ieach
2800                  continue
                    endif
                    if(ittab.le.1) then
                      call fflush
                      line=line+1
                      write(iven(line),'(26(''-''))')
                      call fflush
                    endif
7400              continue
7500            continue
7600          continue
7700        continue
7800      continue
7900    continue
8000  continue
      return
105   format(2x,a8,'...',f7.2,'(',i4,')',6x)
116   format('angle: ',3a8,2f9.4,1x,a7,' .',7x,a7)
118   format(a8,' - ',a8,' - ',a8,5x,f8.2,'(',i4,') symmetry : ',a50)
      end
      subroutine fflush
      include 'params.cmn'
      include 'basic.cmn'
      include 'dist.cmn'
      if(line.eq.mxl) then
        call outst(iven)
        line=mxline
        call newpg(0)
        line=0
        mxl=mxl4
      endif
      return
      end
      subroutine ScodeCIF(jsym,jcntrsm,jcenter,jsh,isw,t7)
      include 'params.cmn'
      include 'basic.cmn'
      dimension jsh(3),jshp(3)
      character*(*) t7
      do 1000i=1,3
       jshp(i)=jsh(i)+5
       if(abs(vt6(i,jcenter,isw)+s6(i,jsym,isw)).gt..999)
     1   jshp(i)=jshp(i)-1
1000  continue
      write(t7,'(i3,''_'',3i1)')(jcenter-1)*ns*nvt+(jcntrsm-1)*ns+jsym,
     1                           jshp
      call zhusti(t7)
      if(t7.eq.'1_555') t7='.'
      return
      end
      subroutine DefaultDist
      include 'params.cmn'
      include 'basic.cmn'
      include 'dist.cmn'
      NactiInt=10
      NactiReal=10
      NactiComposed=5
      NactiKeys=NactiInt+NactiReal+NactiComposed
      do 1000i=1,NactiInt
        NacetlInt(i)=DefIntDist(i)
        DefaultInt(i)=DefIntDist(i)
1000  continue
      do 1100i=NactiInt+1,NactiInt+NactiReal
        NacetlReal(i)=DefRealDist(i)
        DefaultReal(i)=DefIntDist(i)
1100  continue
      do 1200i=1,NactiKeys
        NactiKeywords(i)=IdDist(i)
1200  continue
      irnd=DefIntDist(1)
      iuhl=DefIntDist(2)
      fullcoo=DefIntDist(3)
      ieach=DefIntDist(4)
      incl=DefIntDist(5)
      ittab=DefIntDist(6)
      dmdk=DefRealDist(11)
      dmhk=DefRealDist(12)
      ocut=DefRealDist(13)
      oind=DefRealDist(14)
      do 1300i=1,3
        nt(i)=100
        tzero(i)=0.
1300  continue
      isel=0
      return
      end
      subroutine SetCommandsDist
      include 'params.cmn'
      include 'basic.cmn'
      include 'atoms.cmn'
      include 'dist.cmn'
      include 'fepc.cmn'
      character*80 t80
      character*21 Men(5)
      integer FeMenu
      logical Prvne
      data Men/'%Basic commands','%Selection command',
     1         '%Torsion angles','%Planes','%Modulation commands'/
      call RewriteTitle('JANA98','DIST-commands')
      call DefaultDist
      open(m40,file=fln(1:ifln)//'.m40')
      open(m50,file=fln(1:ifln)//'.m50')
      open(lst,file=CmdFileName(1:LCmdFileName))
      call iom50(0,0)
      if(ErrJana.ne.0) return
      call najdi('dist',i)
      NacetlReal(12)=-1.
      if(i.eq.1) call NactiDist
      close(lst)
      do 1000i=24,25
        call MakeKeyWordFile(NactiKeywords(i)(1:idel(NactiKeywords(i))),
     1                       'dist')
1000  continue
      call MakeStarFile('dist')
      close(m50)
      call iom40(0,0)
      close(m40)
      open(lst,file=CmdFileName(1:LCmdFileName))
      call pisat
      close(lst)
      call FeButtonOff(1)
      call FeButtonOff(7)
      Prvne=.true.
      if(ndim.eq.3) then
        nmen=4
      else
        nmen=5
      endif
1100  if(Prvne) then
        EventNumber=7
        EventType=1
      else
        call FeEvent(0)
      endif
1110  if(EventType.ne.1.or.EventNumber.gt.9) go to 1100
      Prvne=.true.
      if(EventNumber.eq.1) then
        call FeButtonOn(1)
        call WriteKeys('dist')
        if(ndim.gt.3) then
          nd=ndimi
          do 1120i=1,nd
            if(nt(i).ne.100) then
              write(t80,'(3i10)')(nt(j),j=1,nd)
              call ZdrcniCisla(t80,nd)
              t80=NactiKeywords(21)(1:5)//' '//t80(1:idel(t80))
              write(55,FormA1)(t80(j:j),j=1,idel(t80))
              go to 1130
            endif
1120      continue
1130      do 1140i=1,nd
            if(tzero(i).ne.0.) then
              write(t80,'(3f8.6)')(tzero(j),j=1,nd)
              call ZdrcniCisla(t80,nd)
              t80=NactiKeywords(22)(1:5)//' '//t80(1:idel(t80))
              write(55,FormA1)(t80(j:j),j=1,idel(t80))
              go to 1150
            endif
1140      continue
        endif
1150    do 1160i=1,nacalc
          if(.not.brat(i)) then
            t80='select'
            do 1155j=1,nacalc
              if(brat(j)) then
                if(idel(t80).gt.72) then
                  write(55,FormA1)(t80(k:k),k=1,idel(t80))
                  t80='select'
                endif
                t80=t80(1:idel(t80))//' '//atom(j)
              endif
1155        continue
            if(idel(t80).gt.6) write(55,FormA1)(t80(k:k),k=1,idel(t80))
            go to 1170
          endif
1160    continue
1170    do 1200i=24,25
           call MergeFileToM50(NactiKeywords(i))
1200    continue
        call MergeFileToM50('star')
        write(55,'(''end'')')
        call DopisKeys('dist',0)
        call RewriteTitle('DIST-commands','JANA98')
       return
      else if(EventNumber.eq.7) then
        call FeButtonOn(7)
        i=FeMenu(-1.,-1.,men,1,nmen,1,0)
        if(i.ge.1.and.i.le.5) call RightButAc('disable')
        if(i.eq.1) then
          call BasicCommandsD
        else if(i.eq.2) then
          call SelAtoms('The central atoms for distance calculation',
     1                  Atom,Brat,isf,nacalc,.false.,ich)
        else if(i.eq.3) then
          call ReadTorsion
        else if(i.eq.4) then
          call ReadPlane
        else if(i.eq.5) then
          call ModulationCommandsD
        else
          if(EventNumber.eq.1.and.EventType.eq.1) then
            go to 1110
          else
            call FeButtonOff(7)
            Prvne=.false.
            go to 1100
          endif
        endif
      endif
      call RightButAc('refresh')
      go to 1100
      end
      subroutine BasicCommandsD
      include 'params.cmn'
      include 'basic.cmn'
      include 'fepc.cmn'
      character*80 t80
      call FeQuestCreate(1,-1.,-1.,220.,0,9,'Basic commands',0)
      call FeQuestEdwMake(1,5.,1,30.,1,'%Title','L',185.,8.,0)
      call FeQuestEdwOpen(1,i,Title,pom,0)
      call FeQuestCrwMake(1,5.,2,100.,2,'%Round input coordinates','L',
     1                    6.,6.,0,0)
      call FeQuestCrwMake(1,145.,2,207.,2,'%Calculate angles','L',6.,6.,
     1                    0,0)
      call FeQuestCrwMake(1,5.,3,100.,3,'List %full coordination','L',
     1                    6.,6.,0,0)
      do 1000i=1,3
        call FeQuestCrwOpen(i,NacetlInt(i).eq.1)
        if(i.ne.1) then
          if(i.eq.2) then
            t80='d(mi%n)'
          else
            t80='d(ma%x)'
          endif
          ip=i+2
          call FeQuestEdwMake(1,145.,ip,170.,ip,t80,'L',45.,8.,0)
          if(i.eq.2) then
            call FeQuestEdwOpen(i,ip,Title,NacetlReal(11),1)
          else
            call FeQuestCrwMake(1,5.,ip,125.,ip,'d(max) according '//
     1                          'to chemical t%ype','L',6.,6.,1,0)
            call FeQuestCrwOpen(4,NacetlReal(12).lt.0.)
          endif
        endif
1000  continue
      call FeQuestLineMake(1,6)
      call FeQuestLabelMake(1,110.,7,'Include peaks from Fourier '//
     1                      'calculation','C')
      xpom=27.5
      do 1100i=1,4
        if(i.eq.1) then
          t80='n%one'
        else if(i.eq.2) then
          t80='m%axima'
        else if(i.eq.3) then
          t80='m%inima'
        else
          t80='%both'
        endif
        call FeQuestCrwMake(1,xpom,8,xpom-4.,9,t80,'C',8.,8.,0,1)
        call FeQuestCrwOpen(i+4,NacetlInt(5).eq.i-1)
        xpom=xpom+55.
1100  continue
      icont=0
2000  if(.not.CrwLogic(CrwFr+3)) call FeQuestEdwOpen(3,ip,Title,
     1                                         NacetlReal(12),1)
2500  call FeQuestEvent(1,icont,ich)
      icont=1
      if(CheckType.eq.3.and.CheckNumber.eq.4) then
        if(CrwLogic(CrwFr+3)) then
          EventType=0
          NacetlReal(12)=-1.
          call FeQuestEdwClose(3)
        else
          NacetlReal(12)=2.5
          EventType=2
          EventNumber=3
          go to 2000
        endif
        go to 2500
      else if(CheckType.ne.0) then
        call NebylOsetren
        go to 2500
      endif
      if(ich.eq.0) then
        do 3000i=1,3
          if(CrwLogic(i+CrwFr-1)) then
            nacetlInt(i)=1
          else
            nacetlInt(i)=0
          endif
3000    continue
        do 3100i=5,8
          if(CrwLogic(i+CrwFr-1)) then
            NacetlInt(5)=i-5
            go to 3300
          endif
3100    continue
3300    call FeQuestGetFromEdw(1,i,Title,xpom,CrwLogic)
        call FeQuestGetFromEdw(2,ip,Title,NacetlReal(11),CrwLogic)
        if(.not.CrwLogic(4)) call FeQuestGetFromEdw(3,ip,Title,
     1                                  NacetlReal(12),CrwLogic)
      endif
      call FeQuestRemove(1)
      return
      end
      subroutine ModulationCommandsD
      include 'params.cmn'
      include 'basic.cmn'
      include 'dist.cmn'
      include 'fepc.cmn'
      call FeQuestCreate(1,-1.,-1.,140.,0,6,'Modulation commands',0)
      call FeQuestEdwMake(1,5.,1,105.,1,'%Number of t values','L',30.,
     1                    8.,0)
      call FeQuestEdwOpen(1,nt,Title,pom,-ndim+3)
      call FeQuestEdwMake(1,5.,2,105.,2,'%Initial t','L',30.,8.,0)
      call FeQuestEdwOpen(2,i,Title,tzero,ndimi)
      call FeQuestEdwMake(1,5.,3,105.,3,'%Print t period','L',30.,8.,0)
      call FeQuestEdwOpen(3,NacetlInt(4),Title,tzero,-1)
      call FeQuestCrwMake(1,5.,4,105.,4,'Make coordination t-%tables',
     1                    'L',6.,6.,0,0)
      call FeQuestCrwOpen(1,NacetlInt(6).eq.1)
      call FeQuestEdwMake(1,5.,5,105.,5,'Occupancy %calculation limit',
     1                    'L',30.,8.,0)
      call FeQuestEdwOpen(4,i,Title,NacetlReal(13),1)
      call FeQuestEdwMake(1,5.,6,105.,6,'Occupancy in%dication limit',
     1                    'L',30.,8.,0)
      call FeQuestEdwOpen(5,i,Title,NacetlReal(14),1)
      icont=0
2500  call FeQuestEvent(1,icont,ich)
      icont=1
      if(CheckType.ne.0) then
        call NebylOsetren
        go to 2500
      endif
      if(ich.eq.0) then
        if(CrwLogic(CrwFr)) then
          NacetlInt(6)=1
        else
          NacetlInt(6)=0
        endif
        call FeQuestGetFromEdw(1,nt,Title,pom,CrwLogic)
        call FeQuestGetFromEdw(2,i,Title,tzero,CrwLogic)
        call FeQuestGetFromEdw(3,NacetlInt(4),Title,pom,CrwLogic)
        do 2600i=4,5
          call FeQuestGetFromEdw(i,ip,Title,NacetlReal(i+9),CrwLogic)
2600    continue
      endif
      call FeQuestRemove(1)
      return
      end
      subroutine ReadTorsion
      include 'params.cmn'
      include 'basic.cmn'
      include 'atoms.cmn'
      include 'dist.cmn'
      include 'fepc.cmn'
      character*80 t80,p80,t80old
      character*7  prazdno
      character*4  t4
      character*2  nty
      logical novy,FeYesNo,Enable
      data prazdno/'torsion'/
      ln=NextLogicNumber()
      open(ln,file='torsion.tmp')
      n=0
1000  read(ln,FormA80,end=1010) t80
      n=n+1
      go to 1000
1010  close(ln)
      call FeQuestCreate(1,-1.,-1.,200.,0,5,' ',1)
      call RepeatCommandsBottom(n.ne.0,'torsion angle',4)
      xpom=5.
      do 1050i=1,4
        write(t4,'(''%'',i1,a2)') i,nty(i)
        call FeQuestEdwMake(1,xpom+20.,2,xpom,3,t4//' atom','C',40.,8.,
     1                      1)
        xpom=xpom+50.
1050  continue
      kterou=n
      icont=0
      if(n.le.0) t80=prazdno
1100  call RepeatCommandsUpDown(Kterou,n)
      novy=.true.
      if(Kterou.le.n) then
        open(ln,file='torsion.tmp')
        do 1110i=1,kterou
          read(ln,FormA80) t80
1110    continue
        close(ln)
      endif
      k=0
      call kus(t80,k,p80)
      enable=t80(1:1).ne.'!'
      do 1200i=1,4
        call kus(t80,k,p80)
        call uprat(p80)
        call FeQuestEdwOpen(i,ip,p80,pom,0)
1200  continue
      call RepeatCommandsAcBut(Kterou,n)
1350  call RepeatCommandsEnable(Enable)
      if(Novy) then
        call MakeTorsionString(Enable,EdwString(EdwFr),t80old)
        Novy=.false.
      endif
2500  call FeQuestEvent(1,icont,ich)
      icont=1
      if(CheckType.eq.1.and.CheckNumber.eq.2) then
        call MakeTorsionString(Enable,EdwString(EdwFr),t80)
        if(t80.ne.t80old.or.(ButtonState(ButtonFr+4).ne.-2.and.
     1                       t80.ne.prazdno)) then
          if(.not.FeYesNo(-1.,30.,'Do you really want to omit changes '
     1                  //'in the last torsion angle?',0)) then
            icont=0
            call FeQuestButtonOff(CheckNumber)
            go to 2500
          endif
        endif
        icont=1
        QuestCheck(1)=0
        EventType=1
        EventNumber=2
        go to 2500
      else if(CheckType.eq.1.and.CheckNumber.le.4) then
        if(CheckNumber.eq.3) then
          call MakeTorsionString(Enable,EdwString(EdwFr),t80)
          if(t80.ne.t80old) then
            if(.not.FeYesNo(-1.,30.,'Do you really want to omit '//
     1              'changes in the last torsion angle?',0)) then
              icont=0
              call FeQuestButtonOff(CheckNumber)
              go to 2500
            endif
          endif
          t80=prazdno
        else
          call MakeTorsionString(Enable,EdwString(EdwFr),t80)
        endif
        Kterou=n+1
        go to 4000
      else if(CheckType.eq.1.and.CheckNumber.eq.5) then
        call MakeTorsionString(Enable,EdwString(EdwFr),t80)
        if(t80.ne.prazdno) then
          call AppendFile('torsion.tmp',t80,1)
          n=n+1
        endif
        go to 4000
      else if(CheckType.eq.1.and.CheckNumber.eq.6) then
        enable=.not.enable
        icont=0
        go to 1350
      else if(CheckType.eq.1.and.CheckNumber.eq.7) then
        call DeleteLinesFromFile('torsion.tmp',Kterou,Kterou)
        n=n-1
        if(n.eq.0) t80=' '
        Kterou=min(Kterou,n)
        go to 4000
      else if(CheckType.eq.1.and.CheckNumber.eq.8) then
        call MakeTorsionString(Enable,EdwString(EdwFr),t80)
        if(t80.ne.prazdno) call RewriteLinesOnFile('torsion.tmp',t80,
     1                                             Kterou,Kterou)
        go to 4000
      else if(CheckType.eq.2) then
        if(EventType.eq.1.and.(EventNumber.eq.4.or.EventNumber.eq.5.
     1     .or.EventNumber.eq.8).and.Enable) then
          do 2600i=1,4
            call TestAtomsString(EdwString(i+EdwFr-1),0,0,1,ich)
            if(ich.ne.0) then
              EventType=2
              EventNumber=i
              go to 2500
            endif
2600      continue
        endif
        go to 2500
      else if(CheckType.eq.4) then
        call MakeTorsionString(Enable,EdwString(EdwFr),t80)
        KterouOld=Kterou
        if(CheckNumber.eq.1) then
          Kterou=max(Kterou-1,1)
        else
          Kterou=min(Kterou+1,n)
        endif
        icont=0
        if(KterouOld.ne.Kterou) then
        if(t80.ne.t80old.or.(ButtonState(ButtonFr+4).ne.-2.and.
     1                       t80.ne.prazdno)) then
            if(.not.FeYesNo(-1.,30.,'Do you really want to omit '//
     1              'changes in the last torsion angle?',0)) then
              Kterou=KterouOld
              go to 2500
            endif
          endif
          go to 1100
        endif
        go to 2500
      else if(CheckType.ne.0) then
        call NebylOsetren
        go to 2500
      endif
      go to 5000
4000  call FeQuestButtonOff(CheckNumber)
      icont=0
      go to 1100
5000  call FeQuestRemove(1)
      close(ln)
      return
      end
      subroutine MakeTorsionString(Enable,EdwString,t80)
      character*(*) EdwString(4),t80
      logical Enable
      t80='torsion'
      if(.not.Enable) t80='!'//t80(1:7)
      do 1000i=1,4
        call uprat(EdwString(i))
        t80=t80(1:idel(t80))//' '//EdwString(i)
1000  continue
      return
      end
      subroutine ReadPlane
      include 'params.cmn'
      include 'basic.cmn'
      include 'atoms.cmn'
      include 'dist.cmn'
      include 'fepc.cmn'
      dimension nn(2),nnold(2)
      character*256 t256(2),p256,t256old(2)
      character*80 t80
      character*9  prazdno
      logical novy,FeYesNo,Enable
      data prazdno/'plane 0 0'/
      ln=NextLogicNumber()
      open(ln,file='plane.tmp')
      n=0
1000  read(ln,101,end=1010) t256
      n=n+1
      go to 1000
1010  close(ln)
      call FeQuestCreate(1,-1.,-1.,200.,0,8,' ',1)
      call RepeatCommandsBottom(n.ne.0,'plane',7)
      Enable=.true.
      call FeQuestEdwMake(1,100.,2,5.,3,'Atoms defining the best %plane'
     1                   ,'C',190.,8.,1)
      call FeQuestEdwMake(1,100.,4,5.,5,'Additional atoms to calculate'
     1                  //' distanes %from the plane','C',190.,8.,1)
      kterou=n
      icont=0
      if(n.le.0) then
        t256(1)=prazdno
        t256(2)=' '
      endif
1100  call RepeatCommandsUpDown(Kterou,n)
      novy=.true.
      if(Kterou.le.n) then
        open(ln,file='plane.tmp')
        do 1110i=1,kterou
          read(ln,101) t256
1110    continue
        close(ln)
      endif
      k=0
      kk=0
      call kus(t256(1),k,Cislo)
      enable=Cislo.ne.'!'
      do 1200i=1,2
        p256=' '
        id=0
        call kus(t256(1),k,Cislo)
        call Posun(Cislo,0)
        read(Cislo,'(i15)') nn(i)
        if(i.eq.2) nn(i)=nn(i)-nn(1)
        do 1150j=1,nn(i)
          call kus(t256(2),kk,t80)
          if(t80(1:1).eq.'!') t80=t80(2:)
          call uprat(t80)
          idc=idel(t80)
          if(id.eq.0) then
            p256=t80
            id=idc
          else
            p256=p256(1:id)//' '//t80(1:idc)
            id=id+1+idc
          endif
1150    continue
        call FeQuestEdwOpen(i,id,p256,pom,0)
1200  continue
      call RepeatCommandsAcBut(Kterou,n)
1350  call RepeatCommandsEnable(Enable)
      if(Novy) then
        call MakePlaneStrings(Enable,EdwString(EdwFr),t256old,nnold)
        Novy=.false.
      endif
2500  call FeQuestEvent(1,icont,ich)
      icont=1
      if(CheckType.eq.1.and.CheckNumber.eq.2) then
        call MakePlaneStrings(Enable,EdwString(EdwFr),t256,nn)
        if(t256(1).ne.t256old(1).or.t256(2).ne.t256old(2).or.
     1    (ButtonState(ButtonFr+4).ne.-2.and.(t256(1).ne.prazdno.or.
     2                                           t256(2).ne.' '))) then
          if(.not.FeYesNo(-1.,30.,'Do you really want to omit changes '
     1                  //'in the last plane?',0)) then
            icont=0
            call FeQuestButtonOff(CheckNumber)
            go to 2500
          endif
        endif
        icont=1
        QuestCheck(1)=0
        EventType=1
        EventNumber=2
        go to 2500
      else if(CheckType.eq.1.and.CheckNumber.le.4) then
        if(CheckNumber.eq.3) then
          call MakePlaneStrings(Enable,EdwString(EdwFr),t256,nn)
          if(t256(1).ne.t256old(1).or.t256(2).ne.t256old(2)) then
            if(.not.FeYesNo(-1.,30.,'Do you really want to omit '//
     1                      'changes in the last plane?',0)) then
              icont=0
              call FeQuestButtonOff(CheckNumber)
              go to 2500
            endif
          endif
          t256(1)=prazdno
          t256(2)=' '
        else
          call MakePlaneStrings(Enable,EdwString(EdwFr),t256,nn)
        endif
        Kterou=n+1
        go to 4000
      else if(CheckType.eq.1.and.CheckNumber.eq.5) then
        call MakePlaneStrings(Enable,EdwString(EdwFr),t256,nn)
        if(nn(1).lt.3) go to 3900
        if(t256(1).ne.prazdno) then
          call AppendFile('plane.tmp',t256,2)
          n=n+1
        endif
        go to 4000
      else if(CheckType.eq.1.and.CheckNumber.eq.6) then
        enable=.not.enable
        icont=0
        go to 1350
      else if(CheckType.eq.1.and.CheckNumber.eq.7) then
        ip=2*Kterou
        call DeleteLinesFromFile('plane.tmp',ip-1,ip)
        n=n-1
        if(n.eq.0) t80=' '
        Kterou=min(Kterou,n)
        go to 4000
      else if(CheckType.eq.1.and.CheckNumber.eq.8) then
        ip=2*Kterou
        call MakePlaneStrings(Enable,EdwString(EdwFr),t256,nn)
        if(nn(1).lt.3) go to 3900
        if(t256(1).ne.prazdno) call RewriteLinesOnFile('plane.tmp',t256,
     1                                                 ip-1,ip)
        go to 4000
      else if(CheckType.eq.2) then
        if(EventType.eq.1.and.(EventNumber.eq.2.or.EventNumber.eq.3.
     1     .or.EventNumber.eq.6).and.Enable) then
          do 2600i=1,2
            call TestAtomsString(EdwString(i+EdwFr-1),0,0,1,ich)
            if(ich.ne.0) then
              EventType=2
              EventNumber=i
              go to 2500
            endif
2600      continue
        endif
        go to 2500
      else if(CheckType.eq.4) then
        call MakePlaneStrings(Enable,EdwString(EdwFr),t256,nn)
        KterouOld=Kterou
        if(CheckNumber.eq.1) then
          Kterou=max(Kterou-1,1)
        else
          Kterou=min(Kterou+1,n)
        endif
        icont=0
        if(KterouOld.ne.Kterou) then
        if(t256(1).ne.t256old(1).or.t256(2).ne.t256old(2).or.
     1    (ButtonState(ButtonFr+4).ne.-2.and.(t256(1).ne.prazdno.or.
     2                                           t256(2).ne.' '))) then
            if(.not.FeYesNo(-1.,30.,'Do you really want to omit '//
     1                      'changes in the last plane?',0)) then
              Kterou=KterouOld
              go to 2500
            endif
          endif
          go to 1100
        endif
        go to 2500
      else if(CheckType.ne.0) then
        call NebylOsetren
        go to 2500
      endif
      go to 5000
3900  call FeChybne(-1.,30.,'The number of atoms to define the best '//
     1              'plane < 3',' ',0,-1)
4000  call FeQuestButtonOff(CheckNumber)
      icont=0
      go to 1100
5000  call FeQuestRemove(1)
      close(ln)
      return
101   format(a256)
      end
      subroutine MakePlaneStrings(Enable,EdwString,t256,nn)
      character*(*) EdwString(2),t256(2)
      character*80  t80
      logical Enable
      dimension nn(2)
      id=0
      t256(2)=' '
      do 2000i=1,2
        nn(i)=0
        if(idel(EdwString(i)).le.0) go to 2000
        k=0
1000    call kus(EdwString(i),k,t80)
        nn(i)=nn(i)+1
        idp=idel(t80)
        if(id.eq.0) then
          t256(2)=t80
          id=idp
        else
          t256(2)=t256(2)(1:id)//' '//t80(1:idp)
          id=id+1+idp
        endif
        if(k.lt.80) go to 1000
2000  continue
      write(t256(1),'(2i5)') nn(1),nn(1)+nn(2)
      call ZdrcniCisla(t256(1),2)
      t256(1)='plane '//t256(1)(1:idel(t256(1)))
      if(.not.Enable) then
        do 2100i=1,2
          t256(i)='!'//t256(i)(1:idel(t256(i)))
2100    continue
      endif
      return
      end

