C     Last change:  VP   14 Jan 98    1:27 pm
      subroutine Grapht
      include 'params.cmn'
      include 'basic.cmn'
      include 'atoms.cmn'
      include 'fepc.cmn'
      call PrelimGrapht
      if(ErrJana.ne.0) go to 9000
      call RightButtonsGrapht
9000  return
      end
      subroutine RightButtonsGrapht
      include 'params.cmn'
      include 'basic.cmn'
      include 'atoms.cmn'
      include 'fepc.cmn'
      character*25 men1(5)
      integer FeMenu
      logical Prvne
      data men1/'t-%xyz plot',
     1          't-%occupancy plot',
     2          't-%temperature parameters',
     3          't-%ADP parameters',
     4          't-%distance plot'/
      call FeButtonOff(1)
      if(itfmax.gt.2) then
        men1(4)='t-%ADP parameters'
        men1m=5
      else
        men1m=4
      endif
      men1(men1m)='t-%distance plot'
      EventNumber=7
      Prvne=.true.
1000  if(Prvne) then
        EventType=1
      else
        call FeEvent(0)
        if(EventType.ne.1.or.EventType.gt.9) go to 1000
      endif
      Prvne=.false.
      if(EventNumber.eq.1) then
        call FeButtonMake(4,0,ButtonXMin(4),ButtonYMin(4),30.,8.,'%Next'
     1                    )
        call FeButtonDisable(4)
        call FeButtonOn(1)
        call FeButtonOff(1)
        return
      else if(EventNumber.eq.7) then
        call FeButtonOn(7)
        call FeClGw
        j=FeMenu(-1.,-1.,men1,1,men1m,1,0)
        call FeButtonOff(7)
        izpet=7
        if(j.eq.1) then
          call GraphXYZ(izpet)
        else if(j.eq.2) then
          call GraphOcc(izpet)
        else if(j.eq.3) then
          call GraphTemp(izpet)
        else if(j.eq.men1m) then
          call GraphDist(izpet)
        else if(j.eq.4) then
          call GraphADP(izpet)
        endif
        if(j.ge.1.and.j.le.4) then
          EventNumber=izpet
          Prvne=.true.
        else if(EventType.eq.1) then
          Prvne=.true.
        endif
      endif
      go to 1000
      end
      subroutine PrelimGrapht
      include 'params.cmn'
      include 'basic.cmn'
      include 'atoms.cmn'
      include 'fepc.cmn'
      include 'grapht.cmn'
      do 1050j=1,15
        do 1000i=1,15
          Rho(i,j)=2.
1000    continue
1050  continue
      do 1100i=1,mxa
        Brat(i)=.false.
1100  continue
      DrawNonMod=.false.
      DrawVal=.false.
      open(m40,file=fln(1:ifln)//'.m40')
      open(m50,file=fln(1:ifln)//'.m50')
      call iom50(0,0)
      if(ErrJana.ne.0) return
      call inm40Grapht
      if(ErrJana.ne.0) return
      close(m40)
      close(m50)
      if(ndim.le.3) then
        call FeChybne(-1.,-1.,'Grapht can be applied just for modulated'
     1              //' structure',' ',0,1)
        ErrJana=1
        return
      endif
      call FeButtonMake(4,0,ButtonXMin(4),ButtonYMin(4),30.,8.,
     1                  '%Continue')
      call FeButtonDisable(4)
      call UnitMat(Tr(1,1),3)
      return
      end
      subroutine GraphXYZ(izpet)
      include 'params.cmn'
      include 'basic.cmn'
      include 'grapht.cmn'
      include 'fepc.cmn'
      include 'atoms.cmn'
      dimension gx(2)
      character*80 at
      data at/' '/,ix/1/
      data gx,delta/0.,1.,1./
      HardCopy=0
      call RightButAc('disable')
      call FeQuestCreate(1,-1.,-1.,100.,0,5,'Graph t-xyz',1)
      call FeQuestEdwMake(1,5.,1,40.,1,'%Atom','L',55.,8.,0)
      call FeQuestEdwOpen(1,i,at,pom,0)
      call FeQuestEdwMake(1,5.,2,40.,2,'%tmin,tmax','L',55.,8.,0)
      call FeQuestEdwOpen(2,i,at,gx,2)
      call FeQuestEdwMake(1,5.,3,40.,3,'%Delta [A]','L',55.,8.,0)
      call FeQuestEdwOpen(3,i,at,Delta,1)
      call FeQuestLabelMake(1,50.,4,'Coordinates','C')
      xpom=15.
      do 1100i=1,3
        call FeQuestCrwMake(1,xpom,5,xpom+5.,5,'%'//smbx(i),'C',8.,8.,
     1                      0,1)
        call FeQuestCrwOpen(i,i.eq.ix)
        xpom=xpom+30.
1100  continue
      icont=0
1500  call FeQuestEvent(1,icont,ich)
      icont=1
      if(CheckType.eq.1.and.CheckNumber.eq.2) then
        call uprat(EdwString(EdwFr))
        call atsymi(EdwString(EdwFr),ia,xsym,x4dif,tdif,is,k,*1510)
        QuestCheck(1)=0
        go to 1500
1510    EventType=2
        EventNumber=1
        call FeQuestButtonOff(2)
        go to 1500
      else if(CheckType.ne.0) then
        call NebylOsetren
        go to 1500
      endif
      if(ich.eq.0) then
        do 1600ix=1,3
          if(CrwLogic(ix+CrwFr-1)) go to 1610
1600    continue
1610    call FeQuestGetFromEdw(1,i,At,pom,CrwLogic)
        call FeQuestGetFromEdw(2,i,At,gx,CrwLogic)
        call FeQuestGetFromEdw(3,i,At,delta,CrwLogic)
      endif
      call FeQuestRemove(1)
      if(ich.ne.0) then
        call RightButAc('refresh')
        return
      endif
      xomn=gx(1)
      xomx=gx(2)
      dt=(xomx-xomn)/float(mxpt-1)
      yomn=-Delta
      yomx= Delta
      reconfig=.true.
      yy(1,1)=xomn
      yy(2,1)=yomn
      yy(1,2)=xomn
      yy(2,2)=yomx
      yy(1,3)=xomx
      yy(2,3)=yomx
      yy(1,4)=xomx
      yy(2,4)=yomn
      if(reconfig) then
        call FeUpGw(.false.)
        reconfig=.false.
      endif
      isw=iswa(ia)
      iais=iabs(is)
      eps=rm6(16,iais,isw)
      if(is.lt.0.) eps=-eps
      do 2100l=1,kmodx(ia)
        call multm(rm(1,iais,isw),ux(1,l,ia),uxi(1,l),3,3,1)
        call multm(rm(1,iais,isw),uy(1,l,ia),uyi(1,l),3,3,1)
        if(is.lt.0) then
          do 2050k=1,3
            uxi(k,l)=-uxi(k,l)
            uyi(k,l)=-uyi(k,l)
2050      continue
        endif
2100  continue
      x40=qcnt(1,ia)+tdif(1)
      eps0=eps*xomn
      epsd=eps*dt
      call indocc(oca,x40,eps0,mxpt,epsd,a0(ia),ax(1,ia),ay(1,ia),
     1            kmods(ia),kfs(ia),1)
      if(kfx(ia).gt.0) call indoccx(oca,x40,eps0,mxpt,epsd,
     1                           uy(1,kmodx(ia),ia),uy(2,kmodx(ia),ia))
      call indpos(xdi,x40,eps0,mxpt,epsd,uxi,uyi,kmodx(ia),kfx(ia),1)
      t=xomn
      do 2300i=1,mxpt
        ta(i)=t
        valn(i)=(xdi(ix,i)+x(ix,ia)-xdst(ix,ia))*cell(ix,isw)
        t=t+dt
2300  continue
2400  call FeHardCopy(HardCopy,'open',ich)
      if(ich.ne.0) go to 2900
      call FeClGw
      if(HardCopy.eq.4) write(85,'(''# '',a1,''-t plot for atom : '',
     1                             a8)') smbx(ix),at
      call FeOutSt(0,XCenUnit-13.5,YMaxUnit-17.,
     1             'Graph t-'//smbx(ix)//' for atom '//at(1:idel(at)),
     2             'C',White)
      call FeBorGw
      call popisos(1,xomn,xomx,yomn,yomx,'t')
      call popisos(2,yomn,yomx,xomn,xomx,smbx(ix))
      call pokusech(ta,valn,oca,mxpt,.true.,White)
      if(HardCopy.eq.4) then
        write(85,'(''# end of curve'')')
        write(85,'(''# end of file'')')
      endif
      call FeHardCopy(HardCopy,'close',ich)
2900  call RightButAc('refresh')
      if(PrinterPort.ne.0) call FeButtonOff(2)
      call FeButtonOff(3)
3000  call FeEvent(0)
      if(EventType.ne.1) go to 3000
      i=EventNumber
      if(i.eq.2.or.i.eq.3) then
        if(i.eq.2) then
          HardCopy=-PrintStyle
        else
          call FeSavePicture('graph',4)
          if(HardCopy.le.0) then
            HardCopy=0
            call FeButtonOff(i)
            go to 3000
          endif
        endif
        call FeButtonOff(i)
        call RightButAc('disable')
        go to 2400
      else
        izpet=i
        if(PrinterPort.ne.0) call FeButtonDisable(2)
        call FeButtonDisable(3)
        return
      endif
      go to 3000
      end
      subroutine GraphTemp(izpet)
      include 'params.cmn'
      include 'basic.cmn'
      include 'grapht.cmn'
      include 'fepc.cmn'
      include 'atoms.cmn'
      dimension gx(2,2),bg(6,mxpt),bi(6)
      character*80 at
      character*5 cu(4),cuv
      dimension bxi(6,mxw),byi(6,mxw),rmb(36)
      data at/' '/,cu/'U%11','U%22','U%33','U%iso'/,iu/4/
      data gx/0.,1.,-.01,.1/
      HardCopy=0
      call RightButAc('disable')
      xpom=FeTxLength('XXXXXXXXXXXXXXXX')+10.
      call FeQuestCreate(1,-1.,-1.,130.,0,5,'Graph t-Uij',1)
      call FeQuestEdwMake(1,5.,1,xpom,1,'%Atom','L',55.,8.,0)
      call FeQuestEdwOpen(1,i,at,pom,0)
      call FeQuestEdwMake(1,5.,2,xpom,2,'%tmin,tmax','L',55.,8.,0)
      call FeQuestEdwOpen(2,i,at,gx(1,1),2)
      call FeQuestEdwMake(1,5.,3,xpom,3,'%Umin,Umax [A**2]','L',55.,8.,
     1                    0)
      call FeQuestEdwOpen(3,i,at,gx(1,2),2)
      call FeQuestLabelMake(1,65.,4,'Component','C')
      xpom=10.
      do 1100i=1,4
        call FeQuestCrwMake(1,xpom,5,xpom+10.,5,cu(i),'C',8.,8.,0,
     1                      1)
        call FeQuestCrwOpen(i,i.eq.iu)
        xpom=xpom+30.
1100  continue
      icont=0
1500  call FeQuestEvent(1,icont,ich)
      icont=1
      if(CheckType.eq.1.and.CheckNumber.eq.2) then
        call uprat(EdwString(EdwFr))
        call atsymi(EdwString(EdwFr),ia,xsym,x4dif,tdif,is,k,*1510)
        QuestCheck(1)=0
        go to 1500
1510    EventType=2
        EventNumber=1
        call FeQuestButtonOff(2)
        go to 1500
      else if(CheckType.ne.0) then
        call NebylOsetren
        go to 1500
      endif
      if(ich.eq.0) then
        do 1600iu=1,4
          if(CrwLogic(iu+CrwFr-1)) go to 1610
1600    continue
1610    call FeQuestGetFromEdw(1,i,At,pom,CrwLogic)
        call FeQuestGetFromEdw(2,i,At,gx(1,1),CrwLogic)
        call FeQuestGetFromEdw(3,i,At,gx(1,2),CrwLogic)
      endif
      call FeQuestRemove(1)
      if(ich.ne.0) then
        call RightButAc('refresh')
        return
      endif
      xomn=gx(1,1)
      xomx=gx(2,1)
      dt=(xomx-xomn)/float(mxpt-1)
      yomn=gx(1,2)
      yomx=gx(2,2)
      reconfig=.true.
      yy(1,1)=xomn
      yy(2,1)=yomn
      yy(1,2)=xomn
      yy(2,2)=yomx
      yy(1,3)=xomx
      yy(2,3)=yomx
      yy(1,4)=xomx
      yy(2,4)=yomn
      if(reconfig) then
        call FeUpGw(.false.)
        reconfig=.false.
      endif
      isw=iswa(ia)
      iais=iabs(is)
      eps=rm6(16,iais,isw)
      if(is.lt.0.) eps=-eps
      call srotb(rm(1,iais,isw),rm(1,iais,isw),rmb)
      call multm(rmb,beta(1,ia),bi,6,6,1)
      do 2100j=1,kmodx(ia)
        call multm(rmb,bx(1,j,ia),bxi(1,j),6,6,1)
        call multm(rmb,by(1,j,ia),byi(1,j),6,6,1)
2100  continue
      x40=qcnt(1,ia)+tdif(1)
      eps0=eps*xomn
      epsd=eps*dt
      call indocc(oca,x40,eps0,mxpt,epsd,a0(ia),ax(1,ia),ay(1,ia),
     1            kmods(ia),kfs(ia),1)
      if(kfx(ia).gt.0) call indoccx(oca,x40,eps0,mxpt,epsd,
     1                           uy(1,kmodx(ia),ia),uy(2,kmodx(ia),ia))
      call IndBeta(bg,x40,eps0,mxpt,epsd,bxi,byi,kmodb(ia),kfb(ia),1)
      t=xomn
      do 2300i=1,mxpt
        ta(i)=t
        do 2140j=1,6
          bg(j,i)=bg(j,i)+bi(j)
2140    continue
        if(iu.eq.4) then
          call boueq(bg(1,i),sbeta(1,ia),0,valn(i),pom,isw)
        else
          valn(i)=bg(iu,i)/urcp(iu,isw)
        endif
        t=t+dt
2300  continue
2400  call FeHardCopy(HardCopy,'open',ich)
      if(ich.ne.0) go to 2900
      call FeClGw
      call DelProc(cu(iu),cuv)
      if(HardCopy.eq.4) write(85,'(''# '',a4,''-t plot for atom : '',
     1                             a8)') cuv,at
      call FeOutSt(0,XCenUnit-13.5,YMaxUnit-17.,
     1             'Graph t-'//cuv(:idel(cuv))//' for atom '//
     1             at(1:idel(at)),'C',White)
      call FeBorGw
      call popisos(1,xomn,xomx,yomn,yomx,'t')
      call popisos(2,yomn,yomx,xomn,xomx,cuv)
      call pokusech(ta,valn,oca,mxpt,.true.,White)
      if(HardCopy.eq.4) then
        write(85,'(''# end of curve'')')
        write(85,'(''# end of file'')')
      endif
      call FeHardCopy(HardCopy,'close',ich)
2900  call RightButAc('refresh')
      if(PrinterPort.ne.0) call FeButtonOff(2)
      call FeButtonOff(3)
3000  call FeEvent(0)
      if(EventType.ne.1) go to 3000
      i=EventNumber
      call FeButtonOn(i)
      if(i.eq.2.or.i.eq.3) then
        if(i.eq.2) then
          HardCopy=-PrintStyle
        else
          call FeSavePicture('graph',4)
          if(HardCopy.le.0) then
            HardCopy=0
            call FeButtonOff(i)
            go to 3000
          endif
        endif
        call FeButtonOff(i)
        call RightButAc('disable')
        go to 2400
      else
        izpet=i
        if(PrinterPort.ne.0) call FeButtonDisable(2)
        call FeButtonDisable(3)
        return
      endif
      go to 3000
      end
      subroutine DelProc(st1,st2)
      character*(*) st1,st2
      j=0
      st2=' '
      do 1000i=1,idel(st1)
        if(st1(i:i).ne.'%') then
          j=j+1
          st2(j:j)=st1(i:i)
        endif
1000  continue
      return
      end
      subroutine pokusech(x,y,o,nn,plne,Colour)
      dimension x(nn),y(nn),o(nn)
      integer Colour
      logical plne
      n=0
      np=1
      do 1000i=1,nn
        if(o(i).gt.0.) then
          n=n+1
        else
          if(n.gt.0) then
            call krivka(x(np),y(np),n,plne,Colour)
            np=i
            n=0
          endif
          np=np+1
        endif
1000  continue
      if(n.gt.0) call krivka(x(np),y(np),n,plne,Colour)
      return
      end
      subroutine GraphOcc(izpet)
      include 'params.cmn'
      include 'basic.cmn'
      include 'grapht.cmn'
      include 'fepc.cmn'
      include 'atoms.cmn'
      dimension gx(2,2)
      character*80 at
      data at/' '/
      data gx/0.,1.,0.,1.5/
      HardCopy=0
      call RightButAc('disable')
      call FeQuestCreate(1,-1.,-1.,100.,0,3,'Graph t-occupancy',1)
      call FeQuestEdwMake(1,5.,1,40.,1,'%Atom','L',55.,8.,0)
      call FeQuestEdwOpen(1,i,at,pom,0)
      call FeQuestEdwMake(1,5.,2,40.,2,'%tmin,tmax','L',55.,8.,0)
      call FeQuestEdwOpen(2,i,at,gx(1,1),2)
      call FeQuestEdwMake(1,5.,3,40.,3,'%omin,omax','L',55.,8.,0)
      call FeQuestEdwOpen(3,i,at,gx(1,2),2)
      icont=0
1500  call FeQuestEvent(1,icont,ich)
      icont=1
      if(CheckType.eq.1.and.CheckNumber.eq.2) then
        call uprat(EdwString(EdwFr))
        call atsymi(EdwString(EdwFr),ia,xsym,x4dif,tdif,is,k,*1510)
        QuestCheck(1)=0
        go to 1500
1510    EventType=2
        EventNumber=1
        call FeQuestButtonOff(2)
        go to 1500
      else if(CheckType.ne.0) then
        call NebylOsetren
        go to 1500
      endif
      if(ich.eq.0) then
        call FeQuestGetFromEdw(1,i,At,pom,CrwLogic)
        call FeQuestGetFromEdw(2,i,At,gx(1,1),CrwLogic)
        call FeQuestGetFromEdw(3,i,At,gx(1,2),CrwLogic)
      endif
      call FeQuestRemove(1)
      if(ich.ne.0) then
        call RightButAc('refresh')
        return
      endif
      xomn=gx(1,1)
      xomx=gx(2,1)
      dt=(xomx-xomn)/float(mxpt-1)
      yomn=gx(1,2)
      yomx=gx(2,2)
      reconfig=.true.
      yy(1,1)=xomn
      yy(2,1)=yomn
      yy(1,2)=xomn
      yy(2,2)=yomx
      yy(1,3)=xomx
      yy(2,3)=yomx
      yy(1,4)=xomx
      yy(2,4)=yomn
      if(reconfig) then
        call FeUpGw(.false.)
        reconfig=.false.
      endif
      isw=iswa(ia)
      iais=iabs(is)
      eps=rm6(16,iais,isw)
      if(is.lt.0.) eps=-eps
      x40=qcnt(1,ia)+tdif(1)
      eps0=eps*xomn
      epsd=eps*dt
      call indocc(oca,x40,eps0,mxpt,epsd,a0(ia),ax(1,ia),ay(1,ia),
     1            kmods(ia),kfs(ia),1)
      if(kfx(ia).gt.0) call indoccx(oca,x40,eps0,mxpt,epsd,
     1                           uy(1,kmodx(ia),ia),uy(2,kmodx(ia),ia))
      t=xomn
      do 2300i=1,mxpt
        ta(i)=t
        valn(i)=oca(i)
        oca(i)=10.
        t=t+dt
2300  continue
2400  call FeHardCopy(HardCopy,'open',ich)
      if(ich.ne.0) go to 2900
      call FeClGw
      if(HardCopy.eq.4) write(85,'(''# occ-t plot for atom : '',a8)')
     1                        at
      call FeOutSt(0,XCenUnit-13.5,YMaxUnit-17.,
     1             'Graph t-occupancy for atom '//at(1:idel(at)),
     2             'C',White)
      call FeBorGw
      call popisos(1,xomn,xomx,yomn,yomx,'t')
      call popisos(2,yomn,yomx,xomn,xomx,'occ')
      call pokusech(ta,valn,oca,mxpt,.true.,White)
      if(HardCopy.eq.4) then
        write(85,'(''# end of curve'')')
        write(85,'(''# end of file'')')
      endif
      call FeHardCopy(HardCopy,'close',ich)
2900  call RightButAc('refresh')
      if(PrinterPort.ne.0) call FeButtonOff(2)
      call FeButtonOff(3)
3000  call FeEvent(0)
      if(EventType.ne.1) go to 3000
      i=EventNumber
      call FeButtonOn(i)
      if(i.eq.2.or.i.eq.3) then
        if(i.eq.2) then
          HardCopy=-PrintStyle
        else
          call FeSavePicture('graph',4)
          if(HardCopy.le.0) then
            HardCopy=0
            call FeButtonOff(i)
            go to 3000
          endif
        endif
        call RightButAc('disable')
        call FeButtonOff(i)
        go to 2400
      else
        izpet=i
        if(PrinterPort.ne.0) call FeButtonDisable(2)
        call FeButtonDisable(3)
        return
      endif
      go to 3000
      end
      subroutine GraphDist(izpet)
      include 'params.cmn'
      include 'basic.cmn'
      include 'grapht.cmn'
      include 'fepc.cmn'
      include 'atoms.cmn'
      dimension gx(2,2)
      character*80 at
      data at/' '/
      data gx/0.,1.,2.,4./
      HardCopy=0
      call RightButAc('disable')
      call FeQuestCreate(1,-1.,-1.,120.,0,5,'Graph t-distance',1)
      call FeQuestEdwMake(1,5.,1,40.,1,'%Atom','L',55.,8.,0)
      call FeQuestEdwOpen(1,i,at,pom,0)
      call FeQuestEdwMake(1,5.,2,40.,2,'%tmin,tmax','L',55.,8.,0)
      call FeQuestEdwOpen(2,i,at,gx,2)
      call FeQuestEdwMake(1,5.,3,40.,3,'%dmin,dmax','L',55.,8.,0)
      call FeQuestEdwOpen(3,i,at,gx(1,2),2)
      call FeQuestCrwMake(1,5.,4,105.,4,'Draw %non-modulated curves',
     1                    'L',6.,6.,0,0)
      call FeQuestCrwOpen(1,DrawNonMod)
      call FeQuestCrwMake(1,5.,5,105.,5,'Draw %valence curves','L',
     1                    6.,6.,0,0)
      call FeQuestCrwOpen(2,DrawVal)
      icont=0
1500  call FeQuestEvent(1,icont,ich)
      icont=1
      if(CheckType.eq.1.and.CheckNumber.eq.2) then
        call uprat(EdwString(EdwFr))
        call atsymi(EdwString(EdwFr),ia,xsym,x4dif,tdif,is,k,*1510)
        QuestCheck(1)=0
        go to 1500
1510    EventType=2
        EventNumber=1
        call FeQuestButtonOff(2)
        go to 1500
      else if(CheckType.ne.0) then
        call NebylOsetren
        go to 1500
      endif
      if(ich.eq.0) then
        DrawNonMod=CrwLogic(CrwFr)
        DrawVal=CrwLogic(CrwFr+1)
        call FeQuestGetFromEdw(1,i,At,pom,CrwLogic)
        call FeQuestGetFromEdw(2,i,At,gx(1,1),CrwLogic)
        call FeQuestGetFromEdw(3,i,At,gx(1,2),CrwLogic)
      endif
      call FeQuestRemove(1)
      if(ich.ne.0) then
        go to 9000
      endif
      xomn=gx(1,1)
      xomx=gx(2,1)
      dt=(xomx-xomn)/float(mxpt-1)
      tzero=xomn
      yomn=gx(1,2)
      yomx=gx(2,2)
      call SelAtoms('Select atoms for distance calculation',Atom,Brat,
     1              isf,nacalc,.false.,ich)
      if(ich.ne.0) go to 9000
      if(DrawVal) call DefRho(ich)
      if(ich.ne.0) go to 9000
      reconfig=.true.
      yy(1,1)=xomn
      yy(2,1)=yomn
      yy(1,2)=xomn
      yy(2,2)=yomx
      yy(1,3)=xomx
      yy(2,3)=yomx
      yy(1,4)=xomx
      yy(2,4)=yomn
      if(reconfig) then
        call FeUpGw(.false.)
        reconfig=.false.
      endif
2100  call FeHardCopy(HardCopy,'open',ich)
      if(ich.ne.0) go to 2150
      do 2120i=1,mxpt
        valm(i)=0.
        valn(i)=0.
2120  continue
      call FeClGw
      call FeOutSt(0,XCenUnit-13.5,YMaxUnit-17.,
     1             'Graph t-distances for atom '//at(1:idel(at)),
     2             'C',White)
      call FeBorGw
      call popisos(1,xomn,xomx,yomn,yomx,'t')
      call popisos(2,yomn,yomx,xomn,xomx,'d')
      if(HardCopy.eq.4) write(85,'(''# dist-t plot for atom : '',a8)')
     1                        at
      call distatg
      if(HardCopy.eq.4) write(85,'(''# end of file'')')
      call FeHardCopy(HardCopy,'close',ich)
2150  call RightButAc('refresh')
      if(PrinterPort.ne.0) call FeButtonOff(2)
      call FeButtonOff(3)
      if(DrawVal) then
        call FeButtonDisable(1)
        call FeButtonOff(4)
        call FeButtonDisable(7)
      endif
2200  call FeEvent(0)
      if(EventType.ne.1) go to 2200
      i=EventNumber
      call FeButtonOn(i)
      if(i.eq.2.or.i.eq.3) then
        if(i.eq.2) then
          HardCopy=-PrintStyle
        else
          call FeSavePicture('graph',4)
          if(HardCopy.le.0) then
            HardCopy=0
            call FeButtonOff(i)
            go to 2200
          endif
        endif
        call FeButtonOff(i)
        call RightButAc('disable')
        go to 2100
      else if(i.eq.4) then
        call FeButtonDisable(1)
        call FeButtonDisable(4)
        call FeButtonDisable(7)
        go to 2400
      else
        call FeButtonOff(i)
        if(PrinterPort.ne.0) call FeButtonDisable(2)
        call FeButtonDisable(3)
        izpet=i
        go to 9999
      endif
      go to 2200
2400  HardCopy=0
      reconfig=.true.
      yomn=999999.
      yomx=0.
      do 2500i=1,mxpt
        yomn=min(yomn,valm(i))
        yomx=max(yomx,valm(i))
        if(DrawNonMod) yomn=min(yomn,valn(i))
        if(DrawNonMod) yomx=max(yomx,valn(i))
2500  continue
      yomx=float(ifix(yomx*5.)+1)/5.
      yomn=float(ifix(yomn*5.))/5.
      yy(1,1)=xomn
      yy(2,1)=yomn
      yy(1,2)=xomn
      yy(2,2)=yomx
      yy(1,3)=xomx
      yy(2,3)=yomx
      yy(1,4)=xomx
      yy(2,4)=yomn
      if(reconfig) then
        call FeUpGw(.false.)
        reconfig=.false.
      endif
3000  call FeHardCopy(HardCopy,'open',ich)
      if(ich.ne.0) go to 3100
      call FeClGw
      if(HardCopy.eq.4) write(85,'(''# valence-t plot for atom : '',a8)'
     1                        ) at
      call FeOutSt(0,XCenUnit-13.5,YMaxUnit-17.,
     1             'Graph valence-t for atom '//at(1:idel(at)),
     2             'C',White)
      call FeBorGw
      call popisos(1,xomn,xomx,yomn,yomx,'x')
      call popisos(2,yomn,yomx,xomn,xomx,'v')
      if(HardCopy.eq.4) write(85,'(''# curve including modulation'')')
      call krivka(ta,valm,mxpt,.true.,White)
      if(HardCopy.eq.4) write(85,'(''# end of curve'')')
      if(DrawNonMod) then
        if(HardCopy.eq.4) write(85,'(''# curve without modulation'')')
        call krivka(ta,valn,mxpt,.false.,White)
        if(HardCopy.eq.4) write(85,'(''# end of curve'')')
      endif
      if(HardCopy.eq.4) write(85,'(''# end of file'')')
      call FeHardCopy(HardCopy,'close',ich)
3100  call RightButAc('refresh')
      if(PrinterPort.ne.0) call FeButtonOff(2)
      call FeButtonOff(3)
3200  call FeEvent(0)
      if(EventType.ne.1) go to 3200
      i=EventNumber
      call FeButtonOn(i)
      if(i.eq.2.or.i.eq.3) then
        if(i.eq.2) then
          HardCopy=-PrintStyle
        else
          call FeSavePicture('graph',4)
          if(HardCopy.le.0) then
            HardCopy=0
            call FeButtonOff(i)
            go to 3200
          endif
        endif
        call FeButtonOff(i)
        call RightButAc('disable')
        go to 3000
      else
        izpet=i
        if(PrinterPort.ne.0) call FeButtonDisable(2)
        call FeButtonDisable(3)
        go to 9999
      endif
      go to 3200
9000  call RightButAc('refresh')
9999  return
      end
      subroutine DefRho(ich)
      include 'params.cmn'
      include 'basic.cmn'
      include 'atoms.cmn'
      include 'fepc.cmn'
      include 'grapht.cmn'
      dimension rhoo(15,15)
      call FeQuestCreate(1,-1.,-1.,95.,nf,0,'Rho constants',0)
      do 1200i=1,nf
        call FeQuestSelwMake(1, 5.,i,nat(i),10.,8.,i.eq.1,1,1)
        call FeQuestSelwMake(1,20.,i,nat(i),10.,8.,i.eq.1,1,2)
        do 1150k=1,nf
          rhoo(i,k)=rho(i,k)
1150    continue
1200  continue
      i=(nf+1)/2
      call FeQuestEdwMake(1,40.,i,60.,i,'Rho','L',30.,8.,0)
      i=1
      j=1
      icont=0
1500  call FeQuestEdwOpen(1,0,' ',rho(i,j),1)
      call FeQuestEvent(1,icont,ich)
      icont=1
      if(CheckType.eq.5) then
        call FeQuestGetFromEdw(1,i,TextInfo,Rho(i,j),CrwLogic)
        if(i.ne.j) rho(j,i)=rho(i,j)
        iw=(CheckNumber-1)/2+1
        if(mod(CheckNumber,2).eq.1) then
          i=iw
        else
          j=iw
        endif
        EventType=2
        EventNumber=1
        go to 1500
      else if(CheckType.ne.0) then
        call NebylOsetren
        go to 1500
      endif
      if(ich.eq.0) then
        call FeQuestGetFromEdw(1,i,TextInfo,rho(i,j),CrwLogic)
      endif
      call FeQuestRemove(1)
      if(ich.ne.0) then
        do 2130j=1,nf
          do 2120i=j,nf
            rho(j,i)=rhoo(i,j)
2120      continue
2130    continue
      endif
      return
      end
      subroutine distatg
      include 'params.cmn'
      include 'basic.cmn'
      include 'atoms.cmn'
      include 'grapht.cmn'
      include 'fepc.cmn'
      dimension x0(6),y0(6),y1(6),y2(6),uz(3),shj(3),shjc(3),dumm(mxpt),
     1          xdj(3,mxpt),uxj(3,mxw),uyj(3,mxw),y0p(6),y1p(6),y2p(3),
     2          uzp(3),up(3),wprij(36),gw4(3),wpriji(36),nvx(3),nvy(3),
     3          nvz(3),y3(6),y3p(6),yp(6),ypp(6),jsh(3)
      character*80 t80
      character*40 t40
      iswji=0
      do 8100i=ia,ia
        l=isf(i)
        if(l.eq.0) go to 8100
        iswi=iswa(i)
        ari=rcp(1,iswi)
        bri=rcp(2,iswi)
        cri=rcp(3,iswi)
        iais=iabs(is)
        eps=rm6(16,iais,iswi)
        if(is.lt.0.) eps=-eps
        call multm(rm(1,iais,iswi),xdst(1,ia),x0,3,3,1)
        call multm(rm(1,iais,iswi),x(1,ia),x1,3,3,1)
        do 1000l=1,3
          if(is.lt.0) then
            x0(l)=-x0(l)
            x1(l)=-x1(l)
          endif
          x0(l)=x0(l)+xsym(l)-x1(l)
1000    continue
        call bunka(x0,x1,0)
        call qbyx(x1,x1(4),iswi)
        do 1200l=1,3
          x1p(l)=xsym(l)
1200    continue
        if(ndim.eq.4) then
          do 1300l=1,kmodx(i)
            call multm(rm(1,iais,iswi),ux(1,l,i),uxi(1,l),3,3,1)
            call multm(rm(1,iais,iswi),uy(1,l,i),uyi(1,l),3,3,1)
            if(is.lt.0) then
              do 1250k=1,3
                uxi(k,l)=-uxi(k,l)
                uyi(k,l)=-uyi(k,l)
1250          continue
            endif
1300      continue
          x40=qcnt(1,i)+tdif(1)
          eps0=tzero
          epsd=dt
          call indocc(oi,x40,eps0,mxpt,epsd,a0(i),ax(1,i),ay(1,i),
     1                kmods(i),kfs(i),1)
          if(kfx(i).gt.0) call indoccx(oi,x40,eps0,mxpt,epsd,
     1                           uy(1,kmodx(i),i),uy(2,kmodx(i),i))
          call indpos(xdi,x40,eps0,mxpt,epsd,uxi,uyi,kmodx(i),kfx(i),1)
        endif
        do 8000j=1,nacalc
          if(.not.brat(j)) go to 8000
          l=isf(j)
          rbra=rho(isf(i),l)
          aij=ai(j)*float(ism(j))
          if(l.eq.0.or.aij.le.0.) go to 8000
          iswj=iswa(j)
          mxcellx=yomx*rcp(1,iswj)+1
          mxcelly=yomx*rcp(2,iswj)+1
          mxcellz=yomx*rcp(3,iswj)+1
          if(iswj.ne.iswi) then
            l=iswi*10+iswj
            if(l.ne.iswji) then
              call multm(zv(1,iswi),zvi(1,iswj),wprij,4,4,4)
              call matinv(wprij,wpriji,det,4)
              do 2060l=1,3
                nvz(l)=nint(wpriji(l+12))
2060          continue
              kolik=0
              do 2062l=1,3
                nvx(l)=0
                nvy(l)=0
                if(nvz(l).ne.0) then
                  kolik=kolik+1
                  kdeneni=l
                else
                  kdeje=l
                endif
2062          continue
              if(kolik.eq.3) then
                nvx(1)=1
                nvy(2)=1
              else if(kolik.eq.2) then
                nvx(mod(kdeje-1,3)+1)=1
                nvy(mod(kdeje,3)+1)=1
              else
                nvx(mod(kdeneni,3)+1)=1
                nvy(mod(kdeneni+1,3)+1)=1
              endif
              call multm(g(1,iswi),wprij(13),gw4,3,3,1)
              gww=scalmul(gw4,wprij(13))
              tnat=wprij(ndimq)-scalmul(qu(1,1,iswi),wprij(13))
            endif
          else
            tnat=1.
          endif
          iswji=l
          tztnat=tzero/tnat
          dttnat=dt/tnat
          dmhij=yomx+dx(i)+dx(j)
          dmhijq=dmhij**2
          dmhija=dmhij*ari
          dmhijb=dmhij*bri
          dmhijc=dmhij*cri
          js=0
          do 2050l=1,3
            y0(l)=xdst(l,j)
            y0p(l)=x(l,j)
2050      continue
          do 7900jsym=1,ns
            call multm(rm(1,jsym,iswj),y0,y1,3,3,1)
            call multm(rm(1,jsym,iswj),y0p,y1p,3,3,1)
            eps=rm6(16,jsym,iswj)
            do 2100l=1,3
              y1(l)=y1(l)+s6(l,jsym,iswj)
              y1p(l)=y1p(l)+s6(l,jsym,iswj)
2100        continue
            do 7800jcntrsm=1,3-ncs
              js=js+1
              if(isa(js,j).le.0) go to 7800
              if(jcntrsm.ne.1) then
                eps=-eps
                do 2200l=1,3
                  y1(l)=-y1(l)+s6(l,jsym,iswj)*2.
                  y1p(l)=-y1p(l)+s6(l,jsym,iswj)*2.
2200            continue
              endif
              do 7700jcenter=1,nvt
                do 2300l=1,3
                  y2(l)=y1(l)+vt6(l,jcenter,iswj)
                  y2p(l)=y1p(l)+vt6(l,jcenter,iswj)
2300            continue
                ts4=s6(4,jsym,iswj)+vt6(4,jcenter,iswj)
                if(iswj.eq.iswi) then
                  call bunka(y2,shj,1)
                  do 2310l=1,3
                    uzp(l)=y2p(l)-x1p(l)+shj(l)
                    uz(l)=y2(l)-x1(l)
2310              continue
                else
                  call multm(wpriji,x1,yp,ndim,ndim,1)
                  do 2320l=1,3
                    shj(l)=yp(l)-y2(l)
2320              continue
                  do 2330l=1,3
                    shj(l)=ifix(shj(l))
                    y2(l)=y2(l)+shj(l)
                    y2p(l)=y2p(l)+shj(l)
2330              continue
                endif
                do 7600jcellx=-mxcellx,mxcellx
                  cellxj=jcellx
                  if(iswj.eq.iswi) then
                    pom=uz(1)+cellxj
                    if(abs(pom).gt.dmhija) go to 7600
                    u(1)=pom
                    up(1)=uzp(1)+cellxj
                    y2(1)=y2(1)+cellxj
                    y2p(1)=y2p(1)+cellxj
                    jsh(1)=nint(shj(1))+jcellx
                    shjc(1)=shj(1)+cellxj+s6(1,jsym,iswj)+
     1                      vt6(1,jcenter,iswj)
                  endif
                  do 7500jcelly=-mxcelly,mxcelly
                    cellyj=jcelly
                    if(iswj.eq.iswi) then
                      pom=uz(2)+cellyj
                      if(abs(pom).gt.dmhijb) go to 7500
                      u(2)=pom
                      up(2)=uzp(2)+cellyj
                      y2(2)=y2(2)+cellyj
                      y2p(2)=y2p(2)+cellyj
                      jcellzp=-mxcellz
                      jcellzk= mxcellz
                      jsh(2)=nint(shj(2))+jcelly
                      shjc(2)=shj(2)+cellyj+s6(2,jsym,iswj)+
     1                        vt6(2,jcenter,iswj)
                    else
                      do 2420l=1,3
                        pom=cellxj*float(nvx(l))+cellyj*float(nvy(l))
                        y3(l)=y2(l)+pom
                        y3p(l)=y2p(l)+pom
                        jsh(l)=nint(shj(l)+pom)
                        shjc(l)=shj(l)+pom+s6(l,jsym,iswj)+
     1                          vt6(l,jcenter,iswj)
                        jsh(l)=nint(shj(l)+pom)
2420                  continue
                      call qbyx(y3,y3(4),iswj)
                      call multm(wprij,y3,yp,ndim,ndim,1)
                      do 2425l=1,3
                        u(l)=yp(l)-x1(l)
2425                  continue
                      v1=scalmul(gw4,u)
                      call multm(g(1,iswi),u,ug,3,3,1)
                      du=scalmul(u,ug)-v1**2/gww
                      if(du.gt.dmhijq) go to 7500
                      du=sqrt(du)
                      tmin=-v1/gww*tnat
                      it=tmin
                      if(tmin.lt.0.) it=it-1
                      do 2430l=1,3
                        pom=-it*nvz(l)
                        y3(l)=y3(l)+pom
                        y3p(l)=y3p(l)+pom
                        shjc(l)=shjc(l)+pom
                        jsh(l)=jsh(l)+nint(pom)
2430                  continue
                      tmin=tmin-float(it)
                      jcellzk=0
2442                  do 2443l=1,3
                        yp(l)=y3(l)+float(nvz(l)*(jcellzk+1))
2443                  continue
                      call qbyx(yp,yp(4),iswj)
                      yp(4)=yp(4)+xomx/tnat
                      call multm(wprij,yp,ypp,4,4,1)
                      do 2444l=1,3
                        u(l)=ypp(l)-x1(l)
2444                  continue
                      call multm(g(1,iswi),u,ug,3,3,1)
                      pom=scalmul(u,ug)
                      tminp=tmin+float(jcellzk+1)
                      if(pom.lt.dmhijq.or.
     1                   (tminp.ge.xomn.and.tminp.le.xomx)) then
                        jcellzk=jcellzk+1
                        go to 2442
                      endif
                      jcellzp=0
2452                  do 2453l=1,3
                        yp(l)=y3(l)+float(nvz(l)*(jcellzp-1))
2453                  continue
                      call qbyx(yp,yp(4),iswj)
                      yp(4)=yp(4)+xomn/tnat
                      call multm(wprij,yp,ypp,4,4,1)
                      do 2454l=1,3
                        u(l)=ypp(l)-x1(l)
2454                  continue
                      call multm(g(1,iswi),u,ug,3,3,1)
                      pom=scalmul(u,ug)
                      tminp=tmin+float(jcellzp-1)
                      if(pom.lt.dmhijq.or.
     1                   (tminp.ge.xomn.and.tminp.le.xomx)) then
                        jcellzp=jcellzp-1
                        go to 2452
                      endif
                      do 2455l=1,3
                        pom=float(nvz(l)*(jcellzp-1))
                        y3p(l)=y3p(l)+pom
                        y3 (l)=y3 (l)+pom
                        shjc(l)=shjc(l)+pom
                        jsh(l)=jsh(l)+nint(pom)
2455                  continue
                    endif
                    do 7400jcellz=jcellzp,jcellzk
                      cellzj=jcellz
                      if(iswj.eq.iswi) then
                        pom=uz(3)+cellzj
                        if(abs(pom).gt.dmhijc) go to 7400
                        u(3)=pom
                        up(3)=uzp(3)+cellzj
                        y2(3)=y2(3)+cellzj
                        y2p(3)=y2p(3)+cellzj
                        shjc(3)=shj(3)+cellzj+s6(3,jsym,iswj)+
     1                          vt6(3,jcenter,iswj)
                        jsh(3)=nint(shj(3))+jcellz
                        call multm(g(1,iswi),u,ug,3,3,1)
                        uu=scalmul(u,ug)
                        if(uu.gt.dmhijq) go to 7400
                        if(uu.eq.0..and.i.eq.j) go to 7400
                        do 2500l=1,3
                          y3 (l)=y2 (l)
                          y3p(l)=y2p(l)
2500                    continue
                      else
                        do 2510l=1,3
                          pom=nvz(l)
                          y3 (l)=y3 (l)+pom
                          y3p(l)=y3p(l)+pom
                          shjc(l)=shjc(l)+pom
                          jsh(l)=jsh(l)+nint(pom)
2510                    continue
                      endif
                      call qbyx(y3,y3(4),iswj)
                      call qbyx(y3p,y3p(4),iswj)
                      call scode(jsym,jcntrsm,jcenter,shjc,jsh,iswj,t80,
     1                           t40)
                      t80=t80(1:idel(t80))//'#'
                      l=idel(t40)
                      if(l.gt.0) t80=t80(1:idel(t80))//t40(1:l)
                      call zhusti(t80)
                      do 2600m=1,kmodx(j)
                        call multm(rm(1,jsym,iswj),ux(1,m,j),uxj(1,m),
     1                             3,3,1)
                        if(kfx(j).eq.0.or.m.ne.kmodx(j)) then
                          call multm(rm(1,jsym,iswj),uy(1,m,j),
     1                               uyj(1,m),3,3,1)
                        else
                          do 2540l=1,3
                            uyj(l,m)=uy(l,m,j)
2540                      continue
                        endif
                        if(jcntrsm.eq.2) then
                          do 2550l=1,3
                            uxj(l,m)=-uxj(l,m)
                            if(kfx(j).eq.0.or.m.ne.kmodx(j))
     1                                           uyj(l,m)=-uyj(l,m)
2550                      continue
                        endif
2600                  continue
                      call qbyx(shjc,qx,iswj)
                      x40=qcnt(1,j)+eps*(qx(1)-ts4)
                      eps0=eps*tztnat
                      epsd=eps*dttnat
                      call indocc(oj,x40,eps0,mxpt,epsd,a0(j),ax(1,j),
     1                            ay(1,j),kmods(j),kfs(j),1)
                      if(kfx(j).gt.0) call indoccx(oj,x40,eps0,mxpt,
     1                         epsd,uy(1,kmodx(j),j),uy(2,kmodx(j),j))
                      call indpos(xdj,x40,eps0,mxpt,epsd,uxj,uyj,
     1                            kmodx(j),kfx(j),1)
                      t=tzero-dt
                      dummx=-9999.
                      dummn= 9999.
                      dumav=0.
                      y340=y3p(4)
                      ocut=0.1
                      do 2700kt=1,mxpt
                        t=t+dt
                        if(oi(kt).le.ocut.or.oj(kt).le.ocut) then
                          oca(kt)=0.
                        else
                          oca(kt)=1.
                        endif
                        ta(kt)=t
                        if(iswj.eq.iswi) then
                          do 2651l=1,3
                            um(l,kt)=up(l)+xdj(l,kt)-xdi(l,kt)
2651                      continue
                          dumm(kt)=sqrt(uu)
                        else
                          y3p(4)=y340+t/tnat
                          call multm(wprij,y3p,yp,4,4,1)
                          do 2660l=1,3
                            yp(l)=yp(l)-x1p(l)
2660                      continue
                          call multm(g(1,iswi),yp,ypp,3,3,1)
                          dumm(kt)=sqrt(scalmul(yp,ypp))
                          do 2661l=1,3
                            yp(l)=yp(l)-xdi(l,kt)
                            ypp(l)=xdj(l,kt)
2661                      continue
                          call qbyx(ypp,ypp(4),iswj)
                          call cultm(wprij,ypp,yp,4,4,1)
                          do 2662l=1,3
                            um(l,kt)=yp(l)
2662                      continue
                        endif
                        call multm(g(1,iswi),um(1,kt),umg,3,3,1)
                        dum(kt)=sqrt(scalmul(um(1,kt),umg))
                        if(oca(kt).gt..1) then
                          pom=oj(kt)*aij
                          valm(kt)=valm(kt)+exp((rbra-dum(kt))/.37)*pom
                          valn(kt)=valn(kt)+exp((rbra-dumm(kt))/.37)*pom
                        endif
                        dummx=max(dum(kt),dummx)
                        dummn=min(dum(kt),dummn)
                        dumav=dumav+dum(kt)
2700                  continue
                      t80='distance to '//atom(j)(1:idel(atom(j)))//
     1                    '/'//t80(1:idel(t80))
                      if(HardCopy.eq.4) then
                        write(85,101)(t80(l:l),l=1,idel(t80))
                        write(85,
     1                      '(''# distances including modulation'')')
                      endif
                      call pokusech(ta,dum,oca,mxpt,.true.,White)
                      if(HardCopy.eq.4) write(85,'(''# end of curve'')')
                      if(DrawNonMod) then
                        if(HardCopy.eq.4) then
                          write(85,101)(t80(l:l),l=1,idel(t80))
                          write(85,
     1                        '(''# distances without modulation'')')
                        endif
                        call pokusech(ta,dumm,oca,mxpt,.false.,
     1                                White)
                        if(HardCopy.eq.4) write(85,
     1                                        '(''# end of curve'')')
                      endif
7400                continue
7500              continue
7600            continue
7700          continue
7800        continue
7900      continue
8000    continue
8100  continue
      return
101   format('# ',72a1)
      end
      subroutine inm40Grapht
      include 'params.cmn'
      include 'basic.cmn'
      include 'atoms.cmn'
      include 'grapht.cmn'
      call iom40(0,0)
      if(ErrJana.ne.0) return
      do 1100i=1,nacalc
        do 1000j=1,3
          xdst(j,i)=x(j,i)
1000    continue
1100  continue
      call setor(0,0)
      call trortho(0)
      close(m40)
      nt=100
      dt=.01
      tzero=0.
      ocut=.01
      do 2000i=1,nacalc
        dx(i)=0.
        if(ndim.gt.3) then
          x40=qcnt(1,i)
          call indocc(oi,x40,tzero,nt,dt,a0(i),ax(1,i),ay(1,i),kmods(i),
     1                kfs(i),1)
          if(kfx(i).gt.0) call indoccx(oi,x40,tzero,mxpt,dt,
     1                           uy(1,kmodx(i),i),uy(2,kmodx(i),i))
          call indpos(xdi,x40,tzero,nt,dt,ux(1,1,i),uy(1,1,i),kmodx(i),
     1                kfx(i),1)
          do 1200j=1,nt
            if(oi(j).le.ocut) go to 1200
            call multm(g(1,iswa(i)),xdi(1,j),umg,3,3,1)
            dx(i)=max(dx(i),sqrt(scalmul(xdi(1,j),umg)))
1200      continue
        endif
2000  continue
      call AddSpec
      return
      end
      subroutine GraphADP(izpet)
      include 'params.cmn'
      include 'basic.cmn'
      include 'grapht.cmn'
      include 'fepc.cmn'
      include 'atoms.cmn'
      dimension gx(2,2),cg(28*mxpt),ci(28),cxi(28,mxw),cyi(28,mxw),
     1          rmc(28,28)
      character*80 at
      character*12 param
      data at/' '/,Param/'C111'/
      data gx/0.,1.,-.02,.02/
      HardCopy=0
      call RightButAc('disable')
      call FeQuestCreate(1,-1.,-1.,100.,0,4,'Graph t-ADP',1)
      call FeQuestEdwMake(1,5.,1,40.,1,'%Atom','L',55.,8.,0)
      call FeQuestEdwOpen(1,i,at,pom,0)
      call FeQuestEdwMake(1,5.,2,40.,2,'%tmin,tmax','L',55.,8.,0)
      call FeQuestEdwOpen(2,i,at,gx,2)
      call FeQuestEdwMake(1,5.,3,40.,3,'%ymin,ymax','L',55.,8.,0)
      call FeQuestEdwOpen(3,i,at,gx(1,2),2)
      call FeQuestEdwMake(1,5.,4,60.,4,'ADP %parameter','L',35.,8.,0)
      call FeQuestEdwOpen(4,i,Param,pom,0)
      icont=0
1500  call FeQuestEvent(1,icont,ich)
      icont=1
      if(CheckType.eq.1.and.CheckNumber.eq.2) then
        call uprat(EdwString(EdwFr))
        call atsymi(EdwString(EdwFr),ia,xsym,x4dif,tdif,is,k,*1510)
        Param=EdwString(EdwFr+3)
        call mala(Param)
        ip=ktera(Param)
        if(ip.le.0) then
          call FeChybne(-1.,30.,'wrong parameter : '//Param,' ',
     1                  0,-1)
          go to 1510
        else if(ip.lt.11.or.ip.gt.TRankCumul(itf(ia))) then
          call FeChybne(-1.,30.,'parameter : "'//Param(:idel(Param))//
     1                  '" inapplicable',' ',0,-1)
          go to 1510
        endif
        QuestCheck(1)=0
        ic=index('CDEF',Param(1:1))+2
        ip=ip-TRankCumul(ic-1)
        go to 1500
1510    EventType=2
        EventNumber=1
        call FeQuestButtonOff(2)
        go to 1500
      else if(CheckType.ne.0) then
        call NebylOsetren
        go to 1500
      endif
      if(ich.eq.0) then
        call FeQuestGetFromEdw(1,i,At,pom,CrwLogic)
        call FeQuestGetFromEdw(2,i,At,gx(1,1),CrwLogic)
        call FeQuestGetFromEdw(3,i,At,gx(1,2),CrwLogic)
      endif
      call FeQuestRemove(1)
      if(ich.ne.0) then
        call RightButAc('refresh')
        return
      endif
1610  xomn=gx(1,1)
      xomx=gx(2,1)
      dt=(xomx-xomn)/float(mxpt-1)
      yomn=gx(1,2)
      yomx=gx(2,2)
      reconfig=.true.
      yy(1,1)=xomn
      yy(2,1)=yomn
      yy(1,2)=xomn
      yy(2,2)=yomx
      yy(1,3)=xomx
      yy(2,3)=yomx
      yy(1,4)=xomx
      yy(2,4)=yomn
      if(reconfig) then
        call FeUpGw(.false.)
        reconfig=.false.
      endif
      isw=iswa(ia)
      iais=iabs(is)
      eps=rm6(16,iais,isw)
      if(is.lt.0.) eps=-eps
      call srotc(rm(1,iais,isw),ic,rmc)
      nrank=TRank(ic)
      if(ic.eq.3) then
        call multm(rmc,c3(1,ia),ci,nrank,nrank,1)
      else if(ic.eq.4) then
        call multm(rmc,c4(1,ia),ci,nrank,nrank,1)
      else if(ic.eq.5) then
        call multm(rmc,c5(1,ia),ci,nrank,nrank,1)
      else
        call multm(rmc,c6(1,ia),ci,nrank,nrank,1)
      endif
      do 1700i=1,kmoda(ia,ic+1)
        if(ic.eq.3) then
          call multm(rmc,c3x(1,i,ia),cxi(1,i),nrank,nrank,1)
          call multm(rmc,c3y(1,i,ia),cyi(1,i),nrank,nrank,1)
        else if(ic.eq.4) then
          call multm(rmc,c4x(1,i,ia),cxi(1,i),nrank,nrank,1)
          call multm(rmc,c4y(1,i,ia),cyi(1,i),nrank,nrank,1)
        else if(ic.eq.5) then
          call multm(rmc,c5x(1,i,ia),cxi(1,i),nrank,nrank,1)
          call multm(rmc,c5y(1,i,ia),cyi(1,i),nrank,nrank,1)
        else
          call multm(rmc,c6x(1,i,ia),cxi(1,i),nrank,nrank,1)
          call multm(rmc,c6y(1,i,ia),cyi(1,i),nrank,nrank,1)
        endif
1700  continue
      x40=qcnt(1,ia)+tdif(1)
      eps0=eps*xomn
      epsd=eps*dt
      call indocc(oca,x40,eps0,mxpt,epsd,a0(ia),ax(1,ia),ay(1,ia),
     1            kmods(ia),kfs(ia),1)
      if(kfx(ia).gt.0) call indoccx(oca,x40,eps0,mxpt,epsd,
     1                           uy(1,kmodx(ia),ia),uy(2,kmodx(ia),ia))
      call IndAnh(cg,nrank,x40,eps*xomn,mxpt,eps*dt,cxi,cyi,
     1            kmoda(ia,ic+1),kfa(ia,ic+1),1)
      t=xomn
      j=ip
      do 2300i=1,mxpt
        ta(i)=t
        valn(i)=cg(j)+ci(ip)
        t=t+dt
        j=j+nrank
2300  continue
2400  call FeHardCopy(HardCopy,'open',ich)
      if(ich.ne.0) go to 2900
      call FeClGw
      if(HardCopy.eq.4) write(85,'(''# '',a12,''-t plot for atom : '',
     1                             a8)') param,at
      call FeOutSt(0,XCenUnit-13.5,YMaxUnit-17.,
     1             'Graph t-'//Param(:idel(Param))//' for atom '//
     2             at(1:idel(at)),'C',White)
      call FeBorGw
      call popisos(1,xomn,xomx,yomn,yomx,'t')
      call popisos(2,yomn,yomx,xomn,xomx,Param)
      call pokusech(ta,valn,oca,mxpt,.true.,White)
      if(HardCopy.eq.4) then
        write(85,'(''# end of curve'')')
        write(85,'(''# end of file'')')
      endif
      call FeHardCopy(HardCopy,'close',ich)
2900  call RightButAc('refresh')
      if(PrinterPort.ne.0) call FeButtonOff(2)
      call FeButtonOff(3)
3000  call FeEvent(0)
      if(EventType.ne.1) go to 3000
      i=EventNumber
      call FeButtonOn(i)
      if(i.eq.2.or.i.eq.3) then
        if(i.eq.2) then
          HardCopy=-PrintStyle
        else
          call FeSavePicture('graph',4)
          if(HardCopy.le.0) then
            HardCopy=0
            call FeButtonOff(i)
            go to 3000
          endif
        endif
        call FeButtonOff(i)
        call RightButAc('disable')
        go to 2400
      else
        izpet=i
        if(PrinterPort.ne.0) call FeButtonDisable(2)
        call FeButtonDisable(3)
        return
      endif
      go to 3000
      end

