C     Last change:  VP   17 Jan 98    1:43 pm
      subroutine Fourier
      include 'params.cmn'
      include 'basic.cmn'
      include 'fourier.cmn'
      include 'fepc.cmn'
      call PrelimFourier
      if(ErrJana.ne.0) go to 9999
      if(lcalc.eq.1) then
        call FourierSum
        if(ErrJana.ne.0) go to 9999
      endif
      if(lpeaks.eq.1) call peaks(0,81)
9999  if(lcalc.eq.1) call FeButtonMake(2,0,ButtonXMin(2),ButtonYMin(2),
     1                                 30.,8.,'%Print')
      return
      end
      subroutine PrelimFourier
      include 'params.cmn'
      include 'basic.cmn'
      include 'fourier.cmn'
      include 'atoms.cmn'
      include 'fepc.cmn'
      character*80 t80
      character*11 form
      logical ExistM80,ExistFile,Formatted
      dimension ih(6),ihp(6),ihpp(6),mxh(6),mxd(6),hh(6),hhp(6)
      call DefaultFourier
      if(ExistFile('fourier.tmp')) call DeleteFile('fourier.tmp')
      open(m40,file=fln(:ifln)//'.m40')
      open(m50,file=fln(:ifln)//'.m50')
      open(lst,file=fln(:ifln)//'.fou')
      open(81,file=fln(:ifln)//'.m81',form='unformatted')
      uloha='Program for n-dimensional Fourier synthesis'
      noo(1)=-333
      noo(2)=-333
      do 1010i=1,2
        do 1000j=1,6
          xrmn(j,i)=-333.
1000    continue
1010  continue
      call iom50(0,0)
      if(ErrJana.ne.0) go to 9999
      ptstep=-1.0
      call NactiFourier
      if(ndim.le.3) nsubs=1
      inquire(file=fln(:ifln)//'.m80',exist=ExistM80)
      if(Format80.eq.' ') then
        formatted=.false.
        form='unformatted'
      else
        formatted=.true.
        form='formatted'
      endif
      if(.not.ExistM80.and.mapa.ne.1) then
        call FeChybne(-1.,-1.,'the M80 file doesn''t exist, first you'//
     1                ' have to','run REFINE to get phases and/or Fcalc'
     2               ,0,1)
        ErrJana=1
        go to 9999
      endif
      if(ptstep.lt.0.) ptstep=.25
      call deflim
      if(lcalc.eq.1) then
        if(ExistM80) then
          open(80,file=fln(:ifln)//'.m80',form=form)
        else
          open(91,file=fln(:ifln)//'.m91')
        endif
        open(82,file=fln(:ifln)//'.m82',form='unformatted')
      endif
      call iom50(0,1)
      if(ErrJana.ne.0) go to 9999
      Patterson=mapa.le.3
      close(m50)
      twov=2./vol(1)
      pom=to
      call iom40(0,0)
      if(ErrJana.ne.0) go to 9999
      close(m40)
      to=pom
      if(lcalc.eq.1) then
        if(Patterson) then
          mp=2
          srnat=0.
          if(Radiation(1).eq.1) then
            do 1020i=1,nf
              srnat=srnat+rnat(i)
1020        continue
          endif
          if(srnat.gt.0.) then
            if(ntab.gt.0) then
              do 1022i=1,nf
                fx(i)=fx(i)+ff(1,i)+ffr(i)
1022          continue
            else
              do 1032i=1,nf
                fx(i)=ff(10,i)+ffr(i)
                j=0
                do 1030k=2,8,2
                  fx(i)=fx(i)+ff(k,i)
1030            continue
1032          continue
            endif
            pom0=0.
            do 1035i=1,nf
              pom0=pom0+rnat(i)*sqrt((fx(i)**2+ffi(i)**2))
1035        continue
          else
            pom0=1.
          endif
        else
          mp=1
        endif
        if(lite.eq.1) then
          rhom=1.
        else
          rhom=episq
        endif
        if(ptname.ne.'[nic]') then
          ncollar=0
          if(ptname.ne.'[neco]') then
            call atsym(ptname,i,ptx,hh,hh(4),j,k)
            if(i.le.0) then
              call FeChybne(-1.,-1.,'atom '//ptname(:idel(ptname))//
     1                      ' isn''t on the '//'file M40',
     2                      'The part of the volume to be mapped '//
     3                      'isn''t defined',1,1)
              ErrJana=1
            endif
            if(k.eq.3) then
              call FeChybne(-1.,-1.,'atom '//ptname(:idel(ptname))//
     1                      ' isn''t correct',
     2                      'The part of the volume to be mapped '//
     3                      'isn''t defined',1,1)
            endif
            if(ErrJana.ne.0) go to 9999
          endif
          do 1100j=1,3
            nd=nint(.5*pts(j)/ptstep)
            if(nd.ne.0) then
              dd(j,1)=ptstep/cell(j,nsubs)
            else
              dd(j,1)=1.
            endif
            xrmn(j,1)=ptx(j)-dd(j,1)*float(nd)
            xrmx(j,1)=ptx(j)+dd(j,1)*float(nd)
            dd(j,2)=dd(j,1)
            xrmn(j,2)=xrmn(j,1)
            xrmx(j,2)=xrmx(j,1)
1100      continue
        endif
        do 1200i=1,2
          do 1150j=ndim+1,6
            xrmn(j,i)=0.
            xrmx(j,i)=0.
            dd(j,i)=1.
1150      continue
1200    continue
        if(noo(1).eq.-333) noo(1)=nop(1,nsubs)
        if(noo(2).eq.-333) noo(2)=nop(2,nsubs)
        norien=noo(mp)
        n=norien
        i=10**(ndim-1)
        do 1220j=1,ndim-1
          iorien(j)=n/i
          n=mod(n,i)
          i=i/10
1220    continue
        iorien(ndim)=n
        do 1300i=1,2
          do 1250j=1,ndim
            if(xrmn(j,i).lt.-330.) then
              xrmn(j,i)=fourmn(j,i,nsubs)
              xrmx(j,i)=fourmx(j,i,nsubs)
              if(j.le.3) then
                n=nint((xrmx(j,i)-xrmn(j,i))*cell(j,nsubs)/ptstep)
                dd(j,i)=(xrmx(j,i)-xrmn(j,i))/float(n)
              else
                dd(j,i)=.1
              endif
            else
              if(j.le.3) ncollar=0
            endif
1250      continue
1300    continue
        do 1400i=1,ndim
          n=iorien(i)
          if(n.lt.1.or.n.gt.ndim) go to 1500
          do 1350j=i+1,ndim
            if(n.eq.iorien(j)) go to 1500
1350      continue
1400    continue
        go to 1550
1500    t80='wrong orientation'
        i=idel(t80)+1
        write(t80(i:i+6),'(i7)') norien
        call FeChybne(-1.,-1.,t80,' ',1,1)
        ErrJana=1
        go to 9999
1550    do 1600i=1,6
          if(i.le.ndim) then
            j=iorien(i)
            if(ncollar.eq.1.and.j.le.3) then
              xrmn(j,mp)=xrmn(j,mp)-dd(j,mp)
              xrmx(j,mp)=xrmx(j,mp)+dd(j,mp)
            endif
            xfmn(i)=xrmn(j,mp)
            xfmx(i)=xrmx(j,mp)
            xdf(i)=dd(j,mp)
          else
            xfmn(i)=0.
            xfmx(i)=0.
            xdf(i)=1.
          endif
1600    continue
        do 1610i=1,6
          nx(i)=nint((xfmx(i)-xfmn(i))/xdf(i))+1
1610    continue
        nxny=nx(1)*nx(2)
        nmap=nx(3)*nx(4)*nx(5)*nx(6)
      else
        read(81) nx,nxny,nmap,(xfmn(i),xfmx(i),i=1,6),xdf,iorien,mapa,
     1            nsubs
        Patterson=mapa.le.3
      endif
      if(Patterson) then
        ncs=1
        do 1620i=1,ns
          do 1615j=1,ndim
            s6(j,i,1)=0.
1615      continue
1620    continue
      endif
      do 1700i=1,6
        if(i.le.ndim) then
          cx(i)=smbx6(iorien(i))
        else
          cx(i)=' '
        endif
1700  continue
      if(lpeaks.eq.1) then
        if(npeaks(1).lt.0) then
          fa=0.
          fah=0.
          do 1800i=1,nacalc
            if(ff(1,isf(i)).lt.2.) then
              fah=fah+ai(i)
            else
              fa=fa+ai(i)
            endif
1800      continue
          pom=0.
          pomh=0.
          do 1850i=1,nf
            if(ff(1,i).lt.2.) then
              pomh=pomh+rnat(i)
            else
              pom=pom+rnat(i)
            endif
1850      continue
          pom=pom*float(nz)/float(nvt*ns*(3-ncs))
          nacp=nint(pom)
          pomh=pomh*float(nz)/float(nvt*ns*(3-ncs))
          nacp=nint(pom)
          nachp=nint(pomh)
          if(Patterson) then
            npeaks(1)=50
          else if(mapa.eq.4.or.mapa.eq.5.or.mapa.eq.7.or.mapa.eq.8) then
            npeaks(1)=nacp+5
          else
            npeaks(1)=nacp-nint(fa)+nachp-nint(fah)+5
          endif
        endif
        if(npeaks(2).lt.0) npeaks(2)=5
      endif
2000  t80='Type of map : '
      if(mapa.eq.1) then
        t80(15:)='F(obs)**2 - Patterson'
      else if(mapa.eq.2) then
        t80(15:)='F(calc)**2 - checking Patterson'
      else if(mapa.eq.3) then
        t80(15:)='F(obs)**2-F(calc)**2 - difference Patterson'
      else if(mapa.eq.4) then
        t80(15:)='F(obs) - Fourier'
      else if(mapa.eq.5) then
        t80(15:)='F(calc) - checking Fourier'
      else if(mapa.eq.6) then
        t80(15:)='F(obs)-F(cal) - difference Fourier'
      else if(mapa.eq.7) then
        t80(15:)='F(obs)**2*F(calc) - alpha synthesis'
      else if(mapa.eq.8) then
        t80(15:)='F(obs)**2/F(calc) - beta synthesis'
      else if(mapa.eq.9) then
        t80(15:)='1/0 - shape function'
      else
        call FeChybne(-1.,-1.,'wrong map type',' ',1,1)
        ErrJana=1
        go to 9999
      endif
      call newln(2)
      write(lst,FormA1)
      write(lst,FormA1)(t80(i:i),i=1,idel(t80))
      call newln(1)
      write(lst,FormA1)
      if(vyber.gt.0.) then
        call newln(1)
        write(lst,'(''Reflections with  |Fo| > '',f10.2,'' * |Fc| '',
     1              ''will not be used in the synthesis'')') vyber
      endif
      if(snlmx.le.0.0) snlmx=10.0
      call newln(1)
      write(lst,'(''Limits of sin(th)/lambda for acceptance are : '',
     1            2f10.6)') snlmn,snlmx
      if(ncomp.gt.1) then
        call newln(2)
        write(lst,'(/''Fourier for subsystem #'',i1,'' will be '',
     1               ''calculated'')') nsubs
      endif
      call newln(ndim+2)
      write(lst,FormA1)
      write(lst,'(''Scope of the map :'')')
      do 2050i=1,ndim
        if(nx(i).gt.1) then
          write(lst,'(a2,'' from'',f8.4,'' to'',f8.4,'' step'',f7.4)')
     1          cx(i),xfmn(i),xfmx(i),xdf(i)
        else
          xfmn(i)=(xfmn(i)+xfmx(i))*.5
          xfmx(i)=xfmn(i)
          write(lst,'(a2,'' fixed to'',f8.4)') cx(i),xfmn(i)
        endif
2050  continue
      call newln(2)
      write(lst,FormA1)
      write(t80,'(''Orientation : '',6i1)')(iorien(i),i=1,ndim)
      write(lst,FormA1)(t80(i:i),i=1,idel(t80))
      if(lcalc.eq.1) then
        call FeButtonMake(2,0,ButtonXMin(2),ButtonYMin(2),30.,8.,
     1                    '%Break')
        call FeMoveMouseTo((ButtonXMin(2)+ButtonXMax(2))*.5,
     1                     (ButtonYMin(2)+ButtonYMax(2))*.5)
        pom=0.
        do 2100i=1,1000
          trgtbl(i)=cos(pom)
          pom=pom+pi2*.001
2100    continue
        trgtbl(1)   = 1.0
        trgtbl(251) = 0.0
        trgtbl(501) =-1.0
        trgtbl(751) = 0.0
        trgtbl(1001)= 1.0
        rewind 82
        do 2900i=1,6
          mxh(i)=0
2900    continue
        if(ExistM80) then
          rewind 80
          nref=0
2910      if(formatted) then
            read(80,Format80,end=2912)
            isent=0
            go to 2914
2912        isent=1
          else
            read(80) isent
          endif
2914      nref=nref+1
          if(isent.ne.0) go to 2920
          go to 2910
2920      rewind 80
        else
          nref=nref91
        endif
        nref=nref*4
        call FeFlowChartOpen(-1.,-1.,'Expanding of reflections')
        nmod=max(nint(float(nref)*.005),10)
        n=0
3000    if(ExistM80) then
          if(formatted) then
            read(80,Format80,end=3002)(ih(i),i=1,ndim),fo1,fc
            isent=0
            go to 3004
3002        isent=1
          else
            read(80) isent,(ih(i),i=1,ndim),fo1,fo2,fc,ac,bc,sinthl,i
          endif
        else
          read(91,format91)(ih(i),i=1,ndim),fo1,fo2
          if(ih(1).lt.900) then
            isent=0
          else
            isent=1
          endif
        endif
3004    if(isent.eq.0) then
          if(nsubs.gt.1) then
            do 3010i=1,ndim
              hh(i)=ih(i)
3010        continue
            call multm(hh,zvi(1,nsubs),hhp,1,ndim,ndim)
            do 3020i=1,ndim
              ih(i)=nint(hhp(i))
3020        continue
          endif
          do 3100i=1,ns
            call multmi(ih,mr6(1,i,nsubs),ihpp,1,ndim,ndim)
            do 3050j=1,ndim
              mxh(j)=max(mxh(j),iabs(ihpp(iorien(j))))
3050        continue
3100      continue
          n=n+1
          call BudeBreak
          if(ErrJana.ne.0) go to 9000
          if(mod(n,nmod).eq.0) call FeFlowChartDraw(n,nref)
          go to 3000
        endif
        iz=n
        do 3200i=1,ndim
          mxd(i)=2*mxh(i)+1
3200    continue
        if(ExistM80) then
          rewind 80
        else
          rewind 91
        endif
        kolik=0
4000    if(ExistM80) then
          if(formatted) then
            read(80,Format80,end=4002)(ih(i),i=1,ndim),fo1,fc
            isent=0
            fc=fc*torad
            ac=fo1*cos(fc)
            bc=fo1*sin(fc)
            fo2=fo1
            fc=fo1
            call FromIndSinthl(ih,hh,sinthl,sinthlq,1,0)
            go to 4004
4002        isent=1
          else
            read(80) isent,(ih(i),i=1,ndim),fo1,fo2,fc,ac,bc,sinthl,i
          endif
          if(isent.ne.0) go to 5000
        else
          read(91,format91)(ih(i),i=1,ndim),fo1,fo2
          if(ih(1).lt.900) then
            if(fo1.gt.0.) then
              fo1=sqrt(fo1)
            else
              fo1=0.
            endif
            fo2=fo1
            call FromIndSinthl(ih,hh,sinthl,sinthlq,1,0)
          else
            go to 5000
          endif
        endif
4004    iz=iz+1
        call BudeBreak
        if(ErrJana.ne.0) go to 9000
        if(mod(iz,nmod).eq.0) call FeFlowChartDraw(iz,nref)
        iz=iz+1
        if(mod(iz,nmod).eq.0) call FeFlowChartDraw(iz,nref)
        iz=iz+1
        if(mod(iz,nmod).eq.0) call FeFlowChartDraw(iz,nref)
        if(metoda.eq.1) then
          fo=fo1
        else
          fo=fo2
        endif
        if(vyber.gt.0.and.abs(fo).gt.vyber*abs(fc)) go to 4000
        if(sinthl.gt.snlmx.or.sinthl.lt.snlmn) go to 4000
        if(fc.ne.0.) then
          cosaq=ac/fc
          sinaq=bc/fc
        else
          cosaq=0.
          sinaq=0.
        endif
        if(ndim.gt.3.and.nsubs.gt.1) then
          do 4005i=1,ndim
            hh(i)=ih(i)
4005      continue
          call multm(hh,zvi(1,nsubs),hhp,1,ndim,ndim)
          do 4008i=1,ndim
            ih(i)=nint(hhp(i))
4008      continue
        endif
        if(mapa.eq.1) then
          frp=fo**2
          fip=0.
        else if(mapa.eq.2) then
          frp=fc**2
          fip=0.
        else if(mapa.eq.3) then
          frp=fo**2-fc**2
          fip=0.
        else if(mapa.eq.4) then
          frp=fo*cosaq
          fip=fo*sinaq
        else if(mapa.eq.5) then
          frp=fc*cosaq
          fip=fc*sinaq
        else if(mapa.eq.6) then
          pom=fo-fc
          frp=pom*cosaq
          fip=pom*sinaq
        else if(mapa.eq.7) then
          pom=fo**2
          frp=pom*ac
          fip=pom*bc
        else if(mapa.eq.8) then
          pom=fo/fc
          frp=pom*ac
          fip=pom*bc
        else if(mapa.eq.9) then
          frp=1.
          fip=0.
        endif
        if(ih(1).eq.0.and.ih(2).eq.0.and.ih(3).eq.0) then
          frp=frp/2.
          fip=fip/2.
        endif
        if(Patterson) then
          rho=sinthl**2*rhom
          if(srnat.gt.0.) then
            if(ntab.gt.0) then
              pt=sinthl/.05+1.
              ipt=ifix(pt)-1
              do 4010i=1,nf
                fx(i)=ffr(i)
4010          continue
              do 4050k=1,4
                pom=1.
                do 4030l=1,4
                if(k.ne.l) pom=pom*(pt-float(ipt+l))/float(k-l)
4030            continue
                do 4040i=1,nf
                  l=k+ipt
                  if(l.gt.0) then
                    if(l.le.ntab) then
                      ffp=ff(l,i)
                    else
                      ffp=ff(ntab,i)
                    endif
                  else
                    ffp=ff(1,i)
                  endif
                  fx(i)=fx(i)+pom*ffp
4040            continue
4050          continue
            else
              do 4070i=1,nf
                fx(i)=ff(10,i)+ffr(i)
                j=0
                do 4060k=2,8,2
                  arg=-sinthl**2*ff(k+1,i)
                  if(arg.lt.-60.) go to 4060
                  fx(i)=fx(i)+ff(k,i)*exp(arg)
4060            continue
4070          continue
            endif
            pom=0.
            do 4077i=1,nf
              pom=pom+rnat(i)*sqrt(fx(i)**2+ffi(i)**2)
4077        continue
          else
            pom=1.
          endif
          pom=pom*exp(-to*rho)
          frp=frp*(pom0/pom)**2
        endif
        do 4200i=1,ns
          call multmi(ih,mr6(1,i,nsubs),ihpp,1,ndim,ndim)
          arg=0.
          do 4110j=1,ndim
            arg=arg-float(ih(j))*s6(j,i,nsubs)
4110      continue
          arg=arg*pi2
          cs=cos(arg)
          sn=sin(arg)
          pom1=twov*(frp*cs-fip*sn)
          pom2=twov*(frp*sn+fip*cs)
          do 4116j=1,ndim
            if(ihpp(iorien(j)).lt.0) then
              pom2=-pom2
              do 4115k=1,ndim
                ihpp(k)=-ihpp(k)
4115          continue
              go to 4118
            else if(ihpp(iorien(j)).gt.0) then
              go to 4118
            endif
4116      continue
4118      indp=0
          do 4120j=ndim,1,-1
            indp=indp*mxd(j)+ihpp(iorien(j))+mxh(j)
4120      continue
          do 4130j=1,kolik
            if(indp.eq.ind(j)) then
              fr(j)=fr(j)+pom1
              fi(j)=fi(j)+pom2
              mlt(j)=mlt(j)+1
              go to 4200
            endif
4130      continue
          kolik=kolik+1
          fr(kolik)=pom1
          fi(kolik)=pom2
          mlt(kolik)=1
          ind(kolik)=indp
4200    continue
        go to 4000
5000    rewind(82)
        call FeFlowChartRemove
        do 5010i=ndim+1,6
          ihp(i)=0
5010    continue
        kmin= 999999
        kmax=-999999
        hmin= 999999
        hmax=-999999
        do 5200i=1,kolik
          indp=ind(i)
          do 5020j=1,ndim
            ihp(j)=mod(indp,mxd(j))-mxh(j)
            indp=indp/mxd(j)
5020      continue
          hmax=max(hmax,ihp(1))
          hmin=min(hmin,ihp(1))
          kmax=max(kmax,ihp(2))
          kmin=min(kmin,ihp(2))
          if(mlt(i).ne.1) then
            pom=1./float(mlt(i))
            fr(i)=fr(i)*pom
            fi(i)=fi(i)*pom
          endif
          write(82) ihp,fr(i),fi(i)
5200    continue
        rewind 82
      endif
      go to 9999
9000  call DeleteFile(fln(:ifln)//'.m81')
      call DeleteFile(fln(:ifln)//'.m82')
9999  return
      end
      subroutine BudeBreak
      include 'params.cmn'
      include 'basic.cmn'
      include 'fepc.cmn'
      logical FeYesNo
      call FeEvent(1)
      if(EventType.eq.1.and.EventNumber.eq.2) then
        call FeButtonOn(2)
        if(FeYesNo(-1.,30.,'Do you really want to break the '//
     1             'Fourier summation?',0)) then
          call FeFlowChartRemove
          call DeleteFile(fln(1:ifln)//'.m81')
          call DeleteFile(fln(1:ifln)//'.m82')
          ErrJana=1
        endif
        call FeButtonOff(2)
      endif
      return
      end
      subroutine NactiFourier
      include 'params.cmn'
      include 'basic.cmn'
      include 'fourier.cmn'
      include 'atoms.cmn'
      call Najdi('fourier',i)
      if(i.ne.1) go to 9999
      do 1000i=1,NactiKeys
        NactiRepeat(i)=0
1000  continue
1100  call NactiCommon(izpet)
      if(izpet.eq.0) then
        do 2000i=1,NactiInt+NactiReal
          if(NactiRepeat(i).le.0) go to 2000
          if(i.le.NactiInt) then
            j=NacetlInt(i)
          else
            p=NacetlReal(i)
          endif
          if(i.eq.1) then
            kharm=j
          else if(i.eq.2) then
            ncollar=j
          else if(i.eq.3) then
            mapa=j
          else if(i.eq.4) then
            noo(1)=j
            noo(2)=j
          else if(i.eq.5) then
            npeaks(1)=j
          else if(i.eq.6) then
            npeaks(2)=j
          else if(i.eq.7) then
            lcalc=j
          else if(i.eq.8) then
            lpeaks=j
          else if(i.eq.9) then
            nsubs=j
          else if(i.eq.10) then
            metoda=j
          else if(i.eq.21) then
            snlmn=p
          else if(i.eq.22) then
            snlmx=p
          else if(i.eq.23) then
            vyber=p
          else if(i.eq.24) then
            ptstep=p
          else if(i.eq.25) then
            to=p
          else if(i.eq.26) then
            to=p
          else if(i.eq.27) then
            dmax=p
          endif
2000    continue
        go to 9999
      else if(izpet.le.9) then
        if(izpet.le.3) then
          j=izpet
        else
          j=izpet-3
        endif
        call kus(NactiVeta,PosledniPozice,cislo)
        call posun(cislo,1)
        read(cislo,102,err=9000) p
        xrmn(j,1)=p
        xrmn(j,2)=p
        call kus(NactiVeta,PosledniPozice,cislo)
        call posun(cislo,1)
        read(cislo,102,err=9000) p
        xrmx(j,1)=p
        xrmx(j,2)=p
        call kus(NactiVeta,PosledniPozice,cislo)
        call posun(cislo,1)
        read(cislo,102,err=9000) p
        if(p.le.0.) p=1.
        dd(j,1)=p
        dd(j,2)=p
      else if(izpet.eq.10) then
        k=PosledniPozice
        do 2100j=1,3
          call kus(NactiVeta,PosledniPozice,cislo)
          if(cislo(1:1).eq.'n') go to 2120
          call posun(cislo,1)
          read(cislo,102,err=2120) ptx(j)
2100    continue
        ptname='[neco]'
        go to 1100
2120    ptname=NactiVeta(k+1:80)
        call uprat(ptname)
      else if(izpet.eq.11) then
        do 2200j=1,3
          call kus(NactiVeta,PosledniPozice,cislo)
          call posun(cislo,1)
          read(cislo,102,err=9000) pts(j)
2200    continue
      else if(izpet.eq.12) then
        call kus(NactiVeta,PosledniPozice,Format80)
        if(Format80(1:1).eq.'''') Format80(1:1)=' '
        j=idel(format80)
        if(Format80(j:j).eq.'''') Format80(j:j)=' '
        call Zhusti(Format80)
      endif
      if(izpet.ne.0) go to 1100
9000  call ChybaNacteni(izpet+NactiReal+NactiInt)
      go to 1100
9999  return
102   format(f15.5)
      end
      subroutine FourierSum
      include 'params.cmn'
      include 'basic.cmn'
      include 'fourier.cmn'
      dimension ihp(6)
      write(81) nx,nxny,nmap,(xfmn(i),xfmx(i),i=1,6),xdf,iorien,mapa,
     1           nsubs
      kdel=kmax-kmin+1
      nc=(hmax+1)*kdel
      ncd=nc*2
      nef=(hmax+1)*nx(2)*2
      ncdef=ncd+nef
      if(ncdef+nxny.gt.mxtbl) then
        call FeChybne(-1.,-1.,'size of the array "table" isn''t '//
     1                'sufficient','to perform Fourier summation',1,1)
        ErrJana=1
        return
      endif
      rmax=0.
      rmin=0.
      v=xfmn(6)
      nall=nx(3)*nx(4)*nx(5)*nx(6)
      call FeFlowChartOpen(-1.,-1.,'Fourier summation')
      nn=0
      do 6000iv=1,nx(6)
        u=xfmn(5)
        do 5000iu=1,nx(5)
          t=xfmn(4)
          do 4000it=1,nx(4)
            z=xfmn(3)
            do 3000iz=1,nx(3)
              nn=nn+1
              call FeFlowChartDraw(nn,nall)
              do 2020i=1,ncdef+nxny
                table(i)=0.
2020          continue
2030          read(82,end=2080) ihp,ai,bi
              locc=ihp(1)*kdel+(ihp(2)-kmin)+1
              locd=locc+nc
              xlz=float(ihp(3))*z
              if(ndim.gt.3) xlz=xlz+float(ihp(4))*t
              if(ndim.gt.4) xlz=xlz+float(ihp(5))*u
              if(ndim.gt.5) xlz=xlz+float(ihp(6))*v
              call sncs(xlz,sinlz,coslz)
              table(locc)=table(locc)+ai*coslz+bi*sinlz
              table(locd)=table(locd)-ai*sinlz+bi*coslz
              go to 2030
2080          rewind 82
              ne=nx(2)*(hmax+1)
              locei=ncd+1
              locc=1
              locd=locc+nc
              rkyip=kmin
              rkdyp=rkyip*xdf(2)
              rkyip=rkyip*xfmn(2)
              do 2150n=1,hmax+1
                rkdy=rkdyp
                rkyi=rkyip
                do 2140m=1,kdel
                  loce=locei
                  rky=rkyi
                  locf=loce+ne
                  chy=table(locc)
                  dhy=table(locd)
                  do 2130i=1,nx(2)
                    call sncs(rky,sinky,cosky)
                    table(loce)=table(loce)+chy*cosky+dhy*sinky
                    table(locf)=table(locf)-chy*sinky+dhy*cosky
                    loce=loce+(hmax+1)
                    locf=loce+ne
                    rky=rky+rkdy
2130              continue
                  rkyi=rkyi+xfmn(2)
                  rkdy=rkdy+xdf(2)
                  locc=locc+1
                  locd=locc+nc
2140            continue
                locei=locei+1
2150          continue
              loce=ncd+1
              locf=loce+ne
              nrn=ncdef
              nstart=ncdef+1
              inter=0
              do 2240i=1,nx(2)
                hdx=0.
                hxi=0.
                do 2210m=1,hmax+1
                  e=table(loce)
                  f=table(locf)
                  hx=hxi
                  do 2200n=1,nx(1)
                    inter=inter+1
                    if(mod(inter,1000).eq.1) call BudeBreak
                    if(ErrJana.ne.0) return
                    loc=nrn+n
                    call sncs(hx,sinhx,coshx)
                    table(loc)=table(loc)+e*coshx+f*sinhx
                    hx=hx+hdx
2200              continue
                  hdx=hdx+xdf(1)
                  hxi=hxi+xfmn(1)
                  loce=loce+1
                  locf=loce+ne
2210            continue
                nrn=loc
2240          continue
              do 2242n=nstart,nrn
                rmax=max(rmax,table(n))
                rmin=min(rmin,table(n))
2242          continue
              write(81)(table(i),i=nstart,nrn)
              z=z+xdf(3)
3000        continue
            t=t+xdf(4)
4000      continue
          u=u+xdf(5)
5000    continue
        v=v+xdf(6)
6000  continue
      call FeFlowChartRemove
      write(81) rmax,rmin
      call newln(2)
      write(lst,'(/''Maximal density : '',f8.2,
     1             '', minimal density : '',f8.2)') rmax,rmin
      if(mapa.eq.6) then
        open(89,file='fourier.tmp')
        write(89,'(''fourier'')')
        write(89,'(''rhomax/min:'',2f8.2)') rmax,rmin
        write(89,'(''end'')')
        close(89)
      endif
      close(82,status='delete')
      return
      end
      subroutine sncs(arg,sinarg,cosarg)
      include 'params.cmn'
      include 'basic.cmn'
      include 'fourier.cmn'
      arg=arg-float(ifix(arg))
      if(arg.lt.0.) arg=arg+1.
      narg1=nint(arg*1000.)+1
      narg2=narg1+250
      if(narg2.gt.1001) narg2=narg2-1000
      sinarg=-trgtbl(narg2)
      cosarg=trgtbl(narg1)
      return
      end
      subroutine peaks(Klic,m81)
      include 'params.cmn'
      include 'basic.cmn'
      include 'fourier.cmn'
      include 'atoms.cmn'
      include 'fepc.cmn'
      parameter (mxtuv=50,mxwm=mxw21*(mxw+1))
      dimension x456(3),xp(6),stred(3),y1(6),y2(6),y3(6),vu(3),vv(3),
     1          vug(3),xold(6),am(mxwm),ps(mxw21,3),der(mxw21),
     2          waven(mxw21,3),waveo(mxw21,3),kmod(mxa,mxtuv),
     3          romod(mxa,mxtuv),x48(3,mxa),nmod(mxtuv),nroi(mxa),
     4          xmd(6,mxtuv),xmod(3,mxa,mxtuv),ux48(3,mxw,mxa),
     5          uy48(3,mxw,mxa)
      character*132 ven,vent
      character*80 t80
      character*27 format2
      character*24 format1
      character*8 znak
      character*4 ext
      integer roave
      logical mameji,ExistFile
      do 1000j=1,2
        write(ext,109) 46+j
        t80=fln(1:ifln)//ext
        i=idel(t80)
        if(ExistFile(t80(1:i))) call DeleteFile(t80(1:i))
1000  continue
      rewind(m81)
      read(m81) nx,nxny,nmap,(xfmn(i),xfmx(i),i=1,6),xdf,iorien,mapa,
     1          nsubs
      ntu =nx(4)*nx(5)
      ntuv=ntu*nx(6)
      do 1010i=1,3
        if(iorien(i).gt.3) then
          ErrJana=1
          go to 9999
        endif
1010  continue
      if(ntuv.gt.mxtuv) then
        t80='the maximum number of '
        write(t80(23:),'(i3)') mxtuv
        t80=t80(1:25)//' sections exceeded'
        call FeChybne(-1.,-1.,t80,' ',1,-1)
        ErrJana=1
        go to 9999
      endif
      do 1020i=1,nmap
        read(m81)(tbl(j,1),j=1,nxny)
1020  continue
      read(m81) rmax,rmin
      rmax=max(rmax,-rmin)
      format1='(i3,''.'',3f10.6,f12.2,i5)'
      if(rmax.gt.99900000.00) format1(16:20)='e12.5'
      format2='(i3,''/'',i3,3f8.4,f10.2,''|'')'
      if(rmax.gt.999000.00) format2(18:22)='e10.3'
      pom=rmax*33.33/float(imax)
      redukce=1.
1025  if(pom.gt.1.) then
        redukce=redukce*.1
        pom=pom*.1
        go to 1025
      endif
      rmax=rmax*redukce
      eq48=0.
      if(Klic.eq.0) then
        do 1030i=1,3
          eq48=max(eq48,xdf(i)*cell(iorien(i),nsubs))
1030    continue
        eq48=max(.1,eq48)
      else
        do 1031i=1,3
          eq48=max(eq48,xdf(i))
1031    continue
      endif
      open(46,file=fln(1:ifln)//'.m46')
      nflmx=0
      if(npeaks(1).ge.1) nflmx=nmap
      if(npeaks(2).ge.1) nflmx=nflmx+nmap
      if(nflmx.gt.0) call FeFlowChartOpen(-1.,-1.,
     1                                    'Peak searching procedure')
      nfl=0
      do 9000kzap=1,-1,-2
        if(kzap.gt.0) then
          npik=npeaks(1)
          znak='positive'
          m4=48
        else
          npik=npeaks(2)
          znak='negative'
          m4=47
          kharm=0
        endif
        if(npik.le.0) go to 9000
        call newln(2)
        write(lst,'(/''Searching of '',a8,'' peaks - maximum number '',
     1              ''of peaks to be found : '',i3)') znak,npik
        if(redukce.lt..9) then
          call newln(2)
          write(lst,'(/''Scaling factor '',f12.8,'' will be applied'')')
     1      redukce
        endif
        rewind 46
        rewind m81
        read(m81) nx,nxny,nmap,(xfmn(i),xfmx(i),i=1,6),xdf,iorien,mapa,
     1            nsubs
        rzap=kzap
        do 1100i=1,3
          x456(i)=xfmn(i+3)
1100    continue
        do 2120iv=1,nx(6)
          do 2110iu=1,nx(5)
            do 2100it=1,nx(4)
              romez=0
              iz=0
              ipik=0
1600          call cteni(1,kzap,iz,m81)
              nfl=nfl+1
              call FeFlowChartDraw(nfl,nflmx)
              lstr=1
              rez=xfmn(3)
              if(nx(3).le.2) go to 1710
              call cteni(2,kzap,iz,m81)
              nfl=nfl+1
              call FeFlowChartDraw(nfl,nflmx)
              lpod=3
              lnad=2
1700          i=lnad
              lnad=lpod
              lpod=lstr
              lstr=i
              call cteni(lnad,kzap,iz,m81)
              rez=rez+xdf(3)
              nfl=nfl+1
              call FeFlowChartDraw(nfl,nflmx)
1710          ipct=nx(1)
              do 1900i=2,nx(2)-1
                i10=ipct+1
                t110=tbl(i10,lstr)
                do 1890j=2,nx(1)-1
                  i11=i10+1
                  i12=i11+1
                  i01=i11-nx(1)
                  i00=i01-1
                  i02=i01+1
                  i21=i11+nx(1)
                  i20=i21-1
                  i22=i21+1
                  t121=tbl(i21,lstr)
                  t101=tbl(i01,lstr)
                  t111=tbl(i11,lstr)
                  t112=tbl(i12,lstr)
                  if(t111.lt.t110) go to 1880
                  if(t111.le.t112) go to 1880
                  if(t111.lt.t101) go to 1880
                  if(t111.le.t121) go to 1880
                  if(t111.lt.tbl(i00,lstr)) go to 1880
                  if(t111.le.tbl(i20,lstr)) go to 1880
                  if(t111.lt.tbl(i02,lstr)) go to 1880
                  if(t111.le.tbl(i22,lstr)) go to 1880
                  t011=t111
                  t211=t111
                  if(nx(3).le.2) go to 1740
                  t011=tbl(i11,lpod)
                  t211=tbl(i11,lnad)
                  if(t111.lt.t011) go to 1880
                  if(t111.le.t211) go to 1880
                  if(t111.lt.tbl(i00,lpod)) go to 1880
                  if(t111.le.tbl(i00,lnad)) go to 1880
                  if(t111.lt.tbl(i01,lpod)) go to 1880
                  if(t111.le.tbl(i01,lnad)) go to 1880
                  if(t111.lt.tbl(i02,lpod)) go to 1880
                  if(t111.le.tbl(i02,lnad)) go to 1880
                  if(t111.lt.tbl(i10,lpod)) go to 1880
                  if(t111.le.tbl(i10,lnad)) go to 1880
                  if(t111.lt.tbl(i12,lpod)) go to 1880
                  if(t111.le.tbl(i12,lnad)) go to 1880
                  if(t111.lt.tbl(i20,lpod)) go to 1880
                  if(t111.le.tbl(i20,lnad)) go to 1880
                  if(t111.lt.tbl(i21,lpod)) go to 1880
                  if(t111.le.tbl(i21,lnad)) go to 1880
                  if(t111.lt.tbl(i22,lpod)) go to 1880
                  if(t111.le.tbl(i22,lnad)) go to 1880
1740              k=iorien(1)
                  call vrchol(xfmn(1)+float(j-1)*xdf(1),xdf(1),t110,t111
     1                       ,t112,xp(k),r)
                  k=iorien(2)
                  call vrchol(xfmn(2)+float(i-1)*xdf(2),xdf(2),t101,t111
     1                       ,t121,xp(k),s)
                  k=iorien(3)
                  call vrchol(rez,xdf(3),t011,t111,t211,xp(k),t)
                  do 1750k=1,3
                    l=iorien(k)
                    if(xp(l).lt.xfmn(k).or.xp(l).gt.xfmx(k)) go to 1880
1750              continue
                  pom=(r+s+t)*redukce
                  roave=nint(-33.3333*pom)
                  if(roave.lt.romez) call zarad(xp,roave,x48,ipik,npik,
     1                                          klic)
1880              t110=t111
                  i10=i11
1890            continue
                ipct=ipct+nx(1)
1900          continue
              if(iz.lt.nx(3)) then
                if(nx(3).gt.2) then
                  go to 1700
                else
                  go to 1600
                endif
              endif
              if(ipik.lt.npik.and.ipik.gt.0) call indexx(ipik,ro,nro)
              write(46,101) ipik,x456
              na48=ipik
              do 2090n=1,ipik
                j=nro(n)
                write(46,102)(x48(i,j),i=1,3),-float(ro(j))/100.*rzap
2090          continue
              x456(1)=x456(1)+xdf(4)
2100        continue
            x456(2)=x456(2)+xdf(5)
2110      continue
          x456(3)=x456(3)+xdf(6)
2120    continue
        if(ntuv.eq.1) then
          kharm=0
          go to 5000
        endif
        rewind 46
        mxnmod=0
        do 2420k=1,ntuv
          read(46,101) nmod(k)
          mxnmod=max(mxnmod,nmod(k))
          do 2410j=1,nmod(k)
            read(46,102)(xmod(i,j,k),i=1,3),romod(j,k)
2410      continue
          do 2415j=1,nmod(k)
            kmod(j,k)=0
2415      continue
2420    continue
        if(ndim.gt.4.or.kzap.eq.-1.or.Patterson) go to 4900
        dmq=dmax**2
        nlsq=2*kharm+1
        nam=nlsq*(kharm+1)
        der(1)=1.
        nm=0
        na48=0
        jp=1
        kp=1
2500    do 2520k=kp,ntuv
          do 2510j=jp,nmod(k)
            if(kmod(j,k).eq.0) go to 2530
2510      continue
          jp=1
2520    continue
        go to 4800
2530    jp=j
        kp=k
        n=1
        nm=nm+1
        do 2540i=1,3
          do 2535j=1,nlsq
            waveo(j,i)=0.
2535      continue
          xmd(i,n)=xmod(i,jp,kp)
          stred(i)=xmd(i,n)
2540    continue
        call trmod(kp,xmd(4,n))
        call od0do1(xmd(1,n),xmd(1,n),6)
        do 2541j=1,6
          xold(j)=xmd(j,n)
2541    continue
        kmod(jp,kp)=nm
        rop=romod(jp,kp)
        romin=rop*.5
        do 3900k=kp+1,ntuv
          do 3890j=1,nmod(k)
            if(kmod(j,k).ne.0.or.romod(j,k).lt.romin) go to 3890
            mameji=.false.
            do 2545i=1,3
              xp(i)=xmod(i,j,k)
2545        continue
            call trmod(k,xp(4))
            do 3700jsym=1,ns
              call multm(rm6(1,jsym,nsubs),xp,y1,ndim,ndim,1)
              do 3600jcntrsm=1,3-ncs
                zn=3-2*jcntrsm
                do 3120i=1,ndim
                  y2(i)=y1(i)*zn+s6(i,jsym,nsubs)
3120            continue
                do 3500ivt=1,nvt
                  do 3190i=1,ndim
                    y3(i)=y2(i)+vt6(i,ivt,nsubs)
3190              continue
                  call od0do1(y3,y3,ndim)
                  do 3200i=1,3
                    vv(i)=y3(i)-xold(i)
3200              continue
                  do 3400i1=1,3
                    w1=i1-2
                    u1=vv(1)+w1
                    vu(1)=u1
                    do 3300i2=1,3
                      w2=i2-2
                      u2=vv(2)+w2
                      vu(2)=u2
                      do 3290i3=1,3
                        w3=i3-2
                        u3=vv(3)+w3
                        vu(3)=u3
                        call multm(g(1,nsubs),vu,vug,3,3,1)
                        uu=scalmul(vu,vug)
                        if(uu.gt.dmq) go to 3290
                        mameji=.true.
                        n=n+1
                        do 3210i=1,3
                          xmd(i,n)=vu(i)+xold(i)
                          stred(i)=stred(i)+xmd(i,n)
                          xold(i)=xmd(i,n)
3210                    continue
                        do 3211i=4,6
                          xmd(i,n)=y3(i)
3211                    continue
                        rop=rop+romod(j,k)
                        go to 3710
3290                  continue
3300                continue
3400              continue
3500            continue
3600          continue
3700        continue
3710        if(mameji) then
              kmod(j,k)=nm
              go to 3900
            endif
3890      continue
3900    continue
        iter=0
        u=1./float(n)
        rop=rop*u
        do 3910i=1,3
          stred(i)=stred(i)*u
3910    continue
3999    iter=iter+1
        do 4005i=1,nlsq
          do 4000j=1,3
            ps(i,j)=0.
4000      continue
4005    continue
        do 4010i=1,nam
          am(i)=0.
4010    continue
        do 4100k=1,n
          arg=pi2*(xmd(4,k)-qu(1,1,1)*(xmd(1,k)-stred(1))
     1                     -qu(2,1,1)*(xmd(2,k)-stred(2))
     2                     -qu(3,1,1)*(xmd(3,k)-stred(3)))
          j=0
          do 4050i=1,kharm
            pom=float(i)*arg
            j=j+2
            der(j)=sin(pom)
            der(j+1)=cos(pom)
4050      continue
          call SumaPeaks(der,xmd(1,k),am,ps,nlsq)
4100    continue
        call smi(am,der,nlsq,ising)
        if(ising.eq.1.or.n*2.lt.ntuv) then
          do 4150i=1,3
            waven(1,i)=stred(i)
4150      continue
          iter=0
          go to 4600
        endif
        do 4200i=1,3
          call nasob(am,ps(1,i),waven(1,i),nlsq)
4200    continue
        do 4300i=1,3
          stred(i)=waven(1,i)
4300    continue
        pom=0.
        do 4500i=1,3
          do 4450j=1,nlsq
            pom=pom+abs(waven(j,i)-waveo(j,i))
            waveo(j,i)=waven(j,i)
4450      continue
4500    continue
        if(pom.gt..001.and.iter.le.5) go to 3999
4600    if(iter.le.5.and.iter.gt.0) then
          na48=na48+1
          do 4700i=1,3
            k=2
            do 4650j=1,kharm
              ux48(i,j,na48)=waven(k  ,i)
              uy48(i,j,na48)=waven(k+1,i)
              k=k+2
4650        continue
            x48(i,na48)=waven(1,i)
4700      continue
          ro(na48)=nint(-rop*100.)
        endif
        go to 2500
4800    if(na48.gt.1) then
          call indexx(na48,ro,nro)
        else
          nro(1)=1
        endif
4900    do 4902i=1,mxa
          nroi(i)=0
4902    continue
        do 4905i=1,na48
          nroi(nro(i))=i
4905    continue
        iz=1
        m=(nx(4)-1)/3+1
        kk=mod(nx(4)-1,3)+1
        if(kzap.eq.-1) then
          romez=0
          ipik=0
        endif
        x456(3)=xfmn(6)
        do 4990iv=1,nx(6)
          x456(2)=xfmn(5)
          do 4980iu=1,nx(5)
            x456(1)=xfmn(4)
            do 4970it=1,m
              if(it.ne.m) then
                n=2
              else
                n=kk-1
              endif
              if(line.gt.mxline-10) call newpg(0)
              call newln(3)
              write(lst,107)
              if(ndim.eq.4) then
                write(ven,104) cx(4),x456(1)
              else if(ndim.eq.5) then
                write(ven,105) cx(4),x456(1),cx(5),x456(2)
              else
                write(ven,106) cx(4),x456(1),cx(5),x456(2),cx(6),x456(3)
              endif
              if(n.gt.0) then
                if(ndim.eq.4) then
                  write(ven(43:),104) cx(4),x456(1)+xdf(4)
                else if(ndim.eq.5) then
                  write(ven(43:),105) cx(4),x456(1)+xdf(4),cx(5),
     1                                x456(2)+xdf(5)
                else
                  write(ven(43:),106) cx(4),x456(1)+xdf(4),
     1                                cx(5),x456(2)+xdf(5),
     2                                cx(6),x456(3)+xdf(6)
                endif
                if(n.gt.1) then
                  if(ndim.eq.4) then
                    write(ven(85:),104) cx(4),x456(1)+2.*xdf(4)
                  else if(ndim.eq.5) then
                    write(ven(85:),105) cx(4),x456(1)+2.*xdf(4),
     1                                  cx(5),x456(2)+2.*xdf(5)
                  else
                    write(ven(85:),106) cx(4),x456(1)+2.*xdf(4),
     1                                  cx(5),x456(2)+2.*xdf(5),
     2                                  cx(6),x456(3)+2.*xdf(6)
                  endif
                endif
              endif
              write(lst,107) ven
              write(ven,108)
              if(n.gt.0) write(ven(43:),108)
              if(n.gt.1) write(ven(85:),108)
              write(lst,107) ven
              do 4950j=1,mxnmod
                call newln(1)
                ven=' '
                ii=1
                do 4945k=iz,iz+n
                  if(j.gt.nmod(k)) go to 4940
                  if(ndim.eq.4.and.kzap.eq.1.and..not.Patterson) then
                    write(ven(ii:),format2) j,nroi(kmod(j,k)),
     1                   (xmod(i,j,k),i=1,3),romod(j,k)
                  else
                    write(ven(ii:),format2) j,0,(xmod(i,j,k),i=1,3),
     1                                     romod(j,k)
                    if(kzap.eq.-1.or.Patterson) then
                      ip=kzap*nint(-romod(j,k)*100.)
                      if(ip.lt.romez) call zarad(xmod(1,j,k),ip,x48,
     1                                           ipik,npik,klic)
                    endif
                  endif
4940              ii=ii+42
4945            continue
                write(lst,107) ven
4950          continue
              iz=iz+n+1
              x456(1)=x456(1)+3.*xdf(4)
4970        continue
            x456(2)=x456(2)+3.*xdf(5)
4980      continue
          x456(3)=x456(3)+xdf(6)
4990    continue
5000    call newln(3)
        write(lst,'(/''The list of '',a8,'' peaks written to the file ''
     1             ,''m4'',i1/)') znak,7+(kzap+1)/2
        if(ndim.gt.3) then
          if(kzap.eq.1.and..not.Patterson) then
            if(kharm.ne.0) then
              call newln(1)
              write(lst,'(''These peaks were successfully interpreted''
     1                   ,'' with '',i1,'' harmonic wave(s)'')') kharm
            endif
          else
            write(lst,'('' which are the first '',i2,'' extremes '',
     1                  ''peaks'')') ipik
            if(ipik.lt.npik) call indexx(ipik,ro,nro)
          endif
        endif
        vent='         x         y         z            rho   rel'
        if(Patterson) then
          vent=vent(1:51)//'  to origin'
          na(1)=2
          nacalc=2
          Atom(1)='Origin'
          Atom(2)='Itself'
          do 5005i=1,3
            iswa(i)=1
            isf(i)=1
            itf(i)=1
            ai(i)=1.
            x(i,1)=0.
5005      continue
          call specat
        endif
        vent=vent(1:65)//vent(1:65)
        n2=0
        if(line.gt.mxline-12) call newpg(0)
5100    n1=n2+1
        n2=min(n2+2*(mxline-line-2),na48)
        n=n2-n1+1
        nn=(n-1)/2+1
        call newln(nn+2)
        write(lst,107) vent
        write(lst,107)
        do 5300ip=0,nn-1
          ven=' '
          l=1
          ll=n1+ip
          do 5250j=1,2
            if(ll.gt.n2) go to 5250
            inp=nro(ll)
            h=float(-ro(inp)*kzap)*.01
            if(klic.eq.0) then
              if(Patterson) then
                do 5210i=1,3
                  x(i,1)=0.
                  x(i,2)=x48(i,inp)
5210            continue
                call DistForOneAtom(2,20.,1,0)
                do 5212i=1,ndist
                  m=ipord(i)
                  if(adist(m).ne.'Itself') go to 5214
5212            continue
                Znak=' >20'
                go to 5220
5214            do 5218i=1,3
                  x48(i,inp)=xdist(i,m)
5218            continue
                write(Znak,'(f8.3)') ddist(m)
              else
                i=koinc(x48(1,inp),x,1,nacalc,eq48,pom,nsubs)
              endif
            endif
5220        write(ven(l:l+64),format1) ll,(x48(m,inp),m=1,3),h,
     1                                 nint(h*999./rmax)
            if(Patterson) then
              ven=ven(1:idel(ven))//'   '//Znak
            else
              if(i.gt.0) ven=ven(1:idel(ven))//' ='//atom(i)
            endif
            l=l+65
            ll=ll+nn
5250      continue
          write(lst,107) ven
5300    continue
        if(n2.lt.na48) then
          call newpg(0)
          go to 5100
        endif
        if(Patterson) then
          open(m40,file=fln(1:ifln)//'.m40')
          call iom40(0,0)
          close(m40)
        endif
        write(ext,109) m4
        open(m4,file=fln(1:ifln)//ext)
        write(m4,'(i5,15x,i5)') na48,nsubs
        write(m4,103) 1.
        do 5310i=1,3
          write(m4,103) 0.
5310    continue
        do 5400i=1,na48
          if(kzap.eq.1) then
            znak='max'
          else
            znak='min'
          endif
          write(znak(4:6),'(i3)') i
          call zhusti(znak)
          ii=nro(i)
          write(m4,'(a8,2i3,4x,4f9.6,6x,3i1,3i3)') znak,1,1,1.,
     1         (x48(j,ii),j=1,3),0,0,0,0,kharm,0
          h=-float(ro(ii))*.01
          if(h.gt.999000.00) then
            t80='(e9.3)'
          else
            t80='(f9.2)'
          endif
          write(m4,t80) -float(ro(ii))*.01
          do 5350j=1,kharm
            write(m4,103)(ux48(k,j,ii),k=1,3),(uy48(k,j,ii),k=1,3)
5350      continue
          if(kharm.gt.0) write(m4,103) 0.
5400    continue
        close(m4)
9000  continue
      if(nflmx.gt.0) call FeFlowChartRemove
      close(46,status='delete')
9999  return
101   format(i5,3f9.6)
102   format(3f9.6,e15.6)
103   format(6f9.6)
104   format(16x,a2,'=',f6.3,17x)
105   format(11x,2(a2,'=',f6.3,1x),11x)
106   format( 6x,3(a2,'=',f6.3,1x), 6x)
107   format(a132)
108   format('peak/atom    x       y       z       rho |')
109   format('.m',i2)
      end
      subroutine cteni(kam,kzap,iz,m81)
      include 'params.cmn'
      include 'basic.cmn'
      include 'fourier.cmn'
      read(m81)(tbl(j,kam),j=1,nxny)
      if(kzap.lt.0) then
        do 1100j=1,nxny
          tbl(j,kam)=-tbl(j,kam)
1100    continue
      endif
      iz=iz+1
      return
      end
      subroutine zarad(u,roave,x,n,npik,klic)
      include 'params.cmn'
      include 'basic.cmn'
      include 'fourier.cmn'
      dimension u(3),x(3,*)
      integer roave
      if(klic.eq.0) then
        l=koinc(u,x,1,n,eq48,pom,nsubs)
      else
        l=0
      endif
      if(l.ne.0) then
        if(roave.ge.ro(l)) go to 9999
        ro(l)=roave
        do 1000i=1,3
          x(i,l)=u(i)
1000    continue
        if(n.eq.npik) call indexx(n,ro,nro)
      else
        if(n.lt.npik) then
          n=n+1
          nro(n)=n
          kam=n
          ro(kam)=roave
          if(n.eq.npik) call indexx(n,ro,nro)
        else
          do 1100katy=1,n
            l=nro(katy)
            if(roave.lt.ro(l)) go to 1200
1100      continue
          call FeChybne(-1.,-1.,'what are you doing here ?!',' ',1,0)
          go to 9999
1200      kam=nro(n)
          ro(kam)=roave
          do 1250i=n,katy+1,-1
            nro(i)=nro(i-1)
1250      continue
          nro(katy)=kam
        endif
        do 1300i=1,3
          x(i,kam)=u(i)
1300    continue
      endif
      if(n.eq.npik) romez=ro(nro(npik))
9999  return
      end
      subroutine trmod(l,x)
      include 'params.cmn'
      include 'basic.cmn'
      include 'fourier.cmn'
      dimension x(3)
      i=mod(l-1,nx(4))
      n=l/nx(4)
      j=mod(n-1,nx(5))+1
      k=n/nx(5)-1
      x(1)=xfmn(4)+float(i)*xdf(4)
      x(2)=xfmn(5)+float(j)*xdf(5)
      x(3)=xfmn(6)+float(k)*xdf(6)
      return
      end
      subroutine SumaPeaks(der,x,am,ps,n)
      include 'params.cmn'
      dimension der(n),x(3),am(*),ps(mxw21,3)
      im=0
      do 2000i=1,n
        deri=der(i)
        if(deri.eq.0.) then
          im=im+i
          go to 2000
        endif
        do 1000j=1,i
          im=im+1
          derj=der(j)
          if(derj.eq.0) go to 1000
          am(im)=am(im)+deri*derj
1000    continue
        do 1500j=1,3
          ps(i,j)=ps(i,j)+deri*x(j)
1500    continue
2000  continue
      return
      end
      subroutine deflim
      include 'params.cmn'
      include 'basic.cmn'
      include 'fourier.cmn'
      dimension ias(3,mxsym),bs(3,mxsym)
      logical eqiv,eqrv
      do 2000isw=1,ncomp
        n=1
        do 1300i=1,ns
          k=0
          do 1200j=1,3
            j2=j+3*mod(j,3)
            j3=j+3*mod(j+1,3)
            if(rm(k+j,i,isw).eq.0..or.abs(rm(j2,i,isw)).gt..01.or.
     1         abs(rm(j3,i,isw)).gt..01) go to 1300
            ias(j,n)=nint(rm(k+j,i,isw))
            bs(j,n)=s6(j,i,isw)
            k=k+3
1200      continue
          do 1250j=1,n-1
            if(eqiv(ias(1,n),ias(1,j),3).and.
     1         eqrv(bs(1,n),bs(1,j),3,.0001)) go to 1300
1250      continue
          n=n+1
1300    continue
        n=n-1
        if(ncs.eq.1) call nascs(ias,bs,n)
        call nascen(ias,bs,isw,n,m)
        call setlim(ias,bs,m,isw,1)
        do 1500i=1,n
          do 1400j=1,3
            bs(j,i)=0.
1400      continue
1500    continue
        if(ncs.eq.2) call nascs(ias,bs,n)
        call nascen(ias,bs,isw,n,m)
        call setlim(ias,bs,m,isw,2)
2000  continue
      return
      end
      subroutine nascs(ias,bs,n)
      include 'params.cmn'
      include 'basic.cmn'
      dimension ias(3,mxsym),bs(3,mxsym),p(6)
      logical eqiv,eqrv
      data p/6*0./
      m=n+1
      do 2000i=1,n
        do 1000j=1,3
          ias(j,m)=-ias(j,i)
          p(j)=1.-bs(j,i)
1000    continue
        call od0do1(p,p,3)
        do 1500j=1,m-1
          if(eqiv(ias(1,m),ias(1,j),3).and.
     1       eqrv(p,bs(1,j),3,.0001)) go to 2000
1500    continue
        do 1600j=1,3
          bs(j,m)=p(j)
1600    continue
        m=m+1
2000  continue
      n=m-1
      return
      end
      subroutine nascen(ias,bs,isw,n,m)
      include 'params.cmn'
      include 'basic.cmn'
      dimension ias(3,mxsym),bs(3,mxsym),p(6)
      logical eqiv,eqrv
      data p/6*0./
      m=n+1
      do 3000i=2,nvt
        do 2000j=1,n
          do 1000k=1,3
            ias(k,m)=ias(k,j)
            p(k)=bs(k,j)+vt6(k,i,isw)
1000      continue
          call od0do1(p,p,3)
          do 1500k=1,m-1
            if(eqiv(ias(1,m),ias(1,k),3).and.
     1         eqrv(p,bs(1,k),3,.0001)) go to 2000
1500      continue
          do 1600k=1,3
            bs(k,m)=p(k)
1600      continue
          m=m+1
2000    continue
3000  continue
      m=m-1
      return
      end
      subroutine setlim(ias,bs,m,isw,klic)
      include 'params.cmn'
      include 'basic.cmn'
      include 'fourier.cmn'
      dimension ias(3,mxsym),bs(3,mxsym),idal(mxsym)
      do 1000i=1,m
        idal(i)=0
1000  continue
      dx=9999.
      do 3000i=1,3
        n1=0
        do 2000j=1,m
          if(iabs(ias(i,j)).ne.1.or.bs(i,j).ne.0.) go to 2000
          n1=n1+1
2000    continue
        pom=float(n1)*cell(i,isw)/(float(m)*ptstep)
        if(pom.lt.dx) then
          dx=pom
          ismer=i
        endif
3000  continue
      nop(klic,isw)=231
      if(ismer.eq.2) nop(klic,isw)=312
      if(ismer.eq.3) nop(klic,isw)=123
      if(ndim.gt.3) then
        nd=ndimi
        i=10**nd
        nop(klic,isw)=nop(klic,isw)*i+ifix(float(i)*.456)
        do 3500i=4,ndim
          fourmn(i,klic,isw)=0.
          fourmx(i,klic,isw)=1.
3500    continue
      endif
      do 5000i=ismer,ismer+2
        k=mod(i-1,3)+1
        n1=0
        n2=0
        bsmin=9999.
        do 4300j=1,m
          if(idal(j).ne.0) go to 4300
          n2=n2+1
          if(ias(k,j).ne.1) go to 4100
          if(bs(k,j).ne.0.) go to 4200
          n1=n1+1
          go to 4300
4100      bsmin=min(bsmin,bs(k,j))
4200      idal(j)=1
4300    continue
        if(bsmin.gt.10.) bsmin=0.
        fourmn(k,klic,isw)=bsmin*.5
        fourmx(k,klic,isw)=fourmn(k,klic,isw)+float(n1)/float(n2)
5000  continue
      return
      end
      subroutine DefaultFourier
      include 'params.cmn'
      include 'basic.cmn'
      include 'atoms.cmn'
      include 'fourier.cmn'
      NactiInt=20
      NactiReal=20
      NactiComposed=12
      NactiKeys=NactiInt+NactiReal+NactiComposed
      do 1000i=1,NactiInt
        NacetlInt(i)=DefIntFourier(i)
        DefaultInt(i)=DefIntFourier(i)
1000  continue
      do 1100i=NactiInt+1,NactiInt+NactiReal
        NacetlReal(i)=DefRealFourier(i)
        DefaultReal(i)=DefIntFourier(i)
1100  continue
      do 1200i=1,NactiKeys
        NactiKeywords(i)=IdFourier(i)
1200  continue
      kharm=DefIntFourier(1)
      ncollar=DefIntFourier(2)
      mapa=DefIntFourier(3)
      noo(1)=DefIntFourier(4)
      noo(2)=DefIntFourier(4)
      npeaks(1)=DefIntFourier(5)
      npeaks(2)=DefIntFourier(6)
      lcalc=DefIntFourier(7)
      lpeaks=DefIntFourier(8)
      nsubs=DefIntFourier(9)
      metoda=DefIntFourier(10)
      snlmn=DefRealFourier(21)
      snlmx=DefRealFourier(22)
      vyber=DefRealFourier(23)
      ptstep=DefRealFourier(24)
      to=DefRealFourier(25)
      dmax=DefRealFourier(27)
      ptname='[nic]'
      ptx(1)=0.
      ptx(2)=0.
      ptx(3)=0.
      pts(1)=.5
      pts(2)=.5
      pts(3)=.5
      Format80=' '
      return
      end
      subroutine SetCommandsFourier
      include 'params.cmn'
      include 'basic.cmn'
      include 'atoms.cmn'
      include 'fourier.cmn'
      include 'fepc.cmn'
      character*17 Men(5)
      character*80 t80
      integer FeMenu
      logical Prvne
      data Men/'%Basic commands','%Type of the map','%Scope of the map',
     1         'Map %orientation','%Peaks commands'/
      call RewriteTitle('JANA98','FOURIER-commands')
      call DefaultFourier
      open(m50,file=fln(1:ifln)//'.m50')
      open(lst,file=CmdFileName(1:LCmdFileName))
      call iom50(0,0)
      if(ErrJana.ne.0) return
      call najdi('fourier',i)
      noo(1)=-333
      do 1000j=1,6
        xrmn(j,1)=-333.
1000  continue
      if(i.eq.1) call NactiFourier
      if(ptname.eq.'[neco]') then
        write(ptname,101) ptx
        call ZdrcniCisla(ptname,3)
      endif
      call MakeStarFile('fourier')
      close(m50)
      close(lst)
      open(m40,file=fln(1:ifln)//'.m40')
      call iom40(0,0)
      close(m40)
      call MakeIts(its)
      call FeButtonOff(1)
      call FeButtonOff(7)
      Prvne=.true.
1100  if(Prvne) then
        EventNumber=7
        EventType=1
      else
        call FeEvent(0)
      endif
1110  if(EventType.ne.1.or.EventNumber.gt.9) go to 1100
      Prvne=.true.
      if(EventNumber.eq.1) then
        call FeButtonOn(1)
        call WriteKeys('fourier')
        if(its.eq.1.or.its.eq.3) then
          ip=4
        else
          ip=1
        endif
        do 2000i=ip,ndim
          if(xrmn(i,1).gt.-300.) then
            write(t80,101) xrmn(i,1),xrmx(i,1),dd(i,1)
            call ZdrcniCisla(t80,3)
          else
            t80='0 1 0.1'
          endif
          if(i.gt.3.and.t80.eq.'0 1 0.1') go to 2000
          if(ndim.eq.3) then
            t80=NactiKeywords(40+i)(1:4)//' '//t80(1:idel(t80))
          else
            t80=NactiKeywords(43+i)(1:5)//' '//t80(1:idel(t80))
          endif
          write(55,FormA1)(t80(j:j),j=1,idel(t80))
2000    continue
        if(its.eq.3) then
          write(55,'(''center '',60a1)')(ptname(i:i),i=1,idel(ptname))
          write(t80,101) pts
          call ZdrcniCisla(t80,101)
          t80=NactiKeywords(51)(1:5)//' '//t80(1:idel(t80))
          write(55,FormA1)(t80(j:j),j=1,idel(t80))
        endif
        if(Format80.ne.' ') write(55,'(''format '',60a1)')
     1                                (Format80(i:i),i=1,idel(Format80))
        call MergeFileToM50('star')
        write(55,'(''end'')')
        call DopisKeys('fourier',0)
        call RewriteTitle('FOURIER-commands','JANA98')
        return
      else if(EventNumber.eq.7) then
        call FeButtonOn(7)
        i=FeMenu(-1.,-1.,men,1,5,1,0)
        if(i.ge.1.and.i.le.5) call RightButAc('disable')
        if(i.eq.1) then
          call BasicCommandsF
        else if(i.eq.2) then
          call ReadMapType
        else if(i.eq.3) then
          call ReadScope(its)
        else if(i.eq.4) then
          call ReadOrientation
        else if(i.eq.5) then
          call PeaksCommands
        else
          if(EventNumber.eq.1.and.EventType.eq.1) then
            go to 1110
          else
            call FeButtonOff(7)
            Prvne=.false.
            go to 1100
          endif
        endif
      endif
      call RightButAc('refresh')
      go to 1100
101   format(3f10.6)
      end
      subroutine BasicCommandsF
      include 'params.cmn'
      include 'basic.cmn'
      include 'fourier.cmn'
      include 'fepc.cmn'
      i=8
      if(itwin.gt.1) i=i+3
      if(ncomp.gt.1) i=i+2
      call FeQuestCreate(1,-1.,-1.,220.,0,i,'Basic commands',0)
      call FeQuestEdwMake(1,5.,1,30.,1,'%Title','L',185.,8.,0)
      call FeQuestEdwOpen(1,i,Title,pom,0)
      call FeQuestLabelMake(1,110.,2,'Perform','C')
      call FeQuestCrwMake(1,20.,3,5.,3,'%Fourier summation','L',6.,6.,
     1                    0,0)
      call FeQuestCrwOpen(1,NacetlInt(7).eq.1)
      call FeQuestCrwMake(1,130.,3,115.,3,'%Peak interpretation','L',
     1                    6.,6.,0,0)
      call FeQuestCrwOpen(2,NacetlInt(8).eq.1)
      call FeQuestLineMake(1,4)
      call FeQuestLabelMake(1,5.,5,'sin(th)/lambda','L')
      call FeQuestEdwMake(1,70.,5,85.,5,'mi%n.','L',50.,8.,0)
      call FeQuestEdwMake(1,150.,5,165.,5,'ma%x.','L',50.,8.,0)
      do 1110i=2,3
        call FeQuestEdwOpen(i,il,Title,NacetlReal(i+19),1)
1110  continue
      call FeQuestCrwMake(1,5.,6,112.,6,'%Omit not-matching '//
     1                    'reflections','L',6.,6.,1,0)
      call FeQuestCrwOpen(3,NacetlReal(23).gt.0.)
      call FeQuestEdwMake(1,5.,7,90.,7,'%Reflections with F(obs)>',
     1                    'L',30.,8.,0)
      if(CrwLogic(CrwFr+2))
     1  call FeQuestEdwOpen(4,i,Title,NacetlReal(23),1)
      call FeQuestLabelMake(1,125.,7,'*F(calc) will be omitted','L')
      call FeQuestCrwMake(1,5.,8,75.,8,'Formatted input M%80','L',6.,
     1                    6.,1,0)
      call FeQuestCrwOpen(4,Format80.ne.' ')
      call FeQuestEdwMake(1,90.,8,115.,8,'For%mat','L',100.,8.,0)
      if(CrwLogic(CrwFr+3)) call FeQuestEdwOpen(5,0,Format80,0.,0)
      if(itwin.gt.1) then
        call FeQuestLineMake(1,9)
        call FeQuestLabelMake(1,110.,10,'Correction of F(obs) for '//
     1                        'twinning','C')
        call FeQuestCrwMake(1, 20.,11,  5.,11,'%Difference','L',8.,8.,0,
     1                      1)
        call FeQuestCrwMake(1,130.,11,115.,11,'Fr%action','L',8.,8.,0,1)
        call FeQuestCrwOpen(5,NacetlInt(10).eq.0)
        call FeQuestCrwOpen(6,NacetlInt(10).ne.0)
        il=12
      else
        il=9
      endif
      if(ncomp.gt.1) then
        call FeQuestLineMake(1,il)
        il=il+1
        call FeQuestEdwMake(1,5.,il,90.,il,'%Composite part no.','L',
     1                      30.,8.,0)
        call FeQuestEdwOpen(6,NacetlInt(9),Title,pom,-1)
      endif
      icont=0
2500  call FeQuestEvent(1,icont,ich)
      icont=1
      if(CheckType.eq.3.and.CheckNumber.eq.3) then
        EventType=2
        if(CrwLogic(CrwFr+2)) then
          call FeQuestEdwOpen(4,i,Title,NacetlReal(23),1)
          EventNumber=4
        else
          call FeQuestEdwClose(4)
          EventNumber=1
        endif
        go to 2500
      else if(CheckType.eq.3.and.CheckNumber.eq.4) then
        EventType=2
        if(CrwLogic(CrwFr+3)) then
          call FeQuestEdwOpen(5,0,'(i3,2i4,f7.0,f6.0)',0.,0)
          EventNumber=5
        else
          call FeQuestEdwClose(5)
          EventNumber=1
        endif
        go to 2500
      else if(CheckType.ne.0) then
        call NebylOsetren
        go to 2500
      endif
      if(ich.eq.0) then
        do 1200i=1,2
          if(CrwLogic(i+CrwFr-1)) then
            NacetlInt(i+6)=1
          else
            NacetlInt(i+6)=0
          endif
1200    continue
        call FeQuestGetFromEdw(1,i,Title,pom,CrwLogic)
        do 1210i=2,3
          call FeQuestGetFromEdw(i,il,Title,NacetlReal(i+19),CrwLogic)
1210    continue
        if(CrwLogic(CrwFr+2)) call FeQuestGetFromEdw(4,il,Title,
     1                                       NacetlReal(23),CrwLogic)
        if(CrwLogic(CrwFr+3)) then
          Format80=EdwString(EdwFr+4)
        else
          Format80=' '
        endif
        if(itwin.gt.1) then
          if(CrwLogic(CrwFr+4)) then
            NacetlInt(10)=0
          else
            NacetlInt(10)=1
          endif
        endif
        if(ncomp.gt.1) call FeQuestGetFromEdw(6,NacetlInt(9),Title,pom,
     1                                        CrwLogic)
      endif
      call FeQuestRemove(1)
      return
      end
      subroutine ReadMapType
      include 'params.cmn'
      include 'basic.cmn'
      include 'atoms.cmn'
      include 'fourier.cmn'
      include 'fepc.cmn'
      character*43 MapType(9)
      data MapType/'F(obs)**2 - Patterson',
     1             'F(calc)**2 - checking Patterson',
     2             'F(obs)**2-F(calc)**2 - difference Patterson',
     3             'F(obs) - Fourier',
     4             'F(calc) - checking Fourier',
     5             'F(obs)-F(calc) - difference Fourier',
     6             'F(obs)**2*F(calc) - alpha synthesis',
     7             'F(obs)**2/F(calc) - beta synthesis',
     8             '0/1 - shape function'/
      call FeQuestCreate(1,-1.,-1.,180.,0,11,'Type of the map',0)
      do 1000i=1,9
        call FeQuestCrwMake(1,20.,i,5.,i,MapType(i),'L',8.,8.,1,1)
        call FeQuestCrwOpen(i,i.eq.NacetlInt(3))
1000  continue
      if(lite.eq.0) then
        TextInfo(1)='U(iso)'
        ip=25
      else
        TextInfo(1)='B(iso)'
        ip=26
      endif
      call FeQuestLineMake(1,10)
      call FeQuestEdwMake(1,5.,11,30.,11,TextInfo(1),'L',30.,8.,0)
      call FeQuestLabelMake(1,65.,11,'used to sharpen Patterson map',
     1                      'L')
      icont=0
      CheckNumber=NacetlInt(3)
1500  if(CheckNumber.le.3) then
        if(EdwState(EdwFr).ne.0) call FeQuestEdwOpen(1,i,Title,
     1                                           NacetlReal(ip),1)
        Patterson=.true.
      else
        if(EdwState(EdwFr).eq.1) then
          call FeQuestEdwClose(1)
          do 1510i=25,26
            NacetlReal(i)=0.
1510      continue
        endif
        Patterson=.false.
      endif
      call FeQuestEvent(1,icont,ich)
      icont=1
      if(CheckType.eq.3) then
        EventType=2
        EventNumber=1
        go to 1500
      else if(CheckType.ne.0) then
        call NebylOsetren
        go to 1500
      endif
      if(ich.eq.0) then
        do 1600i=1,9
          if(CrwLogic(i+CrwFr-1)) then
            NacetlInt(3)=i
            go to 1610
          endif
1600    continue
1610    if(Patterson) call FeQuestGetFromEdw(1,i,Title,NacetlReal(ip),
     1                                       CrwLogic)
      endif
9999  call FeQuestRemove(1)
      return
      end
      subroutine ReadScope(its)
      include 'params.cmn'
      include 'basic.cmn'
      include 'fourier.cmn'
      include 'fepc.cmn'
      character*80 t80
      equivalence (t80,TextInfo)
      nd3p1=ndim*3+1
      call MakeIts(its)
      call FeQuestCreate(1,-1.,-1.,215.,0,5+ndim,'Scope of the map',0)
      xpom=35.833
      do 1000i=1,3
        if(i.eq.1) then
          t80='%Independent'
        else if(i.eq.2) then
          t80='%Explicitely'
        else
          t80='Central %point'
        endif
        call FeQuestCrwMake(1,xpom,1,xpom-4.,2,t80,'C',8.,8.,1,1)
        call FeQuestCrwOpen(i,i.eq.its)
        xpom=xpom+71.667
1000  continue
      iw=0
      do 1100i=1,ndim
        if(ndim.eq.3) then
          call FeQuestLabelMake(1,17.5,i+3,smbx(i),'C')
        else
          call FeQuestLabelMake(1,17.5,i+3,smbx6(i),'C')
        endif
        xpom=35.
        do 1050j=1,3
          if(i.eq.1) then
            if(j.eq.1) then
              t80='minimum'
            else if(j.eq.2) then
              t80='maximum'
            else
              t80='step'
            endif
          else
            t80=' '
          endif
          call FeQuestEdwMake(1,xpom+27.5,3,xpom,i+3,t80,'C',55.,
     1                        8.,0)
          xpom=xpom+60.
1050    continue
1100  continue
      il=ndim+4
      call FeQuestEdwMake(1,5.,il,35.,il,'%Center','L',70.,8.,1)
      call FeQuestEdwMake(1,117.,il,155.,il,'Sc%ope [A]','L',55.,
     1                    8.,0)
      il=il+1
      call FeQuestCrwMake(1,5.,il,45.,il,'%Add border','L',6.,6.,0,0)
      call FeQuestEdwMake(1,120.,il,155.,il,'%Step [A]','L',55.,8.,0)
      icont=0
1400  iw=0
      do 1460i=1,ndim
        do 1450j=1,3
          iw=iw+1
          if((its.eq.2.or.i.gt.3).and.EdwState(iw+EdwFr-1).ne.1) then
            if(j.eq.1) then
              if(xrmn(i,1).lt.-330.) then
                pom=0.
              else
                pom=xrmn(i,1)
              endif
            else if(j.eq.2) then
              if(xrmn(i,1).lt.-330.) then
                pom=1.
              else
                pom=xrmx(i,1)
              endif
            else
              if(xrmn(i,1).lt.-330.) then
                if(i.le.3) then
                  if(cell(i,1).gt.20.) then
                    pom=0.01
                  else if(cell(i,1).gt.10.) then
                    pom=0.02
                  else
                    pom=0.05
                  endif
                else
                   pom=0.1
                endif
              else
                pom=dd(i,1)
              endif
            endif
            call FeQuestEdwOpen(iw,i,Title,pom,1)
          else if(its.ne.2.and.EdwState(iw+EdwFr-1).eq.1.and.i.le.3)
     1      then
            if(j.eq.1) xrmn(i,1)=-333.
            call FeQuestEdwClose(iw)
          endif
1450    continue
1460  continue
      iw=iw+1
      if(its.eq.3.and.EdwState(iw+EdwFr-1).ne.1) then
        if(ptname.eq.'[nic]') then
          t80=' '
        else
          t80=ptname
        endif
        call FeQuestEdwOpen(iw,i,t80,ptx,0)
        iw=iw+1
        call FeQuestEdwOpen(iw,i,t80,pts,3)
      else if(its.ne.3.and.EdwState(iw+EdwFr-1).eq.1) then
        ptname='[nic]'
        do 1465i=1,3
          ptx(i)=0.
          pts(i)=.5
1465    continue
        do 1466i=iw,iw+1
          call FeQuestEdwClose(i)
1466    continue
      endif
      iw=nd3p1+2
      if((its.eq.1.or.its.eq.3).and.EdwState(iw+EdwFr-1).ne.1) then
        call FeQuestEdwOpen(iw,i,Title,NacetlReal(24),1)
      else if(its.eq.2.and.EdwState(iw+EdwFr-1).eq.1) then
        NacetlReal(24)=DefaultReal(24)
        call FeQuestEdwClose(iw)
      endif
      if(its.eq.1.and.CrwState(EdwFr+3).ne.1) then
        call FeQuestCrwOpen(4,NacetlInt(2).eq.1)
      else if(its.ne.1.and.CrwState(EdwFr+3).eq.1) then
        NacetlInt(2)=DefaultInt(2)
        call FeQuestCrwClose(4)
      endif
1500  call FeQuestEvent(1,icont,ich)
      icont=1
      if(CheckType.eq.3.and.CheckNumber.le.3) then
        its=CheckNumber
        EventType=0
        go to 1400
      else if(CheckType.eq.2.and.CheckNumber.eq.nd3p1) then
        if(EventType.eq.3.and.EventNumber.le.3) go to 1500
        k=0
        do 1510i=1,3
          call kus(EdwString(nd3p1+EdwFr-1),k,cislo)
          if(cislo(1:1).eq.'n') go to 1520
          call posun(cislo,1)
          read(cislo,'(f15.0)',err=1520) EdwReal(i,nd3p1)
1510    continue
        go to 1500
1520    call Uprat(EdwString(nd3p1+EdwFr-1))
        call atsym(EdwString(nd3p1+EdwFr-1),ich,ptx,EdwReal(4,nd3p1),
     1             EdwReal(7,nd3p1),i,j)
        if(ich.le.0) then
          i=nd3p1+EdwFr-1
          call FeChybne(-1.,-1.,'atom '//
     1                  EdwString(i)(:idel(EdwString(i)))//
     2                  ' isn''t on the '//'file M40',' ',0,-1)
          EventType=2
          EventNumber=nd3p1
        endif
        go to 1500
      else if(CheckType.ne.0) then
        call NebylOsetren
        go to 1500
      endif
      if(ich.eq.0) then
        if(CrwLogic(CrwFr+3).and.its.eq.1) then
          NacetlInt(2)=1
        else
          NacetlInt(2)=DefaultInt(2)
        endif
        if(its.eq.1.or.its.eq.3) then
          ip=4
        else
          ip=1
        endif
        iw=(ip-1)*3
        do 1600i=ip,ndim
          do 1590j=1,3
            iw=iw+1
            call FeQuestGetFromEdw(iw,il,Title,pom,CrwLogic)
            if(j.eq.1) then
              xrmn(i,1)=pom
            else if(j.eq.2) then
              xrmx(i,1)=pom
            else
              dd(i,1)=pom
            endif
1590      continue
1600    continue
        if(its.eq.3) then
          call FeQuestGetFromEdw(nd3p1,il,ptname,pom,CrwLogic)
          call FeQuestGetFromEdw(nd3p1+1,il,ptname,pts,CrwLogic)
        else
          ptname='[nic]'
        endif
        if(its.ne.2) call FeQuestGetFromEdw(nd3p1+2,il,ptname,
     1                                      NacetlReal(24),CrwLogic)
      endif
      call FeQuestRemove(1)
      return
      end
      subroutine ReadOrientation
      include 'params.cmn'
      include 'basic.cmn'
      include 'fourier.cmn'
      include 'fepc.cmn'
      character*6 t6
      character*3 t3
      character*2 nty
      logical jeqipi
      dimension ip(6),ipn(6)
      write(t6,101) NacetlInt(4)
      call zhusti(t6)
      call FeQuestCreate(1,-1.,-1.,40.+float(ndim)*15.,0,ndim+3,
     1                   'Map orientation',0)
      call FeQuestCrwMake(1,5.,1,60.,1,'Use default','L',6.,6.,1,0)
      call FeQuestCrwOpen(1,t6(1:1).eq.'-')
      iw=1
      do 1100i=1,ndim
        write(t3,'(i1,a2)') i,nty(i)
        call FeQuestLabelMake(1,20.,i+2,t3//' axis','C')
        xpom=25.
        do 1050j=1,ndim
          iw=iw+1
          xpom=xpom+15.
          if(i.eq.1) then
            if(ndim.eq.3) then
              t3=char(ichar('a')+j-1)
            else
              write(t3,'(''A'',i1)') j
            endif
          else
            t3=' '
          endif
          call FeQuestCrwMake(1,xpom+4.,2,xpom,i+2,t3,'C',8.,8.,1,i)
1050    continue
1100  continue
      call FeQuestEdwMake(1,5.,ndim+3,50.,ndim+3,'Orientation','L',30.,
     1                    8.,1)
      icont=0
      if(t6(1:1).ne.'-') then
        call FeQuestEdwOpen(1,i,t6,xpom,0)
      else
        go to 1500
      endif
1200  iw=1
      read(t6,100)(ip(i),i=1,ndim)
      do 1250i=1,ndim
        do 1240j=1,ndim
          iw=iw+1
          do 1210k=1,i-1
            if(ip(k).eq.j) then
              if(CrwState(iw+CrwFr-1).ne.-2) call FeQuestCrwClose(iw)
              go to 1240
            endif
1210      continue
          jeqipi=j.eq.ip(i)
          if( CrwState(iw+CrwFr-1).eq.-2.or.
     1       (CrwState(iw+CrwFr-1).eq. 1.and..not.jeqipi).or.
     2       (CrwState(iw+CrwFr-1).eq.-1.and.jeqipi))
     3        call FeQuestCrwOpen(iw,jeqipi)
1240    continue
1250  continue
1500  call FeQuestEvent(1,icont,ich)
      icont=1
      if(CheckType.eq.3.and.CheckNumber.le.1) then
        if(CrwLogic(CrwFr)) then
          do 1502i=2,ndimq+1
            if(CrwState(i+CrwFr-1).ne.-2) call FeQuestCrwClose(i)
1502      continue
          call FeQuestEdwClose(1)
          t6='-333'
          EventType=0
          EventNumber=0
        else
          do 1505i=1,ndim
            ip(i)=i
1505      continue
          write(t6,100)(ip(i),i=1,ndim)
          call FeQuestEdwOpen(1,i,t6,xpom,0)
          EventType=2
          EventNumber=1
          go to 1200
        endif
        go to 1500
      else if(CheckType.eq.3.and.CheckNumber.ge.2) then
        i=(CheckNumber-2)/ndim+1
        j=mod(CheckNumber-2,ndim)+1
        ipp=ip(i)
        ip(i)=j
        do 1510k=i+1,ndim
          if(ip(k).eq.j) then
            ip(k)=ipp
            go to 1512
          endif
1510    continue
1512    write(t6,100)(ip(i),i=1,ndim)
        call FeQuestEdwOpen(1,i,t6,xpom,0)
        EventType=2
        EventNumber=1
        go to 1200
      else if(CheckType.eq.2) then
        if(EdwString(EdwFr).eq.t6) go to 1500
        if(idel(EdwString(EdwFr)).ne.ndim) go to 1550
        read(EdwString(EdwFr),100,err=1550)(ipn(i),i=1,ndim)
        do 1520i=1,ndim
          if(ipn(i).lt.1.or.ipn(i).gt.ndim) go to 1550
          do 1515j=i+1,ndim
            if(ipn(i).eq.ipn(j)) go to 1550
1515      continue
1520    continue
        do 1530i=1,ndim
          ip(i)=ipn(i)
1530    continue
        t6=EdwString(EdwFr)
        go to 1200
1550    call FeChybne(-1.,30.,'Incorrect orientation, try again',' ',0,
     1                -1)
        EventType=2
        EventNumber=1
        go to 1500
      else if(CheckType.ne.0) then
        call NebylOsetren
        go to 1500
      endif
      if(ich.eq.0) then
        call posun(t6,0)
        read(t6,101) NacetlInt(4)
      endif
      call FeQuestRemove(1)
      return
100   format(6i1)
101   format(i6)
      end
      subroutine MakeIts(its)
      include 'params.cmn'
      include 'basic.cmn'
      include 'fourier.cmn'
      if(ptname.ne.'[nic]') then
        its=3
      else
        its=2
        do 3600i=1,3
          if(xrmn(i,1).lt.-330.) then
            its=1
            go to 3610
          endif
3600    continue
      endif
3610  return
      end
      subroutine PeaksCommands
      include 'params.cmn'
      include 'basic.cmn'
      include 'fourier.cmn'
      include 'fepc.cmn'
      i=4
      if(ndim.gt.3) i=i+4
      call FeQuestCreate(1,-1.,-1.,160.,0,i,'Peaks commands',0)
      call FeQuestLabelMake(1,75.,1,'Maximum number of peaks','C')
      call FeQuestCrwMake(1, 40.,2, 36.,3,'%Default','C',8.,8.,1,1)
      call FeQuestCrwOpen(1,NacetlInt(5).lt.0.and.NacetlInt(6).lt.0)
      call FeQuestCrwMake(1,120.,2,116.,3,'%Explicitely','C',8.,8.,1,1)
      call FeQuestCrwOpen(2,NacetlInt(5).ge.0.or.NacetlInt(6).ge.0)
      call FeQuestEdwMake(1, 5.,4, 40.,4,'%Positive','L',35.,8.,0)
      call FeQuestEdwMake(1,85.,4,120.,4,'%Negative','L',35.,8.,0)
      if(ndim.gt.3) then
        call FeQuestLineMake(1,5)
        call FeQuestLabelMake(1,75.,6,'Interpretation of diplacement '//
     1                        'waves','C')
        call FeQuestEdwMake(1,5.,7,80.,7,'No. of %harmonics','L',25.,8.,
     1                      0)
        call FeQuestEdwOpen(3,NacetlInt(1),' ',pom,-1)
        call FeQuestEdwMake(1,5.,8,80.,8,'Maximal displacement','L',35.,
     1                      8.,0)
        call FeQuestEdwOpen(4,i,' ',NacetlReal(27),1)
      endif
      if(NacetlInt(5).ge.0.or.NacetlInt(6).ge.0) then
        do 1400i=1,2
          if(NacetlInt(i+4).gt.0) then
            j=NacetlInt(i+4)
          else
            if(i.eq.1) then
              j=50
            else
              j=5
            endif
            NacetlInt(i+4)=j
          endif
          call FeQuestEdwOpen(i,j,' ',pom,-1)
1400    continue
      endif
      icont=0
1500  call FeQuestEvent(1,icont,ich)
      icont=1
      if(CheckType.eq.3) then
        if(CrwLogic(CrwFr+1)) then
          call FeQuestEdwOpen(1,50,' ',pom,-1)
          call FeQuestEdwOpen(2, 5,' ',pom,-1)
          EventType=2
          EventNumber=1
        else
          do 1510i=1,2
            call FeQuestEdwClose(i)
1510      continue
          EventType=0
        endif
        go to 1500
      else if(CheckType.ne.0) then
        call NebylOsetren
        go to 1500
      endif
      if(ich.eq.0) then
        if(CrwLogic(CrwFr)) then
          do 2000i=5,6
            NacetlInt(i)=-333
2000      continue
        else
          do 2100i=1,2
            call FeQuestGetFromEdw(i,NacetlInt(i+4),ptname,pom,CrwLogic)
2100      continue
        endif
        if(ndim.gt.3) then
          call FeQuestGetFromEdw(3,NacetlInt(1),ptname,pom,CrwLogic)
          call FeQuestGetFromEdw(4,i,ptname,NacetlReal(27),CrwLogic)
        endif
      endif
      call FeQuestRemove(1)
      return
      end

